'--- gps2txt.bas ---
'Liest die gps-Datei sequentiell,
'stellt Fahrer-,Team-,Strecken-Daten fr Ausgabe in CSV bereit,
'schreibt nicht zu verndernden Text in Textdateien (z.B: en_part1.txt, ..., en_part8.txt)
'Parameter (vorgesehen):
' 1: infile: GPS-Datei (z.B. "English.gps"
' 2: gps_lng: gps Sprache (0=en,1=de,2=es,3=fr,4=it)
' 3: modus: (0,1,2: 0=Nur Textdateien erstellen, 1=Text und CSV, 2=Nur CSV 
' 4: kmh_select: (0=mph, 1=kmh bzw. km/h) bestimmt, welche Zahl fr Kurvengeschw. gewhlt wird 

'-- Deklarationen --
Dim Shared As String path 
path="D:\GPaedia\2010\Gpaedia 2010 English_jcaranti\"

Dim Shared gps_file(4) As String
gps_file(0)= "GP2001_English.gps"
gps_file(1)= "GP2001_Deutsch.gps"
gps_file(2)= "GP2001_espaol.gps" 
gps_file(3)= "GP2001_Franais.gps" 
gps_file(4)= "GP2001_italiano.gps"
'- Dim As String infile= path + "test.gps" 
Dim As String csvfile, trackinfo
Dim Shared As Single gps_lng=0 , modus=1, kmh_select
'ev. vor Streckeninfo Leerzeile einfgen in de ... 
If gps_lng=0 Then 
	kmh_select=0
Else kmh_select=1
EndIf
Dim As String infile= path + gps_file(gps_lng)
Dim Shared outfile(1 To 8) As String

Const NAK=Chr(21)
Const LF=Chr(10)

Dim Shared As Integer f1,f2,i,k,l,m,n,zl,first
Dim As String felder
Dim Shared As String zeile,puffer,puffer2,pruef,pruef2
Dim Shared As String*4 Year = "2001"
Dim Shared As String*4 LastYear = "2000"

'In den folgenden 3 Tabellen werden die 0-Werte fr Zeilenkopf bzw. Spaltenkopf gebraucht
Dim Shared Drivertab(12,22) As String '22 Fahrer (als Spalten), Zeilen siehe Init
Dim Shared Teamtab(11,11) As String '11 Teams (als Spalten), Zeilen siehe Init
Dim Shared Tracktab(37,17) As String '17 Tracks (als Spalten), Zeilen siehe Init

'In GPaedia werden Fahrer,Team,Strecke in anderer Reihenfolge dargestellt
'Die folgenen Listen stellen die Zuordnung zu der Standardreihenfolge her
Dim Shared GPDriver(1 To 22) As Integer => {1,2,3,4,5,15,6,7,8,20,14,9,11,16,12,17,13,10,18,22,21,19}
Dim Shared GPDriverInfo(1 To 22) As Integer => {3,4,1,2,12,17,5,8,7,11,15,18,13,9,6,16,14,19,10,21,20,22}
Dim Shared GPTeam(1 To 11) As Integer => {2,1,6,9,3,4,11,8,7,10,5}
Dim Shared GPTrack(1 To 17) As Integer => {1,3,4,11,5,9,7,8,10,6,12,13,14,15,16,17,2}

'Sprachspezifische Felder, die Wrter werden mit Prozedur InitLng per READ eingelesen
'Felder fr Trackrecords
Dim Shared language(4) As String
Dim Shared qualifying_lap_record(4) As String
Dim Shared race_lap_record(4) As String
Dim Shared pole_position(4) As String 
Dim Shared fastest_lap(4) As String
Dim Shared race_winner(4) As String
'Felder fr Trackinfo
Dim Shared address(4) As String
Dim Shared gp(4) As String
Dim Shared last_year_results(4) As String
'Dim Shared circuit_qualifying_lap_record(4) As String
'Dim Shared circuit_race_lap_record(4) As String
Dim Shared first_gp(4) As String
Dim Shared nbr_of_gp_held(4) As String
Dim Shared circuit_length(4) As String
Dim Shared gear_word(4) As String
Dim Shared circuit_info(4) As String
'Felder fr Teamdaten:
Dim Shared team_principal(4) As String
Dim Shared team_director(4) As String
Dim Shared team_nationality(4) As String
Dim Shared team_base(4) As String
Dim Shared nbr_of_years_in_f1(4) As String
Dim Shared nbr_of_wins(4) As String
Dim Shared nbr_of_driver_titles(4) As String
Dim Shared nbr_of_constructor_titles(4) As String
'Felder fr Fahrerdaten
Dim Shared team_of_driver(4) As String
Dim Shared date_of_birth(4) As String
Dim Shared nationality(4) As String
Dim Shared residence(4) As String
Dim Shared grand_prix_starts(4) As String
Dim Shared points_scored(4) As String
Dim Shared best_result(4) As String
Dim Shared best_qualifying(4) As String
Dim Shared drivers_first_gp(4) As String
Dim Shared last_year_championship_pos(4) As String
Dim Shared previous_teams(4) As String

'Prozeduren und Funktionen
Declare Sub InitLng 'Initialisierung von sprachspezifischen Wrtern
Declare Sub Init 'Initialisierung von Datenfeldern fr CSV
Declare Sub Textout (outfile As String, StartLabel As String, StartOption As Integer, ExitLabel As String, ExitOption As integer) 
 'Zeilen unverndert in Textdatei ausgeben     
Declare Sub GetTrackRecords (track As Integer) 'Strecken-Rekorde pro Strecke einlesen
Declare Sub GetCornerData (track As Integer) 'Kurvendaten pro Strecke einlesen
Declare Sub GetTrackInfo (track As Integer) 'Kurvendaten pro Strecke einlesen
Declare Sub GetTeamData(team As Integer) 'Teamdaten pro Team einlesen 
Declare Sub GetDriverData (driver As Integer) 'Fahrerdaten pro Fahrer einlesen  
  
Declare  SUB  WriteCSV(s() AS  STRING, Datei AS  STRING, TZ AS  STRING, TT As String, conv AS  INTEGER)
                        
Declare Function SubStr(byVal  Liste As  String, byVal  Trenner As  String, ByVal Stelle As  Integer) As  String
Declare Function Replace(ByVal V_Data As String, ByVal V_Expression As String, ByVal V_ReplaceBy As String) As String                                      
Declare Function quote(ByVal chkstr As String) As String
Declare Function GetDigits(ByVal inline As String) As String

'--- Hauptprogramm ---

Print"Reading from file ";quote(infile):Print
Init 'Sub initialisiert Drivertab, Teamtab, Tracktab
InitLng'Initialsiert sprachspezifische Felder

'-- Verarbeitung der gps-Datei --

'Zeilen aus GPS-Datei einlesen
f1=FreeFile
print
Select Case OPEN (infile For Input Encoding("UTF-16") As #f1)
	CASE 0
		Print "File ";quote(infile);" opened for input - ok"
	Case 2
		Print "File ";quote(infile);" not found."
		Close #f1
		GoTo ende
	CASE Else
		Print "Error when opening file ";quote(infile)
		Close #f1
		GoTo ende
END Select

'Pfad + Name fr Ausgabedateien sprachspezifisch:
Print:Print "Init filenames for output:"
For i=1 To 8
	outfile(i)=path+language(gps_lng)+"_"+"part"+str(i)+".txt"
	Print outfile(i)
Next

'-- 1. Teil: Alle Zeilen bis 1. Kennung in 1. Textdatei schreiben
If modus < 2 Then
	Print
	Textout(outfile(1),"",0,"1767 "+NAK,1)
EndIf

'-- 2. Teil: Fahrer\Team Daten in Array Drivertab aufnehmen
If modus > 0 Then
	i=0
	Print:Print "Driver (Index, GP-Info-Nr, Name, Team):"
	Do While Not(Eof(f1))
		i=i+1
		Line Input #f1,zeile
		If Eof(f1) Then Print "Driver table not found - EOF":Sleep:End
		pruef=Left(zeile,1)
			If pruef=NAK Then Exit Do 'Zeile nach Driver\Teams oder letzte Zeile erreicht
		If i=1 Then 
			puffer=Mid(zeile,4)
		Else puffer=zeile
		EndIf
		Drivertab(1,i)=SubStr(puffer,"\",1)
		Drivertab(2,i)=SubStr(puffer,"\",2)
		Print i,GPDriverInfo(i),drivertab(1,i) + "," + drivertab(2,i)
		pruef2=Right(zeile,1)
		If pruef2=NAK Then 
			Line Input #f1,zeile
			If Eof(f1) Then Print "End of driver table not found - EOF":Sleep:End
			Exit do
		EndIf
	Loop 
EndIf

'-- 3. Teil: Alle Zeilen bis vor GPaedia - Driver\Teams in 2. Textdatei schreiben   
If modus < 2 Then
	Print
	Textout(outfile(2),"",1,"2163 "+NAK,1)
EndIf	

'-- 4. Teil: Alle Zeilen bis nach GPaedia - Driver\Teams
' und vor Tracks \ Country in 3. Textdatei schreiben   

If modus < 2 Then
	Print
	Textout(outfile(3),"13 "+NAK,1,"1445 "+NAK,1)
EndIf	

'-- 5. Teil: Tracks\Country auslesen
Print:Print "Tracks (Index,GPaedia-Index,Name,Country):"
i=0
Do While Not(Eof(f1))
	Line Input #f1,zeile
	If Eof(f1) Then Print "Track table not found - EOF":Sleep:End
	If Left(zeile,4)="43 "+NAK Then Exit Do 'Zeile nach Track\Country
	i=i+1
	puffer=SubStr(zeile,NAK,2)'rechts und links weglassen
	Tracktab(1,i)=SubStr(puffer," \ ",1) 'Track
	Tracktab(2,i)=SubStr(puffer," \ ",2) 'Country
	Print i, GPTrack(i),Tracktab(1,i) + "," + Tracktab(2,i)
Loop
	
'-- 6. Teil: Alle Zeilen nach Track\Country Trackrecords in 4. Textdatei schreiben   
If modus < 2 Then
	Print
	Textout(outfile(4),"",1,"950 "+NAK,1)
EndIf


'-- 7. Teil: Rekorde der Strecken - Teil 1/2 - auslesen
If modus > 0 Then
	Print:Print"Trackrecords 1-7:"
	For i=1 To 7 'Teil 1 = die ersten 7 Strecken
		GetTrackRecords(i)
	Next
EndIf	

'-- 8. Teil: Corner data auslesen
If modus > 0 Then
	Print:Print"Corner data (TrackNbr,Searchlabel,Header)"
	For i=1 To 17: GetCornerData(i):Next
EndIf

'-- 9. Teil: Rekorde der Strecken - Teil 2/2 - auslesen
If modus > 0 Then
	Print:Print"Trackrecords 8-17:"
	For I=8 To 17:	GetTrackRecords(i): Next
EndIf	

'-- 10. Teil: ab "179 "+NAK incl. bis  "666 "+NAK excl. in 5. Textdatei (gross!)

If modus < 2 Then
	Print
	Textout(outfile(5),"",0,"666 "+NAK,0)
EndIf	
  
'-- 11. Teil: anschlieend "666 "+NAK incl. Streckendaten auslesen, dabei
'          Streckeninfo-Text in Textdatei fr Strecke schreiben
Print:Print "Trackinfo-Daten:"
	 	 
For i=1 To 17
	GetTrackInfo(i)
	
	'Allgemeine Streckeninformationen in Strecken-Textdatei speichern	
	If modus = 0 Then ' ohne Daten, dann vorwrts bis nach 'Streckenlnge:'
		Do While Not Eof(f1)
   		Line Input #f1,zeile
   		If Eof(f1) Then Print "Circuit Length not found - EOF":Sleep:End
   		pruef=circuit_length(gps_lng)
   		If Left(zeile,Len(pruef))=pruef Then Exit Do
		Loop
	EndIf		
	
	puffer=LCase(language(gps_lng)+"_"+TrackTab(1,GPTrack(i))+".txt")
	TrackTab(16,GPTrack(i))= Replace(puffer,"","u") 
	trackinfo = path+puffer
	Textout(trackinfo,circuit_info(gps_lng),1,NAK,0)
Next

'-- 12. Teil (anschlieend ab "685 "+NAK): Teamdaten auslesen
If modus > 0 Then 
	Print:Print"Teamdata:"
	For i=1 To 11:	GetTeamData(i): Next	

'Testausgabe Teams'
Print
Print "Teams (Index,GPaedia-Index,Name,Shortname):"
For i=1 To 11
	Teamtab(1,i)=Drivertab(2,2*i) 'Team name from driver-team
	k=InStr(Teamtab(1,i)," ")
	If k=0 Then ' Team name more than one word
		Teamtab(2,i)=Teamtab(1,i)
	Else Teamtab(2,i)=Left(Teamtab(1,i),k-1) 'Shortname = only first word
	EndIf
	Print i,GPTeam(i),Teamtab(1,i);" / ";teamtab(2,i)
Next

EndIf

'-- 13. Teil (anschlieend ab "696 "+NAK): Fahrerdaten auslesen
'		  vor Driver(15) wird dabei die kurze Textdatei part6.txt ausgegeben 				
If modus > 0 Then
	Print:Print"Driverdata:"
	For i=1 To 22
		GetDriverData(i)
		Print i, GPDriverInfo(i), Drivertab(0,i), Drivertab(4,GPDriverInfo(i))
	Next
EndIf	

'-- 14. Teil (ab "1558 "+NAK incl. bis "540 "+NAK incl.): in 7. Textdatei
If modus < 2 Then
	Print
	Textout(outfile(7),"1558 "+NAK,1,"540 "+NAK,1)
EndIf	

'(Linkdaten: sind hier schon bekannt)

'-- 16. Teil (nach Linkdaten ab "2129 "+NAK bis Ende ("2125 "+NAK) in 8. Textdatei
If modus < 2 Then
	Print
	Textout(outfile(8),"2129 "+NAK,1,"2125 "+NAK,1)
EndIf	

'-- 17. Teil: Ausgaben in CSV-Dateien
If modus > 0 Then
	Print
	
	'csvfile=path+language(gps_lng)+"_driver.csv"
	csvfile=path+"driver.csv"
	WriteCSV (Drivertab(),csvfile,";",Chr(34),0) 'z.B. "d:\gpaedia\en_driver.csv"
	Print"CSV file ";quote(csvfile);" created"
	
	'csvfile=path+language(gps_lng)+"_team.csv"
	csvfile=path+"team.csv"
	WriteCSV (Teamtab(),csvfile,";",Chr(34),0)
	Print"CSV file ";quote(csvfile);" created"
	
	'csvfile=path+language(gps_lng)+"_track.csv"
	csvfile=path+"track.csv"
	WriteCSV (Tracktab(),csvfile,";",Chr(34),0)
	Print"CSV file ";quote(csvfile);" created"
	
EndIf

ende:
Close #f1
Print:Print"--- press any key to quit ---"
Sleep

'--- Daten zum Einlesen ---
Data "en","de","es","fr","it",_ 
"race lap record","Rundenrekord Rennen","Rcord de vuelta de carrera","Record du tour","Record sul giro in gara",_
"qualifying lap record","Rundenrekord Qualifikation","Rcord de vuelta de clasificacin","Record en qualification","Record sul giro in qualifica",_
"pole position","Pole-Position","Pole position","Pole position","Pole position:",_
"fastest lap","Schnellste Runde","Vuelta ms rpida","Meilleur tour en course","Giro pi veloce",_
"race winner","Rennsieger","Ganador","Vainqueur","Vincitore",_
"Address","Anschrift","Direccin","Adresse","Indirizzo",_
"First GP","Erster GP","Primer GP","Premier GP ","Primo GP",_
"Number of GPs held","Stattgefundene GP","Nmero de GP albergados","Nombre de GP courus ","Numero di GP disputati",_
"Circuit Length","Streckenlnge","Longitud de la pista","Longueur du circuit ","Lunghezza circuito",_
"Gear "," Gang","Marcha ","Vitesse  ","Prima,Seconda,Terza,Quarta,Quinta,Sesta,Settima",_
"Circuit Info","Streckeninfo","Informacin sobre el circuito","Caractristiques","Note sul tracciato",_
"Team Principal","Teamleiter","Presidente","Prsident","Presidente",_
"Technical Director","Technischer Direktor","Director tcnico","Directeur technique","Direttore tecnico",_
"Team Nationality","Herkunftsland des Teams","Nacionalidad del equipo","Nationalit de l'curie","Nazionalit scuderia",_
"Team Base","Heimatstandort des Teams","Central del equipo","Sige de l'curie","Sede scuderia",_
"Number of years in F1","Jahre bei der F1","Aos en F1","Nombre de saisons en F1","Numero di anni in F1",_
"Number of wins","Zahl der Siege","Victorias","Nombre de victoires","Numero di vittorie",_
"Number of drivers titles","Zahl der Fahrertitel","Ttulos de los pilotos","Nombre de titres conducteurs","Numero di mondiali piloti",_
"Number of constructors titles","Zahl der Konstrukteurstitel","Ttulos del constructor","Nombre de titres constructeurs","Numero di mondiali costruttori",_
"Team","Team","Equipo","Ecurie ","Scuderia",_
"Date of Birth","Geb.-Datum","Fecha de nacimiento","Date de naissance","Data di nascita",_
"Nationality","Nationalitt","Nacionalidad","Nationalit ","Nazionalit",_
"Residence","Wohnort","Residencia","Pays de rsidence","Residenza",_
"Grand Prix Starts","Gefahrene Rennen","Salidas en el Grand Prix","Dparts de grand prix","Gare disputate",_
"Points Scored","Gewonnene Punkte","Puntos conseguidos","Points marqus","Punti conquistati",_
"Best Result","Bestes Rennergebnis","Mejor resultado","Meilleur rsultat","Miglior risultato",_
"Best Qualifying","Bestes Qualifikationsergebnis","Mejor puesto","Meilleure qualification","Miglior risultato in qualifica",_
"First GP","Erster GP","Primer GP","Premier GP","Primo GP",_
"Previous Teams","Frhere Teams","Equipos anteriores","Ecuries antrieures","Scuderie precedenti"

'Fr csv2gps:
'"Qualifying Lap Record:","Rundenrekord Qualifikation", "Rcord de vuelta de clasificacin:","Record du tour en qualif. :","Record sul giro in qualifica:"
'"Race Lap Record:","Rundenrekord Rennen:","Rcord de vuelta de carrera:","Record du tour en course :","Record sul giro in gara:"
'"Drivers:","Fahrer:","Pilotos:","Pilotes :","Piloti:"
'---------------------------------- Functions and SUBs: ------------------------------------

Function  SubStr(byVal  Liste As  String, byVal  Trenner As  String, byVal  Stelle As  Integer) As  String
  Dim As String ret0	
  Dim As Integer Aktuell=0, Ooops, ltr=Len(Trenner), Vorige=1, Gefunden
  If Stelle=0 Or Liste="" Or Trenner="" Or Instr(Liste, Trenner)=0 Then Return ""
  Do
    Ooops=Gefunden
    Gefunden=Instr(Gefunden+1, Liste, Trenner)
    Aktuell-=Gefunden<>0
    If Aktuell=Stelle-1 Then Vorige=Gefunden+ltr
    If Aktuell=Stelle Then Exit Do
  Loop Until Gefunden=0
  ret0 = Mid(Liste, IIF(Stelle-Aktuell>1, Len(Liste)+1, Ooops+ltr))
  If ret0="" Then ret0 = ret0 &Chr(0)
  If Stelle>Aktuell Then 
  	Return ret0
  Else  
  	Return Mid(Liste, Vorige, Gefunden-Vorige)
  EndIf
  
End Function

'Original-Code von ytwinky (Jrg Zhlke), Quelle: 
'http://www.freebasic-portal.de/code-beispiele/string-funktionen/substr-fast-ein-splitstring-81.htm
'Korrigiert P.Hagemann 04/2012 (Fehler: chr(0) am Ende des letzten Teils der Liste)

Function quote(ByVal chckstr As String) As String
Dim chkstr As string

	chkstr = Chr(34)+chckstr+Chr(34)
	Return chkstr
	
End Function

Function Replace(ByVal V_Data As String, ByVal V_Expression As String, ByVal V_ReplaceBy As String) As String
Dim X As Long
Dim SL As Long
Dim D as String
D = V_Data
SL = Len(V_Expression)
X = 0
Do
    X = X + 1
    If X > Len(D) - SL + 1 Then Exit Do
    If Mid(D, X, SL) = V_Expression Then
        D = Mid(D, 1, X - 1) & V_ReplaceBy & Mid(D, X + SL)
        X = X - (SL  - 1)
        If X < 0 then X = 0
    End If
Loop
'Print"Replaced ";quote(V_Expression);" in ";quote(V_Data);", result: ";quote(D)
Return D
End Function
'Quelle: http://www.freebasic-portal.de/code-beispiele/string-funktionen/sehr-schnelle-replace-funktion-91.html
SUB WriteCSV(s() AS STRING, Datei AS STRING, TZ AS STRING, TT As String, conv AS INTEGER)
' Erzeugt aus dem Array s(0, 0) bis s(m, n) eine CSV-Datei (Excel-Tabelle aus
' den Zeilen 0 bis m und den Spalten 0 bis n).
' - TZ = Trennzeichen (z.B. Komma oder Semikolon, d.h. englisches oder deutsches
'   CSV-Format, oder beliebiges anderes Zeichen)
' - TT = Text-Trennzeichen (z.B. Anfhrungszeichen); damit knnen auch Sonderzeichen
'   in den Felddaten vorkommen, wie z.B. LF (Linefeed) als Zeilenumbruch 
' - conv <> 0: Dezimalpunkte werden in Kommata umgewandelt (nur sinnvoll, wenn
'   das Trennzeichen kein Komma ist und die Daten z.B. keine Datumsangaben
'   enthalten)

  DIM AS INTEGER i, j, k, m, n, f

  m = UBOUND(s, 1)
  n = UBOUND(s, 2)

  'Dezimalpunkte durch Kommata ersetzen:
  IF conv THEN
    FOR i = 0 TO m
      FOR j = 0 TO n
        k = INSTR(s(i, j), ".")
        IF k > 0 THEN MID(s(i, j), k, 1) = ","
      NEXT j
    NEXT i
  END IF

  'Speichern mit Trennzeichen:
  f = FreeFile
   
  OPEN Datei For Output Encoding("UTF-16") As #f
  FOR i = 0 TO m
    FOR j = 0 TO n - 1
      PRINT #f, TT + s(i, j) + TT + TZ;
    NEXT j
    PRINT #f, TT + s(i, n) + TT
  NEXT i
  CLOSE #f

END Sub

'Original-Code von Lothar Schirm, Quelle:
'http://www.freebasic-portal.de/code-beispiele/kleine-helferlein/csv-dateien-erzeugen-lesen-163.html
'Modifiziert (Text-Trennzeichen hinzugefgt) von P.Hagemann

SUB Init
'Initialisiert die Arrays fr die Ausgabe in CSV
'Die erste Spalte wird gefllt mit den Bezeichnern fr die Zeilen	
Dim As integer i,k
Dim As String mph_kmh = "km/h"
Dim As String corner_nr

If kmh_select=0 Then mph_kmh = "mph"

'Eintrge der Spaltennummern
For i=1 To 22
	Drivertab(0,i)=Str(i) 'Number of driver
Next

For i=1 To 11
	Teamtab(0,i)=Str(i)	'Number of team, GPaedia-Team-Nr
Next

For i=1 To 17
	Tracktab(0,i)=Str(i) 'Number of Track
Next

'Eintrge der Zeilen-Bezeichner in die erste Spalte
Drivertab(1,0)="Name"
Drivertab(2,0)="Team"
Drivertab(3,0)="Date of Birth"
Drivertab(4,0)="Nationality"
Drivertab(5,0)="Residence"
Drivertab(6,0)="GP Starts"
Drivertab(7,0)="Points scored"
Drivertab(8,0)="Best Results"
Drivertab(9,0)="Best Qualifying"
Drivertab(10,0)="First GP"
Drivertab(11,0)="Last year champ. pos." 
Drivertab(12,0)="Previous teams"

Teamtab(1,0)="Team"
Teamtab(2,0)="Team (short)"
Teamtab(3,0)="Team Principal"
Teamtab(4,0)="Technical Director"
Teamtab(5,0)="Drivers"
Teamtab(6,0)="Team Nationality"
Teamtab(7,0)="Team Base"
Teamtab(8,0)="Number of years in F1"
Teamtab(9,0)="Number of wins"
Teamtab(10,0)="Number of driver titles"
Teamtab(11,0)="Number of constructor titles"
 	
Tracktab(1,0)="Circuit name"
Tracktab(2,0)="Country"
Tracktab(3,0)="Circuit info name"
Tracktab(4,0)="Address"
Tracktab(5,0)="GP Date"
Tracktab(6,0)="Laps"
Tracktab(7,0)="Qualifying lap record"  'driver,year,team,time
Tracktab(8,0)="Race lap record"  'driver,year,team,time
Tracktab(9,0)="First GP"
Tracktab(10,0)="Numbers of GP held"
Tracktab(11,0)="Circuit length"
Tracktab(12,0)="Last year results" 'Tabelle der ersten (6 oder 8)
Tracktab(13,0)="Pole position"
Tracktab(14,0)="Fastest lap"
Tracktab(15,0)="Race winner"
Tracktab(16,0)="Circuit info textfile"
Tracktab(17,0)="corner data"
For i=18 To 37 ' 20 corner-data
	If Len(Str(i-17))>=2 Then 
		corner_nr = Str(i-17)
	Else corner_nr = "0"+Str(i-17)
	EndIf
	Tracktab(i,0)="corner " + corner_nr + ": name"+LF+"           gear"+LF+"           "+mph_kmh
Next
Print "Init Arrays for CSV-output done"

End Sub

Sub InitLng
'Einlesen der Daten fr sprachspezifische Feldgruppen
Dim As Integer i

Print:Print"Reading language specific data"

For i=0 To 4:Read language(i):Next:Print language(0)
For i=0 To 4:Read race_lap_record(i):Next:'Print race_lap_record (0)
For i=0 To 4:Read qualifying_lap_record(i):Next:'Print qualifying_lap_record(0)
For i=0 To 4:Read pole_position(i):Next:Print pole_position(0)
For i=0 To 4:Read fastest_lap(i):Next:Print fastest_lap(0)
For i=0 To 4:Read race_winner(i):Next:Print race_winner(0)
For i=0 To 4:Read address(i):Next:Print address(0)
gp(0)=Year+" GP:":Print gp(0)
gp(1)="GP "+Year+":"
gp(2)="GP del "+Year+":"
gp(3)="GP "+Year+" :"
gp(4)="GP "+Year+":"
last_year_results(0)=LastYear+" Results":Print last_year_results(0)
last_year_results(1)="Ergebnis "+LastYear
last_year_results(2)="Resultados de "+LastYear
last_year_results(3)="Rsultats "+LastYear
last_year_results(4)="Risultati "+LastYear
For i=0 To 4:Read first_gp(i):Next:Print first_gp(0)
For i=0 To 4:Read nbr_of_gp_held(i):Next:Print nbr_of_gp_held(0)
For i=0 To 4:Read circuit_length(i):Next:Print circuit_length(0)
For i=0 To 4:Read gear_word(i):Next:Print gear_word(0)
For i=0 To 4:Read circuit_info(i):Next:Print circuit_info(0)
'Teamdaten
For i=0 to 4:Read team_principal(i):Next
For i=0 to 4:Read team_director(i):Next
For i=0 To 4:Read team_nationality(i):Next:Print team_nationality(0)
For i=0 To 4:Read team_base(i):Next:Print team_base(0)
For i=0 To 4:Read nbr_of_years_in_f1(i):Next:Print nbr_of_years_in_f1(0)
For i=0 To 4:Read nbr_of_wins(i):Next:Print nbr_of_wins(0)
For i=0 To 4:Read nbr_of_driver_titles(i):Next:Print nbr_of_driver_titles(0) 
For i=0 To 4:Read nbr_of_constructor_titles(i):Next:Print nbr_of_constructor_titles(0)
'Fahrerdaten
For i=0 To 4:Read team_of_driver(i):Next:Print team_of_driver(0)
For i=0 To 4:Read date_of_birth(i):Next:Print date_of_birth(0) 
For i=0 To 4:Read nationality(i):Next:Print nationality(0)
For i=0 To 4:Read residence(i):Next:Print residence(0)
For i=0 To 4:Read grand_prix_starts(i):Next:Print grand_prix_starts(0)  
For i=0 To 4:Read points_scored(i):Next:Print points_scored(0)
For i=0 To 4:Read best_result(i):Next:Print best_result(0)
For i=0 To 4:Read best_qualifying(i):Next:Print best_qualifying(0)
For i=0 To 4:Read drivers_first_gp(i):Next:Print drivers_first_gp(0)
last_year_championship_pos(0)=LastYear+" Championship  Position:":Print last_year_championship_pos(0)
last_year_championship_pos(1)="Platzierung "+LastYear+":"
last_year_championship_pos(2)="Puesto en el campeonato de "+LastYear+":"
last_year_championship_pos(3)="Classement au championnat "+LastYear+" :"
last_year_championship_pos(4)="Posizione nel mondiale "+LastYear+":"
For i=0 To 4:Read previous_teams(i):Next:Print previous_teams(0) 

End Sub
Sub GetTrackRecords (track As integer)
'Daten fr Strecken-Rekorde auslesen	
Dim pruef As String
Dim TrackLabel(17) As String => {"179 "+NAK,"951 "+NAK,"953 "+NAK,"954 "+NAK,"955 "+NAK,_
 "956 "+NAK,"957 "+NAK,"958 "+NAK,"977 "+NAK,"978 "+NAK,"979 "+NAK,"980 "+NAK,"981 "+NAK,_
 "982 "+NAK,"983 "+NAK,"984 "+NAK,"985 "+NAK,"986 "+NAK}
 'Marken pro Track (1-17)
 
i=track	

'Weiterlesen bis zur Marke fr 1. Zeile der Streckendaten
	Do While Not Eof(f1)
		Line Input #f1,zeile
		If Eof(f1) Then Print "Track Records not found - EOF":Sleep:End
	'Print i, quote(zeile)
	'Print i, "Pruef = ";quote(Left(zeile,5))
	'Print i, "Tracklabel =";quote(Tracklabel(i))
	'getkey
		If Left(zeile,5)=TrackLabel(i) Then Exit Do
	Loop
	Print i, quote(zeile)
	
'Achtung: die Reihenfolge von 'qualifying lap record' und 'race lap record'
'ist in den gps-Dateien je nach Sprache verschieden:
'(Englisch: qualifiying lap recor / race lap record, andere: umgekehrte Reihenfolge)	
   pruef=qualifying_lap_record(gps_lng)       
	pruef2=race_lap_record(gps_lng)
	'Print "Qualifying_lap_record:",qualifying_lap_record(gps_lng)
	'Print "Race_lap_record:",race_lap_record(gps_lng)
   puffer2=Trim(Trim(Trim(zeile,Tracklabel(i))," "),":")
      
	If Left(puffer2,Len(pruef)) = pruef Then k=7:l=8 ' qualifying lap record
	If Left(puffer2,Len(pruef2)) = pruef2 Then k=8:l=7 ' race lap record
	'Print"puffer2= ";quote(puffer2)
	'Print"pruef2 = ";quote(pruef2)
	'Print"pruef  = ";quote(pruef)
	'Print"k 6/7  = ";k
	If k<>7 And k<>8 Then 
  		Print "Error Track ";i;"Index ";k;" only k=7 or k=8 possible"
  		GoTo subend
	EndIf
	
'Daten holen (2 Zeilen)   
   Line Input #f1,zeile
   If Eof(f1) Then Print "End Of File":Sleep:End
   'Print"Zeile = ";quote(zeile)
   puffer=zeile
   Line Input #f1,zeile
   If Eof(f1) Then Print "End Of File":Sleep:End
   'Print"Zeile1 = ";quote(puffer)
   'Print "pruef = ";quote(pruef)
   'Print "Pruef2 = ";quote(pruef2)
   Tracktab(k,GPTrack(i))=puffer + LF + zeile 'lap record: driver,year LF team,time
   'Print i,"Tracktab";k;",";GPTrack(i);" = ";quote(tracktab(k,GPTrack(i)))
'Nchste Daten:    	
	Do While Not Eof(f1)
   	Line Input #f1,zeile
   	If Eof(f1) Then Print "End Of File":Sleep:End
   	If puffer2=pruef Then pruef=pruef2 ' qualifying erledigt, dann race
   	'Print i,"zeile= ";quote(zeile)
   	'Print i,"pruef= ";quote(pruef)
   	'Print i,"pruef2= ";quote(pruef2)
   	'Print i,"puffer2= ";quote(puffer2)
   	'GetKey
   	If Left(zeile,Len(pruef))=pruef Then Exit Do
	Loop
   'Print "zeile2 = ";quote(zeile)
   'Print "pruef = ";quote(pruef)
   'Print "Pruef2 = ";quote(pruef2)
  
   Line Input #f1,zeile
   If Eof(f1) Then Print "End Of File":Sleep:End
   puffer=zeile
   Line Input #f1,zeile
   If Eof(f1) Then Print "End Of File":Sleep:End
   Tracktab(l,GPTrack(i))=puffer + LF + zeile 'race lap record driver,year LF team,time
   'Print i,"Tracktab 7,";GPTrack(i);" = ";quote(tracktab(7,GPTrack(i)))

 '-- Daten der Vorsaison
'pole position:   
   Do While Not Eof(f1)
   	Line Input #f1,zeile
   	If Eof(f1) Then Print "pole position not found - EOF":Sleep:End
   	pruef=pole_position(gps_lng)
   	If Left(zeile,Len(pruef))=pruef Then Exit Do
   Loop
   Line Input #f1,zeile
   If Eof(f1) Then Print "End Of File":Sleep:End
   puffer=zeile
   Line Input #f1,zeile
   If Eof(f1) Then Print "End Of File":Sleep:End

   Tracktab(13,GPTrack(i))=puffer + LF + zeile 'pole position driver,team LF time,date
   'Print "puffer = ";puffer
   'Print "zeile = ";zeile
'fastest lap
   Do While Not Eof(f1)
   	Line Input #f1,zeile
   	If Eof(f1) Then Print "fastest lap not found - EOF":Sleep:End
   	pruef=fastest_lap(gps_lng)
   	If Left(zeile,Len(pruef))=pruef Then Exit Do
   Loop
   Line Input #f1,zeile
   If Eof(f1) Then Print "End Of File":Sleep:End
   puffer=zeile
   Line Input #f1,zeile
   If Eof(f1) Then Print "End Of File":Sleep:End
   Tracktab(14,GPTrack(i))=puffer + LF + zeile 'fastest lap driver,team LF time,date
   'Print i,"Pruef = ";quote(pruef)
	'Print i,"fastest lap 1 = ";quote(puffer)
	'Print i,"fastest lap 2 = ";quote(zeile)
	'Print i,"Tracktab 13 = ";Tracktab(13,GPTrack(i))
'race winner
   Do While Not Eof(f1)
   	Line Input #f1,zeile
   	If Eof(f1) Then Print "race winner not found - EOF":Sleep:End
   	pruef=race_winner(gps_lng)
   	If Left(zeile,Len(pruef))=pruef Then Exit Do
   Loop
   Line Input #f1,zeile
   If Eof(f1) Then Print "End Of File":Sleep:End
   Tracktab(15,GPTrack(i))=Trim(zeile,NAK)'race winner driver,team	
	'Print i,"Pruef = ";quote(pruef)
	'Print i,"race winner = ";quote(zeile)
	'Print i,"Tracktab 14 = ";Tracktab(14,GPTrack(i))
subend:	   
End Sub

Sub GetCornerData (track As integer)
'Daten fr Kurvenpunkte der jeweiligen Strecke auslesen	

Dim As Integer ColonPos, trennpos, index_offset = 17, ausgang=0
Dim As String cornerdata, gear, speed, nextdata
Dim TrackLabel(1 To 17) As String => {"960 "+NAK,"961 "+NAK,"962 "+NAK,"963 "+NAK,_
 "964 "+NAK,"965 "+NAK,"966 "+NAK,"967 "+NAK,"968 "+NAK,"969 "+NAK,"970 "+NAK,"971 "+NAK,_
 "972 "+NAK,"973 "+NAK,"974 "+NAK,"975 "+NAK,"976 "+NAK}
 'Marken pro Track (1-17)
	
	Dim it_gear(7) As String 'Prima/Seconda/Terza/Quarta/Quinta/Sesta/Settima
	For l=1 To 7 
		it_gear(l)=SubStr(gear_word(4),",",l)
	Next

	i=track
'Weiterlesen bis zur Marke fr 1. Zeile der Streckendaten
	Do While Not Eof(f1)
		Line Input #f1,zeile
		If Eof(f1) Then Print "Tracklabel ";Tracklabel(i);" not found - EOF":Sleep:End
		If Left(zeile,5)=TrackLabel(i) Then Exit Do
	Loop
'Ausgabe in Log	
	'Print i, quote(zeile)
	Tracktab(index_offset,GPTrack(i))=Trim(zeile,Tracklabel(i))
	Print i, Tracklabel(i);quote(Tracktab(index_offset,GPTrack(i)))
'corner data
	Do 
   	Line Input #f1,zeile
   	If Eof(f1) Then Print "corner data not found - EOF":Sleep:End
   	'Print"zeile = ";quote(zeile)
   	If Trim(zeile," ")="" Then Continue Do	'Zeile leer, dann nchste
   	If Right(zeile,1)= NAK Then 
   		zeile=Trim(zeile,NAK)
   		Ausgang=1							  	' letzte Zeile erreicht
   	EndIf
   	ColonPos=InStr(zeile,":")
	   If ColonPos>0 And ColonPos<5 Then	' Neue Kurve, wenn am Anfang (1-4) Doppelpunkt 
	   	If cornerdata<>"" Then				' Daten vorhanden, dann
	   		'Print"cornerdata ausgabe = ";quote(cornerdata)
	   		Tracktab(k+index_offset,GPTrack(i))=cornerdata ' bernehmen
	   		cornerdata=""						'  und Datenpuffer lschen
	   	EndIf										
	   	k=Val(Left(zeile,ColonPos-1)) ' Kurvennummer = Nr. vor dem Doppelpunkt
	   	If k>20 Then Exit Do
	   	cornerdata=Trim(Mid(zeile,ColonPos+1)," ")
	   	'Print"cornerdata+Kurve = ";quote(cornerdata),"Kurve= ";k,ColonPos 	
	   ElseIf InStr(Trim(zeile," "),"/")>0 Then' mph/kmh-Zeile
	   	puffer=Trim(zeile," ")
	     	If kmh_select=0 Then					' dann mph bzw. kmh je nach language holen 
				speed=Str(Val(puffer))
	     	Else 
	     		trennpos=InStr(puffer,"/")
	     		If trennpos>0 Then 
	     			speed=Str(Val(Mid(puffer,trennpos+1)))
	     		Else 
	     			speed=Str(Val(puffer))
	     		EndIf
	     	EndIf
			cornerdata=cornerdata+LF+speed
	   Else
	   	puffer=Trim(zeile," ")
			If gps_lng<4 Then 				 'Gear-Zeile, dann Gear holen	
				gear=GetDigits(puffer)
				'If gear="0" Then gear=Str(Val(puffer))
			Else l=0
				Do 
					l=l+1 
					If puffer=it_gear(l) Then Exit Do ' Kein gear_word, nur it. Zahl (1-7)
				Loop While l<7
			EndIf	
			cornerdata=cornerdata+LF+gear			 ' in Daten aufnehmen
	   EndIf
	   
	Loop 	While Not Eof(f1) And ausgang=0
	If cornerdata<>"" Then
		'Print"cornerdata ausgabe = ";quote(cornerdata)
		Tracktab(k+index_offset,GPTrack(i))=cornerdata ' bernehmen
	EndIf
	
End Sub

Function GetDigits (ByVal inline As String) As String
' extrahiert Zahlen aus String	
Dim As String number, digits = "0123456789"
Dim chk As String*1
Dim As Integer i,l

l=Len(inline)
For i=1 To l
	chk = Mid(inline,i,1)
	If InStr(digits,chk)>0 Then number = number + chk
Next

'Print "Number = ";quote(number)
Return number	
End Function

Sub GetTrackInfo (track As integer)

Dim TrackLabel(1 To 17) As String => {"666 "+NAK,"667 "+NAK,"668 "+NAK,"671 "+NAK,"672 "+NAK,_
 "673 "+NAK,"674 "+NAK,"675 "+NAK,"676 "+NAK,"677 "+NAK,"678 "+NAK,"679 "+NAK,"680 "+NAK,_
 "681 "+NAK,"682 "+NAK,"683 "+NAK,"684 "+NAK}
'Marken pro Track (1-17)
Dim trackinfo_name As String
 	 	
	i=track
	
	If i=1 Then 
		If modus>0 Then 
			Tracktab(3,GPTrack(i))=Trim(Mid(zeile,6)," ")
			Print i, zeile
		EndIf
	Else'die erste Marke wurde bereits eingelesen
	'Weiterlesen bis zur Marke fr 1. Zeile der Streckendaten
		Do While Not Eof(f1)
			Line Input #f1,zeile
			'If i=12 Then Print i,quote(zeile):getkey	
			If Eof(f1) Then 
				Print quote(Tracklabel(i))+ "not found - EOF",quote(zeile)
				Sleep:End 
			EndIf
			If Left(zeile,5)=TrackLabel(i) Then 
				trackinfo_name=Mid(zeile,6)
				Exit Do
			EndIf		
		Loop	
		
		If modus>0 Then 
			Tracktab(3,GPTrack(i))=Trim(trackinfo_name," ")
			Print i, zeile
		EndIf
		
	EndIf

'Print i,"Tracklabel = ";Tracklabel(i)
'Print i,"Zeile = ";quote(zeile)
If modus=0 Then GoTo subend
	
'Address:
   Do 
   	Line Input #f1,zeile
   	if Eof(f1) Then 
   		If Eof(f1) Then Print "Address not found - EOF":Sleep:End
   		Exit Do
   	EndIf
   	pruef=address(gps_lng)
   	If Left(zeile,Len(pruef))=pruef Then Exit Do
   Loop
   
   'Print i, "Pruef = ";quote(pruef)
   'Print i, "zeile = ";quote(zeile)
   Tracktab(4,GPTrack(i))=Trim(Trim(Trim(zeile,pruef)," "),": ")
   
'Last years GP (Date, Laps):    
   Do While Not Eof(f1)
   	Line Input #f1,zeile
   	If Eof(f1) Then Print "Last years GP not found - EOF":Sleep:End
   	pruef=gp(gps_lng)
   	If Left(zeile,Len(pruef))=pruef Then Exit Do
   Loop

   puffer=Trim(Trim(zeile,pruef)," ")
   l=InStr(puffer,"(")
   TrackTab(5,GPTrack(i))=Trim(Left(puffer,l-1)) ' Datum
   TrackTab(6,GPTrack(i))=Str(Val(Mid(puffer,l+1))) ' Laps
   'Print i, "zeile = ";quote(zeile)
    
 'Last years results' = Tabelle Platz) Fahrer - Team
   Do While Not Eof(f1)
   	Line Input #f1,zeile
   	If Eof(f1) Then Print "Last years results not found - EOF":Sleep:End
   	pruef=last_year_results(gps_lng)
   	If Left(zeile,Len(pruef))=pruef Then Exit Do
   Loop

   puffer=""
   Do 
   	Line Input #f1,zeile
   	If Eof(f1) Then Print "Last years results not found - EOF":Sleep:End
   	If zeile="" Then Exit Do
 		puffer=puffer+zeile+LF
   Loop While Not(Eof(f1))
   If Eof(f1) Then Print "End Of File":Sleep:End
   TrackTab(12,GPTrack(i))=Trim(puffer,LF)
   'Print i, "zeile = ";quote(zeile)
 '(Race Lap Record) bereits erfasst
 '(Qualifying Lap Record) dto.
 
 'First GP:
 	Do While Not Eof(f1)
   	Line Input #f1,zeile
   	If Eof(f1) Then Print "First GP not found - EOF":Sleep:End
   	pruef=first_gp(gps_lng)
   	If Left(zeile,Len(pruef))=pruef Then Exit Do
 	Loop
   Tracktab(9,GPTrack(i))=Trim(Trim(Trim(zeile,pruef)," "),": ")
   'Print i, "zeile = ";quote(zeile) 
'Number of GPs held:
 	 Do While Not Eof(f1)
   	Line Input #f1,zeile
   	If Eof(f1) Then Print "Number of GPs held not found - EOF":Sleep:End
   	pruef=nbr_of_gp_held(gps_lng)
   	If Left(zeile,Len(pruef))=pruef Then Exit Do
 	 Loop
    Tracktab(10,GPTrack(i))=Trim(Trim(Trim(zeile,pruef)," "),": ")
    'Print i, "zeile = ";quote(zeile)
'Circuit Length:
 	Do While Not Eof(f1)
   	Line Input #f1,zeile
   	If Eof(f1) Then Print "Circuit Length not found - EOF":Sleep:End
   	pruef=circuit_length(gps_lng)
   	If Left(zeile,Len(pruef))=pruef Then Exit Do
 	Loop
   Tracktab(11,GPTrack(i))=Trim(Trim(Trim(zeile,pruef)," "),": ")
   'Print i, "zeile = ";quote(zeile)
   Line Input #f1,zeile
   	If Eof(f1) Then Print "EOF after Circuit Length":Sleep:End
	'Print i, "zeile = ";quote(zeile)
	   	
subend:   
End Sub

Sub GetTeamData (team As Integer)
Dim TrackLabel(1 To 11) As String => {"685 "+NAK,"686 "+NAK,"687 "+NAK,"688 "+NAK,_
"689 "+NAK,"690 "+NAK,"691 "+NAK,"692 "+NAK,"693 "+NAK,"694 "+NAK,"695 "+NAK}

	i=team
	Do While Not Eof(f1)
		Line Input #f1,zeile
		If Eof(f1) Then Print "Teamlabel ";Tracklabel(i);" not found - EOF":Sleep:End
		If Left(zeile,5)=TrackLabel(i) Then 
			Print teamtab(0,i), GPTeam(i), zeile
			Exit Do
		EndIf
	Loop
	
'Team Principal:
	Teamtab(3,GPTeam(i))=Trim(Trim(SubStr(zeile,":",2),Tracklabel(i))," ")
	'Print i,"zeile = ";quote(zeile)
'Technical Director:
	Line Input #f1,zeile
	If Eof(f1) Then Print "Technical Director not found - EOF":Sleep:End
	'Print i,"zeile = ";quote(zeile)
	Teamtab(4,GPTeam(i))=Trim(SubStr(zeile,":",2)," ")
'Drivers
	Teamtab(5,GPTeam(i))=Drivertab(1,2*GPTeam(i)-1)+", "+Drivertab(1,2*GPTeam(i))	
'Team Nationality:
   Do While Not Eof(f1)
   	Line Input #f1,zeile
   	If Eof(f1) Then Print "Team Nationality not found - EOF":Sleep:End
   	pruef=team_nationality(gps_lng)
   	If Left(zeile,Len(pruef))=pruef Then Exit Do
   Loop
   Teamtab(6,GPTeam(i))=Trim(Trim(Trim(zeile,pruef),": ")," ")  
'Team Base:
   Do While Not Eof(f1)
   	Line Input #f1,zeile
   	If Eof(f1) Then Print "Team Base not found - EOF":Sleep:End
   	pruef=team_base(gps_lng)
   	If Left(zeile,Len(pruef))=pruef Then Exit Do
   Loop
   Teamtab(7,GPTeam(i))=Trim(Trim(Trim(zeile,pruef),": ")," ")
'Number of years in F1:
   Do While Not Eof(f1)
   	Line Input #f1,zeile
   	If Eof(f1) Then Print "Number of years in F1 not found - EOF":Sleep:End
   	pruef=nbr_of_years_in_f1(gps_lng)
   	If Left(zeile,Len(pruef))=pruef Then Exit Do
   Loop
   Teamtab(8,GPTeam(i))=Trim(Trim(Trim(zeile,pruef),": ")," ")

'Number of wins:
   Do While Not Eof(f1)
   	Line Input #f1,zeile
   	If Eof(f1) Then Print "Number of wins not found - EOF":Sleep:End
   	pruef=nbr_of_wins(gps_lng)
   	If Left(zeile,Len(pruef))=pruef Then Exit Do
   Loop
   Teamtab(9,GPTeam(i))=Trim(Trim(Trim(zeile,pruef)," "),": ")

'Number of driver titles:
   Do While Not Eof(f1)
   	Line Input #f1,zeile
   	If Eof(f1) Then Print "Number of driver titles not found - EOF":Sleep:End
   	pruef=nbr_of_driver_titles(gps_lng)
   	If Left(zeile,Len(pruef))=pruef Then Exit Do
   Loop
   Teamtab(10,GPTeam(i))=Trim(Trim(Trim(zeile,pruef)," "),": ")
   
'Number of constructors titles:
   Do While Not Eof(f1)
   	Line Input #f1,zeile
   	If Eof(f1) Then Print "Number of constructor titels not found - EOF":Sleep:End
   	pruef=nbr_of_constructor_titles(gps_lng)
   	If Left(zeile,Len(pruef))=pruef Then Exit Do
   Loop
   puffer=Trim(Trim(Trim(zeile,pruef)," "),": ")
   Teamtab(11,GPTeam(i))=Trim(puffer,NAK)
   'Print i,"pruef = ";quote(pruef)
   'Print i,"zeile = ";quote(zeile) 
End Sub
Sub GetDriverData (driver As Integer)
	
'Dim drivertxt As String = path+language(gps_lng)+"_part5a.txt"	
Dim TrackLabel(1 To 22) As String => {"696 "+NAK,"697 "+NAK,"698 "+NAK,"699 "+NAK,"701 "+NAK,"702 "+NAK,_
"704 "+NAK,"705 "+NAK,"706 "+NAK,"708 "+NAK,"709 "+NAK,"712 "+NAK,"713 "+NAK,"716 "+NAK,"719 "+NAK,_
"1135 "+NAK,"1136 "+NAK,"1137 "+NAK,"1138 "+NAK,"1272 "+NAK,"1451 "+NAK,"1477 "+ NAK}

	i=driver
	Do While Not Eof(f1)
	Line Input #f1,zeile
	If Eof(f1) Then Print "Driverlabel ";Tracklabel(i);" not found - EOF":Sleep:End
	If Left(zeile,Len(Tracklabel(i)))=TrackLabel(i) Then
		If Tracklabel(i)="719 "+NAK Then
			Textout(outfile(6),"",1,"1130 "+NAK,0)
		EndIf
		Print i, zeile
		Exit Do
	EndIf
	Loop

		
'Date of Birth
	Do While Not Eof(f1)
   	Line Input #f1,zeile
   	If Eof(f1) Then Print "Date of Birth not found - EOF":Sleep:End
   	pruef=date_of_birth(gps_lng)
   	If Left(zeile,Len(pruef))=pruef Then Exit Do
	Loop
	Drivertab(3,GPDriverInfo(i))=Trim(Trim(Trim(zeile,pruef)," "),": ")
	
'Nationality
	Do While Not Eof(f1)
   	Line Input #f1,zeile
   	If Eof(f1) Then Print "Nationality not found - EOF":Sleep:End
   	pruef=nationality(gps_lng)
   	If Left(zeile,Len(pruef))=pruef Then Exit Do
	Loop
	Drivertab(4,GPDriverInfo(i))=Trim(Trim(Trim(zeile,pruef)," "),": ")

'Residence
	Do While Not Eof(f1)
   	Line Input #f1,zeile
   	If Eof(f1) Then Print "Residence not found - EOF":Sleep:End
   	pruef=residence(gps_lng)
   	If Left(zeile,Len(pruef))=pruef Then Exit Do
	Loop
	Drivertab(5,GPDriverInfo(i))=Trim(Trim(Trim(zeile,pruef)," "),": ")

'GP Starts
	Do While Not Eof(f1)
   	Line Input #f1,zeile
   	If Eof(f1) Then Print "GP Starts not found - EOF":Sleep:End
   	pruef=grand_prix_starts(gps_lng)
   	If Left(zeile,Len(pruef))=pruef Then Exit Do
	Loop
	Drivertab(6,GPDriverInfo(i))=Trim(Trim(Trim(zeile,pruef)," "),": ")
'Points scored
	Do While Not Eof(f1)
   	Line Input #f1,zeile
   	If Eof(f1) Then Print "Points scored not found - EOF":Sleep:End
   	pruef=points_scored(gps_lng)
   	If Left(zeile,Len(pruef))=pruef Then Exit Do
	Loop
	Drivertab(7,GPDriverInfo(i))=Trim(Trim(Trim(zeile,pruef)," "),": ")

'Best Results
	Do While Not Eof(f1)
   	Line Input #f1,zeile
   	If Eof(f1) Then Print "Best Results not found - EOF":Sleep:End
   	pruef=best_result(gps_lng)
   	If Left(zeile,Len(pruef))=pruef Then Exit Do
	Loop
	Drivertab(8,GPDriverInfo(i))=Trim(Trim(Trim(zeile,pruef)," "),": ")

'Best Qualifying
	Do While Not Eof(f1)
   	Line Input #f1,zeile
   	If Eof(f1) Then Print "Best Qualifying not found - EOF":Sleep:End
   	pruef=best_qualifying(gps_lng)
   	If Left(zeile,Len(pruef))=pruef Then Exit Do
	Loop
	Drivertab(9,GPDriverInfo(i))=Trim(Trim(Trim(zeile,pruef)," "),": ")

'First GP
	Do While Not Eof(f1)
   	Line Input #f1,zeile
   	If Eof(f1) Then Print "First GP not found - EOF":Sleep:End
   	pruef=drivers_first_gp(gps_lng)
   	If Left(zeile,Len(pruef))=pruef Then Exit Do
	Loop
	Drivertab(10,GPDriverInfo(i))=Trim(Trim(Trim(zeile,pruef)," "),": ")

'Last Year Championship Position
	Do While Not Eof(f1)
   	Line Input #f1,zeile
   	If Eof(f1) Then Print "Last Year Championship Position not found - EOF":Sleep:End
   	pruef=last_year_championship_pos(gps_lng)
   	If Left(zeile,Len(pruef))=pruef Then Exit Do
	Loop
	Drivertab(11,GPDriverInfo(i))=Trim(Trim(Trim(zeile,pruef)," "),": ")

'Previous Teams	
		Do While Not Eof(f1)
   	Line Input #f1,zeile
   	If Eof(f1) Then Print "Previous Teams not found - EOF":Sleep:End
   	pruef=previous_teams(gps_lng)
   	If Left(zeile,Len(pruef))=pruef Then Exit Do
		Loop
	Drivertab(12,GPDriverInfo(i))=Trim(Trim(Trim(zeile,pruef)," "),": ")
	
End Sub
Sub Textout (outfile As String, StartLabel As String,StartOption As Integer, ExitLabel As String,ExitOption As integer)
'Direktausgabe von Zeilen aus gps-Datei in Textdatei outfile
'Startlabel: Marke, bei der die Ausgabe beginn; wenn leer, dann sofort
'StartOption = 1: inclusiv, d.h. die erste Zeile ist schon eingelesen (bei voriger Textausgabe), 0=exclusiv 
'ExitLabel: Marke, bei der die Ausgabe endet
'ExitOption = 1: inclusiv, d.h. die Zeile mit dem ExitLabel gehrt zum Text, 0=exclusiv

	f2=FreeFile
	Select Case OPEN (outfile For Output Encoding("UTF-16") As #f2)
		CASE 0
			' ok
		Case 2
			' not found: wird erstellt
		Case Else
			Print "Error when opening file ";outfile
			Close #f2
			GoTo subend
	END Select
	
	If StartLabel<>"" Then 
	Do While Not(Eof(f1))
		Line Input #f1,zeile
		If Eof(f1) Then Print "Startlabel ";Startlabel;" not found - EOF":Sleep:End
		If Left(zeile,Len(StartLabel))=StartLabel Then Exit Do 'vor bis Startlabel
	Loop
	EndIf
	
	If StartOption = 1 Then Print #f2,zeile 'die erste Zeile ist schon eingelesen worden

	Do While Not(Eof(f1))
		Line Input #f1,zeile
		If Eof(f1) Then 
			If ExitLabel="2125 "+NAK Then 
				Print "Normal EOF"
			Else
				Print "Exitlabel ";Exitlabel;" not found - EOF":Sleep:End
			EndIf
		EndIf
		If Left(zeile,Len(ExitLabel))=ExitLabel Then 
			If Exitoption = 1 Then Print #f2,zeile
			Exit Do
		EndIf
		Print #f2,zeile
	Loop 
	Close #f2
	Print"Text file ";quote(outfile); " created."
	  	
subend:	  	
End Sub
