'--- gps2txt_ff.bas ---
#Include "vbcompat.bi"
'Liest (i.a. englische) GPS-Datei sequentiell,
'stellt Fahrer-,Team-,Strecken-Daten fr Ausgabe in CSV bereit,
'schreibt nicht zu verndernden Text in Textdateien (z.B: en_part1.txt, ..., en_part8.txt)
'div. Parameter aus INI-Datei u.a.: Modus: (0,1: 0=Nur CSV erstellen, 1=Text und CSV) 

On Error GoTo errorhandler
Const version = " 0.42 "

'-- Deklarationen --
Dim Shared As Integer f1,f2,i,k,l,m,n,errnr, errfn, errln, key, result, tracknum
Dim Shared As String zeile,puffer,pruef, pruef2
Dim Shared As String gps_ini, csvfile, gps_log
Dim Shared As String progpath, inpath, season, gps_file, form_file, outpath,  trackinfo_file 'werden aus ini ermittelt
Dim Shared As String*1 _modus 'optional aus ini eingelesen
Dim Shared As String driver_header(), team_header(), track_header() ' werden aus Format-Datei form_file eingelesen
Dim Shared As Integer gps_lng, modus=0, driver_rows, team_rows, track_rows, info_row, tracktab_offset, corner_rows, header_dim
Dim Shared As String*2 lng(4) => {"en","de","es","fr","it"}
Dim Shared As String*8 language(4) => {"English", "Deutsch", "espaol", "Franais", "italiano"} 
Dim Shared As String circuit_info(0 To 4) 

Dim Shared outfile(1 To 10) As String

'In GPaedia werden Fahrer,Team,Strecke in anderer Reihenfolge dargestellt
'Die folgenen Listen stellen die Zuordnung zu der Standardreihenfolge her
Dim Shared GPDriver(1 To 22) As Integer => {1,2,3,4,5,15,6,7,8,20,14,9,11,16,12,17,13,10,18,22,21,19}
Dim Shared GPDriverInfo(1 To 22) As Integer => {3,4,1,2,12,17,5,8,7,11,15,18,13,9,6,16,14,19,10,21,20,22}
Dim Shared GPTeam(1 To 11) As Integer => {2,1,6,9,3,4,11,8,7,10,5}
Dim Shared GPTrack(1 To 17) As Integer => {1,3,4,11,5,9,7,8,10,6,12,13,14,15,16,17,2}

'Prozeduren und Funktionen
Declare Sub ReadIni 'Einlesen von Werten aus der Ini-Datei (gps_%season%.ini)
Declare Sub ReadFormat 'Einlesen der Format-Datei "gps.txt"
Declare Sub InitLang 'Sprachspezifische Daten einlesen (Circuit_info)
Declare Sub InitTabs 'Initialisierung von Datenfeldern fr CSV
Declare Sub Textout (outfile As String, StartLabel As String, StartOption As Integer, ExitLabel As String, ExitOption As integer) 
 'Zeilen unverndert in Textdatei ausgeben     
Declare Sub GetTrackRecords (track As Integer) 'Strecken-Rekorde pro Strecke einlesen
Declare Sub GetCornerData (track As Integer) 'Kurvendaten pro Strecke einlesen
Declare Sub GetTrackGpaedia (track As Integer) 'Kurvendaten pro Strecke einlesen
Declare Sub GetTeamData(team As Integer) 'Teamdaten pro Team einlesen 
Declare Sub GetDriverData (driver As Integer) 'Fahrerdaten pro Fahrer einlesen  
  
Declare Sub MakeTXT(gpsfile As String, typ As Integer)  
Declare Sub WriteCSV(s() AS  STRING, Datei AS  STRING, TZ AS  STRING, TT As String, conv AS  INTEGER)
Declare Sub error_print(zeilen As String, colour As Integer) ' Fehler ausgeben (rot auf Bildschirm)
Declare Sub chktext(txtfile As String)
                        
Declare Function SubStr(byVal  Liste As  String, byVal  Trenner As  String, ByVal Stelle As  Integer) As  String
Declare Function InCount(ByVal wordlist As String,ByVal Delimiter As String) As Integer
Declare Function StrReplace (Byval StrEx as String, Byval StrMask as String, Byval StrRplce as String) as String
Declare Function Replace(ByVal V_Data As String, ByVal V_Expression As String, ByVal V_ReplaceBy As String) As String                                      
Declare Function quote(ByVal chkstr As String) As String
Declare Function GetDigits(ByVal inline As String) As String
Declare Function Chkpath(ByVal path As String) As Integer
Declare Function Chkvalue(ByVal value As String) As Integer
Declare Function chkvalue2(ByVal value As String) As Integer
Declare Function chkheader(ByVal zeile As String, ByVal typ As String, ByVal index As Integer, ByRef chklen As Integer) As Integer

Const NAK=Chr(21), LF=Chr(10), CrLf = Chr(13), red = 12

'--- Hauptprogramm ---
Screen 19

' gps_ini kann als Argument bergeben werden
If Command$(1) <> "" Then 
	gps_ini = Command$(1)
Else
'	gps_ini = "d:\gpaedia\gps2txt_ff\gps_1996.ini"
'	gps_ini = "d:\gpaedia\gps2txt_ff\gps_2008.ini"
'	gps_ini = "d:\gpaedia\gps2txt_ff\2001\gps_2001_en.ini"
'	gps_ini = "d:\gpaedia\gps2txt_ff\1983\gps_1983-test.ini"
EndIf

Print "=== gps2txt_ff";version;"==="

gps_lng = 0
season = "2001" 'default; aktuelle Saison wird aus ini eingelesen
'progpath = ExePath 
progpath = "d:\gpaedia\gps2txt_ff\"
ReadIni 'Einlesen Ini_Datei (gps_ini)
Readformat 'Einlesen der Formate aus form_file
InitLang

'In den folgenden 3 Tabellen werden die 0-Werte fr Zeilenkopf bzw. Spaltenkopf gebraucht
Dim Shared Drivertab(driver_rows,22) As String '22 Fahrer (als Spalten), Zeilen siehe ReadFormat
Dim Shared Teamtab(team_rows,11) As String '11 Teams (als Spalten), Zeilen siehe ReadFormat
Dim Shared Tracktab(track_rows,17) As String '17 Tracks (als Spalten), Zeilen siehe ReadFormat

InitTabs 'Tabellen initialisieren (Zeilen- und Spaltenkpfe)

'--- GPS Datei auslesen ---

'Zeilen aus GPS-Datei einlesen
f1=FreeFile
print
Select Case OPEN (gps_file For Input Encoding("UTF-16") As #f1)
	CASE 0
		Print "File ";quote(gps_file);" opened for input - ok"
	Case 2
		Print "File ";quote(gps_file);" not found."
		Close #f1
		GoTo ende
	CASE Else
		Print "Error when opening file ";quote(gps_file)
		Close #f1
		GoTo ende
END Select

'Pfad + Name fr Ausgabedateien sprachspezifisch:
If modus > 0 Then
	Print:Print "Init filenames for output:"
	For i=1 To 10
		outfile(i)=outpath+lng(gps_lng)+"_"+"part"+str(i)+".txt"
		Print outfile(i)
	Next
If key<>13 Then Print "--- key --- ";:key = GetKey
EndIf

'-- 1. Teil: Alle Zeilen bis 1. Kennung in 1. Textdatei schreiben
Textout(outfile(1),"",0,"1767 "+NAK,1)

'-- 2. Teil: Fahrer\Team Daten in Array Drivertab aufnehmen
i=0
Print:Print "Driver (No.,GP-Info-No.,Name,Team):"
Do While Not(Eof(f1))
	i=i+1
	Line Input #f1,zeile
	'Print i,quote(zeile)
	If Eof(f1) Then Print "Driver table not found - EOF":Sleep:End
	pruef=Left(zeile,1)
		If pruef=NAK Then Exit Do 'Zeile nach Driver\Teams oder letzte Zeile erreicht
	If i=1 Then 
		puffer=Mid(zeile,4)
	Else puffer=zeile
	EndIf
	'Print "puffer = ";puffer
	Drivertab(1,i)=Trim(SubStr(puffer,"\",1))
	Drivertab(2,i)=Trim(StrReplace(SubStr(puffer,"\",2),NAK,""))
	Print i,GPDriverInfo(i),drivertab(1,i) + ", " + drivertab(2,i)
	pruef2=Right(zeile,1)
	If pruef2=NAK Then 
		Line Input #f1,zeile
		If Eof(f1) Then Print "End of driver table not found - EOF":Sleep:End
		Exit do
	EndIf
Loop 

If key<>13 Then Print "--- key --- ":key = GetKey

'-- 3. Teil: Alle Zeilen bis vor GPaedia - Driver\Teams in 2. Textdatei schreiben   
Textout(outfile(2),"",1,"2163 "+NAK,1)

'-- 4. Teil: Alle Zeilen bis nach GPaedia - Driver\Teams
' und vor Tracks \ Country in 3. Textdatei schreiben   

Textout(outfile(3),"13 "+NAK,1,"1445 "+NAK,1)

'-- 5. Teil: Tracks\Country auslesen
Print "Tracks (No.,GPaedia-No.,Name,Country):"
i=0
Do While Not(Eof(f1))
	Line Input #f1,zeile
	If Eof(f1) Then Print "Track table not found - EOF":Sleep:End
	If Left(zeile,4)="43 "+NAK Then Exit Do 'Zeile nach Track\Country
	i=i+1
	puffer=SubStr(zeile,NAK,2)'rechts und links weglassen
	Tracktab(1,i)=SubStr(puffer," \ ",1) 'Track
	Tracktab(2,i)=SubStr(puffer," \ ",2) 'Country
	Print i, GPTrack(i),Tracktab(1,i) + ", " + Tracktab(2,i)
Loop
If key <> 13 Then Print "--- key ---":key = GetKey
	
'-- 6. Teil: Alle Zeilen nach Track\Country Trackrecords in 4. Textdatei schreiben   
Textout(outfile(4),"",1,"950 "+NAK,1)

'-- 7. Teil: Rekorde der Strecken - Teil 1/2 - auslesen
Print"Trackrecords 1-7 (No., Gpaedia-No., Track, Label+Data):"
For i=1 To 7 'Teil 1 = die ersten 7 Strecken
	GetTrackRecords(i)
Next
If key <> 13 Then Print "--- key ---":key = GetKey

'-- 8. Teil: Corner data auslesen
Print"Corner data (TrackNo.,Gpaedia-No.,Searchlabel,Header)"
For i=1 To 17: GetCornerData(i):Next
If key <> 13 Then Print "--- key ---":key = GetKey

'-- 9. Teil: Rekorde der Strecken - Teil 2/2 - auslesen
Print"Trackrecords 8-17 (No., Gpaedia-No., Track, Data):"
For i=8 To 17:	GetTrackRecords(i): Next
If key <> 13 Then Print "--- key ---":key = GetKey

'-- 10. Teil: ab "179 "+NAK incl. bis  "666 "+NAK excl. in 5. Textdatei (gross!)
Textout(outfile(5),"",0,"1247 "+NAK,1)
Textout(outfile(6),"1557 ",0,"2170 "+NAK,1)
Textout(outfile(7),"2171 ",0,"666 "+NAK,0)
  
'-- 11. Teil: anschlieend "666 "+NAK incl. Streckendaten auslesen, dabei
'          Streckeninfo-Text in Info-Textdatei fr Strecke schreiben
Print "Trackinfo data (No., Gpaedia-No., Label + Circuit):"
For i=1 To 17
	GetTrackGpaedia(i)	
Next
If key <> 13 Then Print "--- key ---":key = GetKey

'-- 12. Teil (anschlieend ab "685 "+NAK): Teamdaten auslesen
Print"Teamdata (No., Gpaedia-No., Name):"
For i=1 To 11
	GetTeamData(i)
Next
If key <> 13 Then Print "--- key ---":key = GetKey

'Testausgabe Teams' verschieben hinter einlesen der teamlinks (fr team short)
Print "Teams (No.,GPaedia-No.,Name/Shortname):"
For i=1 To 11
	Teamtab(1,i)=Drivertab(2,2*i) 'Team name from driver-team
	'Print quote(Teamtab(1,i)):getkey
	Teamtab(2,i)=Teamtab(1,i) 'Shortname = Teamname, spter aus teamlink data
	Print i,GPTeam(i),Teamtab(1,i);" / ";teamtab(2,i) 
Next
If key <> 13 Then Print "--- key ---":key = GetKey

'-- 13. Teil (anschlieend ab "696 "+NAK): Fahrerdaten auslesen
'		  vor Driver(15) wird dabei die kurze Textdatei 8 ausgegeben 				
For i=1 To 22
	GetDriverData(i)':getkey
	'Print i, GPDriverInfo(i), Drivertab(0,i)', Drivertab(4,GPDriverInfo(i))
Next

'Testausgabe Drivers'
Print "Drivers (No.,GPaedia-No.,Name):"
For i=1 To 22
	Print i,GPDriverinfo(i),Drivertab(1,i)
Next
If key <> 13 Then Print "--- key ---":key = GetKey

'-- 14. Teil (ab "1558 "+NAK incl. bis "540 "+NAK incl.): in 7. Textdatei
Textout(outfile(9),"1558 "+NAK,1,"540 "+NAK,1)

'(Linkdaten: sind hier schon bekannt)

'-- 16. Teil (nach Linkdaten ab "2129 "+NAK bis Ende ("2125 "+NAK) in 8. Textdatei
Textout(outfile(10),"2129 "+NAK,1,"2125 "+NAK,1)

'-- 17. Teil: Ausgaben in CSV-Dateien
Print
	
csvfile=outpath+"driver.csv"
WriteCSV (Drivertab(),csvfile,";",Chr(34),0) 
Print"CSV file ";quote(csvfile);" created"
	
csvfile=outpath+"team.csv"
WriteCSV (Teamtab(),csvfile,";",Chr(34),0)
Print"CSV file ";quote(csvfile);" created"

csvfile=outpath+"track.csv"
WriteCSV (Tracktab(),csvfile,";",Chr(34),0)
Print"CSV file ";quote(csvfile);" created"
	
ende:
Close #f1

Print:Print"--- press any key to quit ---"
Sleep:end	
	
errorhandler:
errnr = Err
errfn = *Ermn
errln = Erl
'Print #f3, ("Error " &Err &" in function " &*Ermn &" in line " &Erl)
'Print #f3, "--- Program stopped ---"
'Close #f3

Print("Error " &errnr &" in function " &errfn &" in line " &errln)
Print "--- press any key to stop ---"
GetKey:End

'Daten einlesen:
Data "Circuit Info:","Streckeninfo:","Informacin sobre el circuito:","Caractristiques :","Note sul tracciato:"

'---------------------------------- Functions and SUBs: ------------------------------------
Function  SubStr(byVal  Liste As  String, byVal  Trenner As  String, byVal  Stelle As  Integer) As  String
  Dim As String ret0	
  Dim As Integer Aktuell=0, Ooops, ltr=Len(Trenner), Vorige=1, Gefunden
  If Stelle=0 Or Liste="" Or Trenner="" Or Instr(Liste, Trenner)=0 Then Return ""
  Do
    Ooops=Gefunden
    Gefunden=Instr(Gefunden+1, Liste, Trenner)
    Aktuell-=Gefunden<>0
    If Aktuell=Stelle-1 Then Vorige=Gefunden+ltr
    If Aktuell=Stelle Then Exit Do
  Loop Until Gefunden=0
  ret0 = Mid(Liste, IIF(Stelle-Aktuell>1, Len(Liste)+1, Ooops+ltr))
  If ret0="" Then ret0 = ret0 &Chr(0)
  If Stelle>Aktuell Then 
  	Return ret0
  Else  
  	Return Mid(Liste, Vorige, Gefunden-Vorige)
  EndIf
  
End Function

'Original-Code von ytwinky (Jrg Zhlke), Quelle: 
'http://www.freebasic-portal.de/code-beispiele/string-funktionen/substr-fast-ein-splitstring-81.htm
'Korrigiert P.Hagemann 04/2012 (Fehler: chr(0) am Ende des letzten Teils der Liste)

Function StrReplace (Byval StrEx as String, _
                     Byval StrMask as String, _
                     Byval StrRplce as String) as String

    If Len(StrEx)=0 or Len(StrMask)>Len(StrEx) Then Return StrEx

    Dim Buffer as String=StrEx
    Dim MaskSearch as UInteger
    Dim MFound as byte
    Dim lp as UInteger=1

    Do
        MaskSearch=InStr(lp,Buffer,StrMask)
        MFound=0

        If MaskSearch Then
            MFound=1:lp=MaskSearch+Len(StrRplce)

            ''
            Buffer=Left(Buffer,MaskSearch-1)+ _
            StrRplce+ _
            Right(Buffer,Len(Buffer)-(MaskSearch+(Len(StrMask)-1)))
            ''

        End If

    Loop while MFound=1

    Return Buffer
End Function
'Quelle: http://www.freebasic-portal.de/code-beispiele/string-funktionen/strreplace-59.html


Function quote(ByVal chckstr As String) As String
Dim chkstr As string

	chkstr = Chr(34)+chckstr+Chr(34)
	Return chkstr
	
End Function

Function Replace(ByVal V_Data As String, ByVal V_Expression As String, ByVal V_ReplaceBy As String) As String
Dim X As Long
Dim SL As Long
Dim D as String
D = V_Data
SL = Len(V_Expression)
X = 0
Do
    X = X + 1
    If X > Len(D) - SL + 1 Then Exit Do
    If Mid(D, X, SL) = V_Expression Then
        D = Mid(D, 1, X - 1) & V_ReplaceBy & Mid(D, X + SL)
        X = X - (SL  - 1)
        If X < 0 then X = 0
    End If
Loop
'Print"Replaced ";quote(V_Expression);" in ";quote(V_Data);", result: ";quote(D)
Return D
End Function
'Quelle: http://www.freebasic-portal.de/code-beispiele/string-funktionen/sehr-schnelle-replace-funktion-91.html

Sub error_print(zeilen As String, colour As Integer)
'gibt Zeile rot oder gelb aus'

Color colour
Print zeilen
Color 15 	
End Sub

SUB WriteCSV(s() AS STRING, Datei AS STRING, TZ AS STRING, TT As String, conv AS INTEGER)
' Erzeugt aus dem Array s(0, 0) bis s(m, n) eine CSV-Datei (Excel-Tabelle aus
' den Zeilen 0 bis m und den Spalten 0 bis n).
' - TZ = Trennzeichen (z.B. Komma oder Semikolon, d.h. englisches oder deutsches
'   CSV-Format, oder beliebiges anderes Zeichen)
' - TT = Text-Trennzeichen (z.B. Anfhrungszeichen); damit knnen auch Sonderzeichen
'   in den Felddaten vorkommen, wie z.B. LF (Linefeed) als Zeilenumbruch 
' - conv <> 0: Dezimalpunkte werden in Kommata umgewandelt (nur sinnvoll, wenn
'   das Trennzeichen kein Komma ist und die Daten z.B. keine Datumsangaben
'   enthalten)

  DIM AS INTEGER i, j, k, m, n, f

  m = UBOUND(s, 1)
  n = UBOUND(s, 2)

  'Dezimalpunkte durch Kommata ersetzen:
  IF conv THEN
    FOR i = 0 TO m
      FOR j = 0 TO n
        k = INSTR(s(i, j), ".")
        IF k > 0 THEN MID(s(i, j), k, 1) = ","
      NEXT j
    NEXT i
  END IF

  'Speichern mit Trennzeichen:
  f = FreeFile
   
  OPEN Datei For Output Encoding("UTF-16") As #f
  FOR i = 0 TO m
    FOR j = 0 TO n - 1
      PRINT #f, TT + s(i, j) + TT + TZ;
    NEXT j
    PRINT #f, TT + s(i, n) + TT
  NEXT i
  CLOSE #f

END Sub

'Original-Code von Lothar Schirm, Quelle:
'http://www.freebasic-portal.de/code-beispiele/kleine-helferlein/csv-dateien-erzeugen-lesen-163.html
'Modifiziert (Text-Trennzeichen hinzugefgt) von P.Hagemann

Sub ReadIni

Dim As String zeile, pruef, puffer, lng_lst, lng_switch, gpsfiles, gps_normal, gps_tracks, gps_test
Dim As Integer errors=0, out0, i, j, k, t, act, lng_count, part_count

Print

	f2=FreeFile
	Select Case OPEN (gps_ini For Input As #f2)
		CASE 0
			Print quote(gps_ini);" openend"
		Case 2
			error_print ("File not found " + quote(gps_ini),red)
			'Close #f2
			errors = errors + 1
			GoTo endini
		Case Else
			error_print ("Error when opening file " + quote(gps_ini),red)
			'Close #f2
			errors = errors + 1
			GoTo endini
	END Select
	
	'Verzeichnisnamen
	k=0
	Do While Not(Eof(f2))
		Line Input #f2,zeile
		k=k+1
		'print "#";k,zeile
		If zeile="" Then Continue Do
		If Left(zeile,1)=";" Then Continue Do
		
		If Left(zeile,7)="gps_lng" Then 
			gps_lng = Val(Trim(SubStr(zeile,"=",2)))
			Print "gps_lng = ";gps_lng,language(gps_lng)
		EndIf
		
		If Left(zeile,6)="season" Then 
			Season = Trim(SubStr(zeile,"=",2))
			Print "season = ";season
		EndIf
		
		If Left(zeile,12)="program_path" Then 
			progpath = Trim(SubStr(zeile,"=",2)) 
			progpath = StrReplace(progpath,"%season%",season)
			If Right(progpath,1) = "\" Then progpath = Left(progpath,Len(progpath)-1)
			
			If chkpath(progpath+"\") = 1 Then
				Print "program_path = ";quote(progpath)
			Else
				error_print ("program_path folder " + quote(progpath) + " not found.",red)
				errors=errors+1
			EndIf	
		EndIf	
				
		If Left(zeile,7)="in_path" Then 
			inpath = Trim(SubStr(zeile,"=",2)) 
			inpath = StrReplace(inpath,"%program_path%",progpath)
			inpath = StrReplace(inpath,"%season%",season)
			If Right(inpath,1) <> "\" Then inpath = inpath + "\"
			If chkpath(inpath) = 1 Then
				Print "in_path = ";quote(inpath)
			Else
				error_print ("in_path folder " + quote(inpath) + " not found.",red)
				errors=errors+1
			EndIf	
		EndIf	

		If Left(zeile,8)="gps_file" Then 
			gps_file = Trim(SubStr(zeile,"=",2)) 
			gps_file = StrReplace(gps_file,"%program_path%",progpath)
			gps_file = StrReplace(gps_file,"%in_path%",inpath)
			gps_file = StrReplace(gps_file,"%season%",season)
			gps_file = StrReplace(gps_file,"%language%",language(gps_lng))
			gps_file = StrReplace(gps_file,"%ln%",lng(gps_lng))
			If FileExists(gps_file) Then
				Print "gps_file = ";quote(gps_file)
			Else
				error_print (quote(gps_file) + " not found",red)
				errors +=1
			EndIf
		EndIf	
		
		If Left(zeile,11)="format_file" Then 
			form_file = Trim(SubStr(zeile,"=",2)) 
			form_file = StrReplace(form_file,"%program_path%",progpath)
			form_file = StrReplace(form_file,"%in_path%",inpath)
			form_file = StrReplace(form_file,"%season%",season)
			form_file = StrReplace(form_file,"%language%",language(gps_lng))
			form_file = StrReplace(form_file,"%ln%",lng(gps_lng))
			If FileExists(form_file) Then
				Print "format_file = ";quote(form_file)
			Else
				error_print (quote(form_file) + " not found",red)
				errors +=1
			EndIf
		EndIf	
		
		If Left(zeile,8)="out_path" Then 
			outpath = Trim(SubStr(zeile,"=",2)) 'Leerzeichen und Tabs entfernen
			outpath = StrReplace(outpath,"%program_path%",progpath)
			outpath = StrReplace(outpath,"%in_path%",inpath)
			outpath = StrReplace(outpath,"%season%",season)
			outpath = StrReplace(outpath,"%language%",language(gps_lng))
			outpath = StrReplace(outpath,"%ln%",lng(gps_lng))
			If Right(outpath,1) <> "\" Then outpath = outpath + "\"
			If ChDir(outpath) Then
				If MkDir(outpath) Then
					error_print("out_path folder " + quote(outpath) + " could not be created.",red)
					errors=errors+1
				Else
					print("out_path folder " + quote(outpath) + " created.")
				EndIf		
			Else
				Print "out_path = ";quote(outpath)
			EndIf	
		EndIf			

		If Left(zeile,14)="trackinfo_file" Then 
			trackinfo_file = Trim(SubStr(zeile,"=",2))
			trackinfo_file = StrReplace(trackinfo_file,"%program_path%",progpath)
			trackinfo_file = StrReplace(trackinfo_file,"%season%",season)
			trackinfo_file = StrReplace(trackinfo_file,"%language%",language(gps_lng))
			trackinfo_file = StrReplace(trackinfo_file,"%ln%",lng(gps_lng))
			'Print "trackinfo file = ";trackinfo_file
		EndIf
		
		If Left(zeile,5)="modus" Then 
			_modus = Trim(SubStr(zeile,"=",2))
			Print "modus = ";_modus
			If chkvalue(_modus) <> 1 Then 
				error_print ("Invalid modus value " + _modus,red)
				errors=errors+1
			Else
				modus = Val(_modus)
			EndIf
		EndIf		
				
	Loop
	Close #f2

	'For i=0 To 4:Print i, quote(outfile(i)):Next
	'For i=0 To 4:Print i, quote(trackgpsfile(i)):next
  	
endini:
	If errors > 0 Then
		Print
		print "--- ";errors;" errors found. Press any key to break ---"
		GetKey:End
	EndIf
  	
End Sub

Sub Readformat
Dim As String zeile, puffer, pruef, mode
Dim As String driver_label="[driver]", team_label="[team]", track_label="[track]"
Dim As Integer i,k,n,in,dr,te,tr,act, errors=0
Dim As Integer driverfound, teamfound, trackfound

chktext(form_file)	
Print
	
anfang:
	f2=FreeFile
	Select Case OPEN (form_file For Input Encoding("UTF-16") As #f2)
		CASE 0
			If act=0 Then Print quote(form_file);" openend"
		Case 2
			Print:error_print ("File not found " + quote(form_file),red)
			'Close #f2
			errors += 1
			GoTo endformat
		Case Else
			Print:error_print ("Error when opening file " + quote(form_file),red)
			'Close #f2
			errors += 1
			GoTo endformat
	END Select
	
If act = 1 GoTo act1
	
	'Print "act0"
	' lesen und Anzahl der Daten ermitteln
	Do
		Line Input #f2,zeile
		'Print "Format Zeile: ";zeile
		If Eof(f2) Then Exit Do
		If Trim(zeile)="" Then Continue Do 'leere Zeile berlesen
		If Left(zeile,1)=";" Then Continue Do 'Zeile mit ";" berlesen
		If Left(zeile,Len(driver_label)) = driver_label Then 
			mode = "dr" ':print quote(driver_label)
			Continue Do
		EndIf
		If Left(zeile,Len(team_label)) = team_label Then 
			mode = "te" ':print quote(team_label)
			Continue Do
		EndIf
		If Left(zeile,Len(track_label)) = track_label Then 
			mode = "tr" ':print quote(track_label)
			Continue Do
		EndIf
		
		n=InCount(zeile,"|")
		If n-1>header_dim Then 
			header_dim=n-1
			'Print "header_dim = ";header_dim
		EndIf

		If mode = "dr" Then dr +=1
		If mode = "te" Then te +=1
		If mode = "tr" Then tr +=1
		'Print mode,quote(zeile),dr,te,tr
	Loop
	'Print "act0 exit =";quote(zeile):GetKey':End
	
Close #f2
'	Print "header_dim = ";header_dim
	ReDim driver_header(dr,header_dim)
	ReDim team_header(te,header_dim)
	ReDim track_header(tr,header_dim)
	
act = act + 1:GoTo anfang
'Print "act1"
act1:
	
	' einlesen der Daten in arrays
	Do While Not(Eof(f2))
		Line Input #f2,zeile':Print zeile
		If Eof(f2) Then Exit Do
		If Left(zeile,1)=";" Then Continue Do 'Zeile mit ";" berlesen
		
		If Left(zeile,Len(driver_label)) = driver_label Then
			driverfound = 1
			i=1
			'Print "--- driver_header";
			Do While i<=dr
				Line Input #f2,zeile':Print zeile
				If Left(zeile,1)=";" Then Continue Do 'Zeile mit ";" berlesen
				n=InCount(zeile,"|")
				'Print "i,n,zeile";i;Tab(15);n;Tab(20);quote(zeile);
				If n=1 Then
					driver_header(i,0) = Trim(zeile)
					'Print Tab(50);0;quote(driver_header(i,0))				
				Else
					For k=1 To n
						pruef = SubStr(zeile,"|",k)
						driver_header(i,k-1) = Trim(pruef)
						'Print Tab(20);i;Tab(25);k-1;quote(pruef)
					Next
				EndIf
				
				If Eof(f2) Then Exit Do
				'Print i,zeile:	
				'GetKey
				i+=1
			Loop 
		EndIf
		
		If Left(zeile,Len(team_label)) = team_label Then
			teamfound = 1
			i=1
			'Print "--- team_header";
			Do While i<= te
				Line Input #f2,zeile':Print zeile
				If Left(zeile,1)=";" Then Continue Do 'Zeile mit ";" berlesen
				n=InCount(zeile,"|")
				'Print "i,n,zeile";i;Tab(15);n;Tab(20);quote(zeile);
	
				If n=1 Then
					team_header(i,0) = Trim(zeile)':Print i,dr,zeil
					'Print Tab(50);0;quote(team_header(i,k))
				else
					For k=1 To n
						pruef = SubStr(zeile,"|",k)
						team_header(i,k-1) = Trim(pruef)':Print i,dr,quote(puffer)
						'Print Tab(20);i;Tab(25);k-1;quote(pruef)
					Next
				EndIf
				
				If Eof(f2) Then Exit Do
				'Print i,zeile
				'getkey
				i+=1
			Loop
		EndIf
		
		If Left(zeile,Len(track_label)) = track_label Then
			trackfound = 1
   		i=1
   		'Print "--- track_header";
   		Do While i<= tr
				Line Input #f2,zeile':Print zeile
				If Left(zeile,1)=";" Then Continue Do 'Zeile mit ";" berlesen
				n=InCount(zeile,"|")
				'Print "i,n,zeile";i;Tab(15);n;Tab(20);quote(zeile);
			  	
				If n=1 Then
					track_header(i,0) = Trim(zeile)':Print i,dr,zeile
					'Print Tab(50);0;quote(track_header(i,0))
					If zeile = "#info" Then info_row = i
					If zeile = "corner data" Then 
						tracktab_offset = i
						corner_rows=25
					EndIf
				else
					For k=1 To n
						pruef = SubStr(zeile,"|",k)
						track_header(i,k-1) = Trim(pruef)':Print i,dr,quote(puffer)
						'Print Tab(20);i;Tab(25);k-1;quote(pruef)
					Next
				EndIf

				If Eof(f2) Then Exit Do
				'Print i,zeile
				'getkey
				i+=1
   		Loop
		EndIf
    	
	Loop
	'Print "act1 exit =";quote(zeile):GetKey:End

Close #f2

If driverfound = 0 Then
	error_print("driver format not found",red)
	errors +=1
EndIf

If teamfound = 0 Then
	error_print("team format not found",red)
	errors +=1
EndIf

If trackfound = 0 Then
	error_print("track format not found",red)
	errors +=1
EndIf

If info_row < 4 Then 
	error_print("invalid #info row = "+ Str(info_row),red)
	errors +=1
EndIf

If errors >0 Then GoTo endformat

'Test Ausgabe Format
Print dr;" driver_header:"
For i=1 To dr:Print i,quote(driver_header(i,0));
   For k=1 To header_dim
		If driver_header(i,k)<>"" Then 
			Print "|";quote(driver_header(i,k));
		EndIf
   Next
   Print
Next
Print "--- key --- ";" Press <Enter> for display all / other for paging":key = GetKey
Print te;" team_header:"
For i=1 To te:Print i,quote(team_header(i,0));
   For k=1 To header_dim
		If team_header(i,k)<>"" Then 
			Print "|";quote(team_header(i,k));
		EndIf
   Next
   Print
Next
If key <> 13 Then Print "--- key --- ":key = GetKey
Print tr;" track_header:"
For i=1 To tr:Print i,quote(track_header(i,0));
   For k=1 To header_dim
		If track_header(i,k)<>"" Then 
			Print "|";quote(track_header(i,k));
		EndIf
   Next
   Print
Next
If key <> 13 Then Print "--- key --- ":key = GetKey

Print
driver_rows = UBound(driver_header)
'Print "driver_rows = ";driver_rows
team_rows = UBound(team_header)
'Print "team_rows = ";team_rows
track_rows = UBound(track_header)+corner_rows 'plus zeilen fr corner data (0 oder 25)
'Print "track_rows = ";track_rows,tracktab_offset,corner_rows	

	
endformat:	
	If errors > 0 Then
		Print
		print "--- ";errors;" errors found. Press any key to break ---"
		GetKey:End
	EndIf
	
'Print "---End Sub ReadFormat---":GetKey
End Sub

Sub InitLang
'Einlesen von Daten fr sprachspezifische Feldgruppen
'0=English,1=German,2=Espanol,3=Italiano,4=Francais
Dim As Integer i

For i=0 To 4:Read circuit_info(i):Next':Print circuit_info(0)

End Sub

SUB InitTabs
'Initialisiert die Arrays fr die Ausgabe in CSV
'Die erste Spalte wird gefllt mit den Bezeichnern fr die Zeilen	
Dim As integer i,k
Dim As String mph_kmh = "km/h"
Dim As String corner_nr

'Eintrge der Spaltennummern
Drivertab (0,0) = season
Teamtab(0,0) = season
Tracktab(0,0) = season

Print "Init table rows and columns"
'Spalten
For i=1 To 22
	Drivertab(0,i)=Str(i) 'Number of driver
	'Print "driver";i,quote(Drivertab(0,i))',"=key=":getkey
Next

For i=1 To 11
	Teamtab(0,i)=Str(i)	'Number of team, GPaedia-Team-Nr
	'Print "team";i,quote(Teamtab(0,i))',"=key=":GetKey
Next

For i=1 To 17
	Tracktab(0,i)=Str(i) 'Number of Track
	'Print "track";i,quote(tracktab(0,i))',"=key=":getkey
Next

'Zeilen der ersten Spalte
'Print "- Driver rows"
For k = 1 To driver_rows
	Drivertab(k,0) = Trim(Trim(Trim(driver_header(k,0)),":"))
	'Print k,quote(Drivertab(k,0))
Next
'If key <> 13 Then Print "--- key ---":key = GetKey

'Print "- Team rows"
For k = 1 To team_rows
	Teamtab(k,0) = Trim(Trim(Trim(team_header(k,0)),":"))
	'Print k,quote(Teamtab(k,0))
Next
'If key <> 13 Then Print "--- key ---":key = GetKey

'Print "- Track rows"
For k = 1 To tracktab_offset
	Tracktab(k,0) = Trim(Trim(Trim(track_header(k,0)),":"))
	'Print k,quote(Tracktab(k,0))
Next

' corner data
If corner_rows > 0 Then
Print "Set corner rows"
	Tracktab(tracktab_offset,0)=track_header(tracktab_offset,0)
	For i=tracktab_offset+1 To track_rows ' 25 corner-data
		k=i-tracktab_offset
		If Len(Str(k))>=2 Then 
			corner_nr = Str(k)
		Else 
			corner_nr = "0"+Str(k)
		EndIf
		Tracktab(i,0)="corner " + corner_nr + ": name"+LF+"           gear"+LF+"           "+mph_kmh
	Next
EndIf

Print "Init Arrays for CSV-output done"
End Sub

Sub GetTrackRecords (track As integer)
'Daten fr Strecken-Rekorde auslesen	

Dim TrackLabel(17) As String => {"179 "+NAK,"951 "+NAK,"953 "+NAK,"954 "+NAK,"955 "+NAK,_
 "956 "+NAK,"957 "+NAK,"958 "+NAK,"977 "+NAK,"978 "+NAK,"979 "+NAK,"980 "+NAK,"981 "+NAK,_
 "982 "+NAK,"983 "+NAK,"984 "+NAK,"985 "+NAK,"986 "+NAK}
 'Marken pro Track (1-17)
Dim As Integer i,j,k,max,n,fertig,first 
Dim As String pruef,puffer,rest,lines

max=UBound(track_header)
i=track : j=GPTrack(i)
k=info_row+1

'Weiterlesen bis zur Marke fr 1. Zeile der Streckendaten
	Do While Not Eof(f1)
		Line Input #f1,zeile
		If Eof(f1) Then Print "Track records not found - EOF":Sleep:End
	'Print i, quote(zeile)
	'Print i, "Pruef = ";quote(Left(zeile,5))
	'Print i, "Tracklabel =";quote(Tracklabel(i))
	'getkey
		If Left(zeile,5)=TrackLabel(i) Then Exit Do
	Loop
	Print i,j;Tab(25);Tracktab(1,j);Tab(45);quote(zeile)
	puffer = Trim(Mid(zeile,6))
	pruef = track_header(k,0):m=Len(pruef)
	If left(puffer,m)=pruef Then 
		Tracktab(k,j) = Mid(puffer,m+1)
		'Print k;track_header(k,0);quote(Tracktab(k,i))
		n=k
		If k<max Then k=k+1
	Else			
		error_print(quote(Str(track_header(k,0)))+" not in first track records line "+quote(zeile),red)
		GetKey
	EndIf

	Do While Not Eof(f1)	
		Line Input #f1,zeile
		'Print i;k;" zeile = ";quote(zeile)
		If zeile = NAK Then Exit Do
		If Right(zeile,1) = NAK Then 
			zeile = Trim(zeile,NAK)
			fertig = 1
		EndIf
		If zeile = "" Then Continue Do
		'pruef = track_header(k,0) : m=Len(pruef)
		'Print i;k;" pruef = ";quote(pruef)
		If chkheader(zeile,"track",k,m)>0 Then
			Tracktab(k,j) = Trim(Mid(zeile,m+1))
			n=k
			'Print k;track_header(k,0);quote(Tracktab(k,i))
			If k<max Then k=k+1
		Else			
			Tracktab(n,j)= Tracktab(n,j) + CrLf + Trim(zeile)	
			'Print n,quote(Tracktab(n,i))
		EndIf
		'Print "=key=":GetKey
		If fertig > 0 Then Exit Do
	Loop

subend:	   
End Sub

Sub GetCornerData (track As integer)
'Daten fr Kurvenpunkte der jeweiligen Strecke auslesen	

Dim As Integer ColonPos, trennpos, ausgang
Dim As Integer i,k,j
Dim As String cornerdata, gear, speed, nextdata
Dim TrackLabel(1 To 17) As String => {"960 "+NAK,"961 "+NAK,"962 "+NAK,"963 "+NAK,_
 "964 "+NAK,"965 "+NAK,"966 "+NAK,"967 "+NAK,"968 "+NAK,"969 "+NAK,"970 "+NAK,"971 "+NAK,_
 "972 "+NAK,"973 "+NAK,"974 "+NAK,"975 "+NAK,"976 "+NAK}
 'Marken pro Track (1-17)
	
i=track : j=GPTrack(i)

'Weiterlesen bis zur Marke fr 1. Zeile der Streckendaten
	Do While Not Eof(f1)
		Line Input #f1,zeile
		'Print zeile
		If Eof(f1) Then Print "Tracklabel ";Tracklabel(i);" not found - EOF":Sleep:End
		If Left(zeile,5)=TrackLabel(i) Then Exit Do
	Loop
'Ausgabe in Log	
	'Print i, quote(zeile)
	Tracktab(tracktab_offset,j)=Trim(zeile,Tracklabel(i))
	Print i,j,Tracklabel(i);quote(Tracktab(tracktab_offset,j))
'corner data
If corner_rows > 0 Then
	Do 
   	Line Input #f1,zeile
   	If Eof(f1) Then Print "corner data not found - EOF":Sleep:End
   	'Print zeile
   	If Trim(zeile)="" Then Continue Do	'Zeile leer, dann nchste
   	If Right(zeile,1)= NAK Then 
   		zeile=Trim(zeile,NAK)
   		Ausgang=1							  	' letzte Zeile erreicht
   	EndIf
   	ColonPos=InStr(zeile,":")
	   If ColonPos>0 And ColonPos<5 Then	' Neue Kurve, wenn am Anfang (1-4) Doppelpunkt 
	   	If cornerdata<>"" Then				' Daten vorhanden, dann vorige Kurvendaten jetzt bernehmen
	   		'Print"cornerdata ausgabe = ";quote(cornerdata):getkey
	   		Tracktab(k+tracktab_offset,j)=cornerdata 
	   		cornerdata=""						' Datenpuffer lschen
	   	EndIf		
	   	k=Val(Left(zeile,ColonPos-1)) ' Kurvennummer = Nr. vor dem Doppelpunkt
	   	If k>25 Then Exit Do
	   	cornerdata=Trim(Mid(zeile,ColonPos+1))
	   	'Print"cornerdata+Kurve = ";quote(cornerdata),"Kurve= ";k,ColonPos
	   	If cornerdata = "" Then cornerdata = "-"	'Kurvenname als leer markieren
	   	If InStr(zeile,"Gear")>0 Then 	'1. Zeile leerr oder schon "Gear"-Zeile
				cornerdata = "-"
				puffer=Trim(Mid(zeile,ColonPos+1))
				gear=GetDigits(puffer)
				cornerdata=cornerdata+LF+gear	' in Daten aufnehmen 					
	   	EndIf		   	
	   ElseIf InStr(zeile,"Gear")>0 Then 'Zeile mit "Gear"
	   	puffer=Trim(Mid(zeile,ColonPos+1))
			gear=GetDigits(puffer)
			cornerdata=cornerdata+LF+gear			 ' in Daten aufnehmen
	   ElseIf InStr(Trim(zeile),"/")>0 Then ' mph/kmh-Zeile
	   	puffer = Trim(Mid(zeile,ColonPos+1))
	   	trennpos = InStr(puffer,"/")
     		speed=Str(Val(Mid(puffer,trennpos+1))) 'nur den km/h Wert (hinter "/") nehmen
	    	cornerdata=cornerdata+LF+speed
	   Else
	   EndIf
	   
	Loop 	While Not Eof(f1) And ausgang=0
	If cornerdata<>"" Then
		'Print"cornerdata ausgabe = ";quote(cornerdata)
		Tracktab(k+tracktab_offset,j)=cornerdata ' bernehmen
		'Print"cornerdata ausgabe = ";quote(cornerdata):GetKey
	EndIf
EndIf
	
End Sub

Function GetDigits (ByVal inline As String) As String
' extrahiert Zahlen aus String	
Dim As String number, digits = "0123456789"
Dim chk As String*1
Dim As Integer i,l

l=Len(inline)
For i=1 To l
	chk = Mid(inline,i,1)
	If InStr(digits,chk)>0 Then number = number + chk
Next

'Print "Number = ";quote(number)
Return number	
End Function

Sub GetTrackGpaedia (track As integer)

Dim TrackLabel(1 To 17) As String => {"666 "+NAK,"667 "+NAK,"668 "+NAK,"671 "+NAK,"672 "+NAK,_
 "673 "+NAK,"674 "+NAK,"675 "+NAK,"676 "+NAK,"677 "+NAK,"678 "+NAK,"679 "+NAK,"680 "+NAK,_
 "681 "+NAK,"682 "+NAK,"683 "+NAK,"684 "+NAK}
'Marken pro Track (1-17)
Dim As String pruef, puffer, trackinfo_name, trackinfo_txt
Dim As Integer i,j,k,l,n,m,lci,max,fertig,modus_save
 	 	
i=track : j=GPTrack(i)
max = UBound(track_header)
lci=Len(circuit_info(gps_lng))
	
	If i=1 Then 
		Tracktab(3,GPTrack(i))=Trim(Mid(zeile,6)," ")
		Print i,j,zeile
	Else'die erste Marke wurde bereits eingelesen
	'Weiterlesen bis zur Marke fr 1. Zeile der Streckendaten
		Do While Not Eof(f1)
			Line Input #f1,zeile
			'If i=12 Then Print i,quote(zeile):getkey	
			If Eof(f1) Then 
				Print quote(Tracklabel(i))+ "not found - EOF",quote(zeile)
				Sleep:End 
			EndIf
			If Left(zeile,5)=TrackLabel(i) Then 
				trackinfo_name=Mid(zeile,6)
				Exit Do
			EndIf		
		Loop	
		
		Tracktab(3,j)=Trim(trackinfo_name)
		Print i,j,zeile
				
	EndIf

'Print i,"Tracklabel = ";Tracklabel(i)
'Print i,"Zeile = ";quote(zeile)

	k=4
   Do 
   	Line Input #f1,zeile
   	if Eof(f1) Then Print "Track-Header ";track_header(k,0);" not found - EOF":Sleep:End
   	If Trim(zeile)="" Then Continue Do
   	If zeile = NAK Then Exit Do
		If Right(zeile,1) = NAK Then 
			zeile = Trim(zeile,NAK)
			fertig = 1
		EndIf
		
  		'If Left(zeile,lci)=circuit_info(gps_lng) Then 
  			'Print quote(zeile),lci;quote(circuit_info(gps_lng)):getkey
  			'GoTo trackinfofile
  		'EndIf
   	
   	pruef=track_header(k,0) : m = Len(pruef)
   	   'Print i;" zeile = ";quote(zeile)
     		'Print "   pruef = ";quote(pruef)
   	If chkheader(zeile,"track",k,m)>0 Then
   		'Print quote(pruef),"chkheader track:";k,quote(zeile),m
   		puffer=Trim(mid(zeile,m+1))
   		'Print "puffer = ";quote(puffer),m
   		'print "=key=":GetKey
   		If pruef = season + " GP:" And k+1<max Then
   			If track_header(k+1,0) = "GP Date" And track_header(k+2,0) = "Laps" Then
   				l=InStr(puffer,"(")
   				TrackTab(k+1,j)=Left(puffer,l-1) ' Datum
   				TrackTab(k+2,j)=Str(Val(Mid(puffer,l+1))) ' Laps
   				'Print i, "zeile = ";quote(zeile)
   				'print "GP Date =";quote(tracktab(k+1,j))," Laps = ";Laps
   				k=k+3
   				Continue Do
   			EndIf
   		EndIf
   		
   		If pruef = circuit_info(gps_lng) And trackinfo_file <> "" Then
				'wenn in ini spezifiziert
				'im Namen fr die Trackinfo-Datei %trackname% bzw. %tracknum% ersetzen
				'%trackname% durch Name aus Tracktab(1,tracknr), %tracknum% durch track(nr)
				'Print "trackinfo_file = ";quote(trackinfo_file)
				'Print "Trackname = ";Tracktab(1,i)
				trackinfo_txt = StrReplace(trackinfo_file,"%trackname%",Trim(Tracktab(1,j)))
				trackinfo_txt = StrReplace(trackinfo_txt,"%tracknum%",Str(j))
   			trackinfo_txt = outpath + trackinfo_txt
   			'Print "trackinfo_txt = ";quote(trackinfo_txt)
   			modus_save = modus : modus = 1
   			Textout(trackinfo_txt,"",1,NAK,0)
   			'GetKey
   			modus = modus_save
   		Else
  				Tracktab(k,j)=puffer
	     		'Print i;quote(zeile);Tab(40);"pruef = ";quote(pruef)
	     		'Print i;k;Tab(10);track_header(k,0);quote(Tracktab(k,i)),"=key=":GetKey
   		EndIf
	     	
	     	n=k
	  		If k<max Then
	  			k+=1
	  			If k=info_row Then Exit Do '#info markiert Ende TrackGpaedia/Anfang Trackrecords
	  		EndIf
   	Else
   		Tracktab(n,j)=Tracktab(n,j) + CrLf + Trim(zeile)
   		'Print n,quote(tracktab(n,i))
   	EndIf	
   	If fertig > 0 Then Exit Do
   Loop 

subend:   
End Sub

Sub GetTeamData (team As Integer)
Dim TeamLabel(1 To 11) As String => {"685 "+NAK,"686 "+NAK,"687 "+NAK,"688 "+NAK,_
"689 "+NAK,"690 "+NAK,"691 "+NAK,"692 "+NAK,"693 "+NAK,"694 "+NAK,"695 "+NAK}
Dim As Integer i,j,k,n,m,max,fertig
Dim As String pruef, puffer

i=team : j = GPTeam(i) 
k=3 : max = UBound(team_header)

	Do While Not Eof(f1)
		Line Input #f1,zeile
		If Eof(f1) Then Print "Teamlabel ";Teamlabel(i);" not found - EOF":Sleep:End
		If Left(zeile,5)=TeamLabel(i) Then 
			Print Teamtab(0,i), j, zeile
			Exit Do
		EndIf
	Loop
	puffer = Mid(zeile,6)
	pruef = team_header(k,0) : m=Len(pruef)
	'Print quote(pruef),quote(puffer):GetKey
	If Left(puffer,m)= pruef Then 
		Teamtab(k,j)=Trim(Mid(puffer,m+1))
		'Print team_header(k,0),Teamtab(k,j)
	EndIf
	k=4	
   Do 
   	Line Input #f1,zeile
   	if Eof(f1) Then Print "Track-Header ";track_header(k,0);" not found - EOF":Sleep:End
   	If Trim(zeile)="" Then Continue Do
   	If zeile = NAK Then Exit Do
		If Right(zeile,1) = NAK Then 
			zeile = Trim(zeile,NAK)
			fertig = 1
		EndIf
   	'pruef=team_header(k,0) : m = Len(pruef)
   	If chkheader(zeile,"team",k,m)>0 Then 
   		Teamtab(k,j)=Trim(Mid(zeile,m+1))
   		n=k
   		If k<max Then k=k+1
   	Else
   		Teamtab(n,j)=Teamtab(n,j) + CrLf + Trim(zeile)
   	EndIf	
   	If fertig > 0 Then Exit Do
   Loop 	

End Sub
Sub GetDriverData (driver As Integer)

Dim DriverLabel(1 To 22) As String => {"696 "+NAK,"697 "+NAK,"698 "+NAK,"699 "+NAK,"701 "+NAK,"702 "+NAK,_
"704 "+NAK,"705 "+NAK,"706 "+NAK,"708 "+NAK,"709 "+NAK,"712 "+NAK,"713 "+NAK,"716 "+NAK,"719 "+NAK,_
"1135 "+NAK,"1136 "+NAK,"1137 "+NAK,"1138 "+NAK,"1272 "+NAK,"1451 "+NAK,"1477 "+ NAK}
Dim As Integer i,j,k,n,m,max,fertig
Dim As String pruef, puffer

max = UBound(driver_header)':Print "max =";max
i=driver : j=GPDriverInfo(i)
Do While Not Eof(f1)
	Line Input #f1,zeile':Print quote(zeile)
	If Eof(f1) Then Print "Driverlabel ";Driverlabel(i);" not found - EOF":Sleep:End
	n=Len(Driverlabel(i))
	If Left(zeile,n)=Driverlabel(i) Then
		If Driverlabel(i)="719 "+NAK Then Textout(outfile(8),"",1,"1130 "+NAK,0)
		Exit Do
	EndIf
Loop
'Print i, zeile

k=3
Do 
  	Line Input #f1,zeile':Print quote(zeile)
  	if Eof(f1) Then Print "Driver-Header ";driver_header(k,0);" not found - EOF":Sleep:End
  	If Trim(zeile)="" Then Continue Do
  	If zeile = NAK Then Exit Do
	If Right(zeile,1) = NAK Then 
		zeile = Trim(zeile,NAK)
		fertig = 1
	EndIf
 '	pruef=driver_header(k,0) : m = Len(pruef)
  	
  	If chkheader(zeile,"driver",k,m)>0 Then 
  		Drivertab(k,j)=Trim(Mid(zeile,m+1))
  		'Print i;j;k;Tab(10);quote(zeile);Tab(45);"pruef = ";quote(pruef);Tab(85);quote(Drivertab(k,j))
  		n=k
  		If k< max Then k=k+1
  	Else
  		'Print "keine headerzeile: ";quote(zeile)
  		Drivertab(n,j)=Drivertab(n,j) + CrLf + Trim(zeile)
  		'Print "k, Zeile:";k;quote(zeile);
  		'Print " pruef = ";quote(pruef)
  		'Print " Tab   = ";quote(Drivertab(k,j))
  	EndIf	
  	If fertig > 0 Then Exit Do
Loop 	
	'Print "Exit:";quote(zeile):getkey
End Sub
Sub Textout (outfile As String, StartLabel As String,StartOption As Integer, ExitLabel As String,ExitOption As integer)
'Direktausgabe von Zeilen aus gps-Datei in Textdatei outfile - nur bei modus 1
'Startlabel: Marke, bei der die Ausgabe beginn; wenn leer, dann sofort
'StartOption = 1: inclusiv, d.h. die erste Zeile ist schon eingelesen (bei voriger Textausgabe), 0=exclusiv 
'ExitLabel: Marke, bei der die Ausgabe endet
'ExitOption = 1: inclusiv, d.h. die Zeile mit dem ExitLabel gehrt zum Text, 0=exclusiv

If modus > 0 Then
	If outfile = "" Then
		error_print("Empty file name "+quote(outfile),red)
		GoTo subend
	EndIf
	f2=FreeFile
	Select Case OPEN (outfile For Output Encoding("UTF-16") As #f2)
		CASE 0
			' ok
		Case 2
			' not found: wird erstellt
		Case Else
			error_print("Error when opening file "+outfile,red)
			Close #f2
			GoTo subend
	END Select
EndIf	
	
	If StartLabel<>"" Then 
	Do While Not(Eof(f1))
		Line Input #f1,zeile
		If Eof(f1) Then 
			error_print("Startlabel "+Startlabel+" not found - EOF",red):Sleep:End
		EndIf
		If Left(zeile,Len(StartLabel))=StartLabel Then Exit Do 'vor bis Startlabel
	Loop
	EndIf
	
If modus >0 Then
	If StartOption = 1 Then Print #f2,zeile 'die erste Zeile ist schon eingelesen worden
EndIf

	Do While Not(Eof(f1))
		Line Input #f1,zeile
		'Print zeile:getkey
		If Eof(f1) Then 
			If ExitLabel="2125 "+NAK Then 
				Print "Normal EOF"
			Else
				error_print("Exitlabel "+Exitlabel+" not found - EOF",red):Sleep:End
			EndIf
		EndIf
		'Print quote(Left(zeile,Len(exitlabel))),quote(exitlabel):getkey
		If Left(zeile,Len(ExitLabel))=ExitLabel Then 
			If modus > 0 Then If Exitoption = 1 Then Print #f2,zeile
			Exit Do	
		EndIf
		If modus > 0 Then Print #f2,zeile
	Loop 
	If modus > 0 Then 
		Close #f2
		Print"Text file ";quote(outfile); " created."
	EndIf
	
subend:	  	
End Sub

Sub chktext(txtfile As String)
	'prft auf CRLF am Ende in UTF-16 Textdatei
Dim As Integer f4,anzahl,hi,low,test,pruef=13*4096+16*10
Dim As Byte x
Dim As UShort xcr,xlf

If Not FileExists(txtfile) Then
	error_print ("File not found " + quote(txtfile),red)
	GetKey 
	Exit Sub		
EndIf

check:
'Print "checking ";quote(txtfile)
	f4 = FreeFile
	Open txtfile For Binary As #f4
	
	anzahl = Lof(f4)
	'Print quote(txtfile),anzahl;" Bytes"
	Get #f4,anzahl-3,xcr
	Get #f4,,xlf
	'hi=HiByte(xcr):low=LoByte(xcr)
	'Print xcr, hi;" / ";low
	'hi=HiByte(xlf):low=LoByte(xlf)
	'Print xlf, hi;" / ";low
	test=xcr*4096 + 16*xlf':Print (test = pruef)
Close #f4	

If Not(test = pruef) Then
	error_print (quote(txtfile)+ " no CRLF at end of file",red)
	Print "--- Critical text file error found. Press any key to break ---"	
	Close #f1
	GetKey:End
EndIf

End Sub
Function chkvalue (ByVal value As String) As Integer
' prft auf "0" oder "1"	
Dim result As Integer
	
If value = "0" Or value = "1" Then 
  		result = 1
	Else
  		result = 0
	End If

Return result
End Function

Function chkvalue2 (ByVal value As String) As Integer
' prft auf "0" oder "1"	
Dim result As Integer
	
If value = "0" Or value = "1" Or value = "2" Then 
  		result = 1
	Else
  		result = 0
	End If

Return result
End Function
Function chkpath(ByVal path As String) As Integer
' prft Verzeichnis	
Dim result As Integer
	
If Dir(path & "*") <> "" Then 
	result = 1
Else
	result = 0
End If

Return result
End Function

Function chkheader(ByVal zeile As String, ByVal typ As String, ByVal index As Integer, ByRef chklen As integer) As Integer
' prft, ob zeile header enthlt
Dim As Integer i, result, m1, dr_dim, te_dim, tr_dim
Dim As String header(0 To header_dim),hpruef(0 To header_dim), puffer
'Print typ,"header_dim = ";header_dim, "index = ";index

If typ = "driver" Then
	For i=0 To header_dim
		header(i)=driver_header(index,i)
	Next
ElseIf typ = "team" Then
	For i=0 To header_dim
		header(i)=team_header(index,i)
	Next
ElseIf typ = "track" Then
	For i=0 To header_dim
		header(i)=track_header(index,i)
	Next
Else
	chklen=0
	Return result
EndIf

i=0
Do While i<=header_dim
	hpruef(i) = LCase(Trim(header(i))) : m1 = Len(hpruef(i)) : puffer = LCase(Left(Trim(zeile),m1))
	If hpruef(i)="" Then Exit Do
	'Print "zeile = ";quote(zeile),"m1=";m1
	'Print i;Tab(10);"pruef =";quote(hpruef(i));Tab(40);"puffer=";quote(puffer):getkey
	If hpruef(i) = puffer Then
		chklen = m1
		result = 1
		'Print "chkheader ";i,quote(zeile);" hpruef(i)=";quote(hpruef(i));" Len=";chklen," result=";result:GetKey
		Exit Do
	EndIf
	i+=1
Loop

'Print typ;" chkheader ";quote(zeile);Tab(30);"result=";result;Tab(60);"Len=";chklen:getkey
Return result
End Function

Function  InCount(ByVal wordlist As String, ByVal Delimiter As String) As Integer
'Ermittelt die Anzahl der Wrter = 1 + wie oft der Delimiter-String vorkommt im String Wortliste
Dim As Integer x,z,count
z=0:x=1

Do
	x=x+z
	z=InStr(Mid(wordlist,x),delimiter)
	'Print z,Chr(34);Mid(wordlist,x);Chr(34)
	count +=1
Loop While z<>0

'Print Count;"-mal"
Return count
End Function

