'--- gps2txt_ff.bas ---
#Include "vbcompat.bi"
'Liest GPS-Datei aller Sprachen (je nach Auswahl in der INI Datei) sequentiell,
'stellt Fahrer-,Team-,Strecken-Daten fr Ausgabe in CSV bereit,
'schreibt nicht zu verndernden Text in Textdateien (z.B: en_part1.txt, ..., en_part8.txt)
'erstellt ggf. Textdateien mit Streckeninformationen
'div. Parameter aus INI-Datei (gps_modes (gps_lng) ==> modus 0,1,2,3: 0=nix, 1=CSV, 2=Text, 3=beides) 
'Da mit den Routinen UTF2STR bzw. STR2UTF gearbeitet wird, werden auch Sonderzeichen korrekt dargestellt;
'dies gilt ev. nicht bei der Ausgabe auf den Bildschirm.

On Error GoTo errorhandler
Const version = " 1.32 ", Fenstertitel = "GPS to CSV"

'-- Deklarationen --
Dim Shared As UShort xx, bom = &hfeff,  wCr = &h000D, wLf = &h000A, wNAK = &h0015
Dim Shared As ULong wCrLf = &h000A000D
Dim Shared As Integer scr_w, scr_h,f1,f2,f3,i,k,l,m,n,errnr, errfn, errln, errors, result, tracknum, errorcount, filecount, dspcol
Dim Shared As String zeile,puffer,pruef, pruef2
Dim Shared As String gps_ini, csvfile, log_file, gpaedia_log
Dim Shared As String progpath, inpath, inpath_, season, gps_file, gpsfile, ascii_gpsfile, form_file, formfile, outpath, trackinfo_file, out_trackinfo, trackinfo_trans, lng_lst 'werden aus ini ermittelt
'Dim Shared As String*3 _modus="csv" 'optional aus ini eingelesen
Dim Shared As String driver_team_delim, country_town_delim 'optional aus ini eingelesen
driver_team_delim="\" : country_town_delim=" \ "
Dim Shared As String driver_header(), team_header(), track_header() ' werden aus Format-Datei form_file eingelesen
Dim Shared As integer dr_header(), te_header(), tr_header() ' Benutzung (0/1) des headers 
Dim Shared As Integer gps_lng, modus, txtmodus, csvmodus, driver_rows, team_rows, track_rows, info_row, tracktab_offset, corner_rows, header_dim
Dim Shared As Integer txt_count, circuit_count, csv_count,ky
Dim Shared As String*2 lng(4) => {"en","de","es","fr","it"}
Dim Shared As String*1 lng_list(4) => {"1","0","0","0","0"}, log_extended = "0", ignore_linkdata = "0"
Dim Shared As String*8 language(4) => {"English", "Deutsch", "espaol", "Franais", "italiano"} 
Dim Shared As String*8 ascii_language(4) => {"English", "Deutsch", "espa" & Chr(&h00a4) & "ol", "Fran" & Chr(&h0087) & "ais", "italiano"}
Dim Shared As String circuit_info(0 To 4),unames() 

Dim Shared outfile(1 To 11) As String

'In GPaedia werden Fahrer,Team,Strecke in anderer Reihenfolge dargestellt
'Die folgenen Listen stellen die Zuordnung zu der Standardreihenfolge her
Dim Shared GPDriver(1 To 22) As Integer => {1,2,3,4,5,15,6,7,8,20,14,9,11,16,12,17,13,10,18,22,21,19}
Dim Shared GP_Driver(1 To 22) As Integer => {1,2,3,4,5,7,8,9,12,18,13,15,17,11,6,14,16,19,22,10,21,20}
Dim Shared GPDriverInfo(1 To 22) As Integer => {3,4,1,2,12,17,5,8,7,11,15,18,13,9,6,16,14,19,10,21,20,22}
Dim Shared GP_DriverInfo(1 To 22) As Integer => {3,4,1,2,7,15,9,8,14,19,10,5,13,17,11,16,6,12,18,21,20,22}
Dim Shared GP_Team(1 To 11) As Integer => {2,1,6,9,3,4,11,8,7,10,5}
Dim Shared GPTeam(1 To 11) As Integer => {2,1,5,6,11,3,9,8,4,10,7}
Dim Shared GPTrack(1 To 17) As Integer => {1,17,2,3,5,10,7,8,6,9,4,11,12,13,14,15,16}
Dim Shared GP_Track(1 To 17) As Integer => {1,3,4,11,5,9,7,8,10,6,12,13,14,15,16,17,2}
Dim Shared GPTrackRec(1 To 17) As Integer => {1,3,4,11,5,9,7,8,10,6,12,13,14,15,17,16,2}
Dim Shared GP_TrackRec(1 To 17) As Integer => {1,17,2,3,5,10,7,8,6,9,4,11,12,13,14,15,16}
Dim Shared Driver_Label(1 To 22) As String 'driverlabel global
Dim Shared gear_word(4) As String
Dim Shared it_gear(9) As String
Dim Shared UTF_ANSI(0 To 7,2) As UShort
Dim Shared Drivertab() As String '22 Fahrer (als Spalten), Zeilen siehe ReadFormat
Dim Shared Teamtab() As String '11 Teams (als Spalten), Zeilen siehe ReadFormat
Dim Shared Tracktab() As String '17 Tracks (als Spalten), Zeilen siehe ReadFormat
Dim Shared Track_tab() As String '17 Tracks (als Spalten), Zeilen = Tacktab() minus "Circuit Info"
Dim Shared Driverteam(23) As String '23 Teams aus driverdata (nur zum Prfen, nicht benutzt in txt2gps
Dim Shared Driver_team(22) As String 'Teams aus Tabelle "driver \ teams"
'Count UTF critical characters 
Dim Shared UTF_incount(0 To 7) As Integer
Dim Shared UTF_outcount(0 To 7) As Integer

'Prozeduren und Funktionen
Declare Sub ReadIni 'Einlesen von Werten aus der Ini-Datei (gps_%season%.ini)
Declare Sub ReadFormat 'Einlesen der Format-Datei "gps.txt"
Declare Sub InitLang 'Sprachspezifische Daten einlesen (Circuit_info)
Declare Sub InitTabs 'Initialisierung von Datenfeldern fr CSV
Declare Sub Textout (outfile As String, StartLabel As String, StartOption As Integer, ExitLabel As String, ExitOption As integer) 
 'Zeilen unverndert in Textdatei ausgeben     
Declare Sub GetTrackRecords (gptracknum As Integer) 'Strecken-Rekorde pro Strecke einlesen
Declare Sub GetCornerData (gptracknum As Integer) 'Kurvendaten pro Strecke einlesen
Declare Sub GetTrackGpaedia (gptracknum As Integer) 'Kurvendaten pro Strecke einlesen
Declare Sub GetTeamData(gpteamnum As Integer) 'Teamdaten pro Team einlesen 
Declare Sub GetDriverData (gpdrivernum As Integer) 'Fahrerdaten pro Fahrer einlesen 
Declare Sub GetLinkdata 'Linkdaten (Fahrer, Team, Land der Strecke) einlesen
  
Declare Sub MakeTXT(gpsfile As String)  
Declare Sub WriteCSV(s() AS  STRING, Datei AS  STRING, TZ AS  STRING, TT As String, conv AS  INTEGER)
Declare Sub error_print(zeilen As String, colour As Integer) ' Fehler ausgeben (rot auf Bildschirm)
Declare Sub chktext(txtfile As String)
Declare Sub Str2UTF(zkette As string, f As Integer,zende As string)
Declare Sub readspecial(specialfile As String)
Declare Sub utf_in_summary
Declare Sub utf_Out
                        
Declare Function SubStr(byVal  Liste As  String, byVal  Trenner As  String, ByVal Stelle As  Integer) As  String
Declare Function InCount(ByVal wordlist As String,ByVal Delimiter As String) As Integer
Declare Function StrReplace (Byval StrEx as String, Byval StrMask as String, Byval StrRplce as String) as String
Declare Function Replace(ByVal V_Data As String, ByVal V_Expression As String, ByVal V_ReplaceBy As String) As String                                      
Declare Function quote(ByVal chkstr As String) As String
Declare Function GetDigits(ByVal inline As String) As String
Declare Function Chkpath(ByVal path As String) As Integer
Declare Function chkvalue (ByVal value As String, allowed As String) As Integer
Declare Function chkheader(ByVal zeile As String, ByVal typ As String, ByVal index As Integer, ByRef chklen As Integer, ByRef headerdim As Integer) As Integer
Declare Function chkgear(gearword As String) As Integer
Declare Function getgear(geardata As String) As String
Declare Function utf2ansi(unicode As short) As Short
Declare Function ansi2utf(ansicode As Short) As Short
Declare Function UTF2Str(f As Integer) As String
Declare Function extpath(filename As String) As String
Declare Function makedir(curdir_path As String,subfolder As string) As Integer
Declare Function tag_entries(ByVal txtfile As String) As Integer
Declare Function Lnamecase(getname As String) As String

Const NAK=Chr(21), LF=Chr(10), CrLf = Chr(13), red = 12, ylw=14, wht=15

'--- Hauptprogramm ---
'GoTo weiter
''Screen 19
ScreenInfo scr_w, scr_h
'scr_w=640:scr_h=480
If scr_w >= 800 Then scr_w = 800
If scr_h >= 800 Then scr_h = 800
ScreenRes  scr_w, scr_h
Width Int(scr_w/8), Int(scr_h/16)
WindowTitle Fenstertitel
weiter:

'For i=0 To 4
'	Print i,lng(i),ascii_language(i)
'Next
'GetKey:end

log_file = "gpaedia"

' gps_ini kann als Argument bergeben werden
If Command$(1) <> "" Then 
	gps_ini = Command$(1)
Else
'	gps_ini = "d:\gp4\gpaedia\gps2txt_ff\1993\gps_1993_ignore.ini"
'	gps_ini = "e:\gpaedia\gps2txt_ff\indycar2017\gps_indy_2017_test124.ini"
'	gps_ini = "d:\gp4\gpaedia\gps2txt_ff\2001org\gps_2001org.ini"
	gps_ini = "d:\gp4\gpaedia\gps2txt_ff\2018\gps_2018b.ini"
EndIf

Print "=== gps2txt_ff";version;"==="

InitLang
'Default-Werte fr INI setzen
gps_lng = 0
season = "2001"
progpath = ExePath 
ReadIni 'Einlesen Ini_Datei (gps_ini)

'Logdatei ffnen
f3=FreeFile
Print
gpaedia_log = outpath + log_file + ".log"
If FILEEXISTS(gpaedia_log) Then Kill gpaedia_log
Select Case OPEN (gpaedia_log For Output As #f3)
	Case 0
		Print "logfile ";quote(gpaedia_log)+ " opened for output - ok"
	Case 2
	'not found
	Case Else
		error_print("Error when opening logfile " & quote(gpaedia_log),red)
		'Close #f3
		GoTo ende
End Select	

Print #f3, "=== ";log_file;".log ==="
Print #f3, "logfile for gps2txt_ff version" & version
Print #f3, "processing ";quote(StrReplace(gps_ini,progpath+"\",""))
Print #f3,
Print #f3,"INI file settings:"
n=20
Print #f3,"progpath";tab(n);" = ";quote(progpath)
Print #f3,"inpath";tab(n);" = ";quote(inpath)
Print #f3,"outpath";tab(n);" = ";quote(outpath)
Print #f3,"trackinfo_file";tab(n);" = ";quote(trackinfo_file)
Print #f3,"trackinfo folder";tab(n);" = ";quote(out_trackinfo)
Print #f3,"trackinfo_trans";tab(n);" = ";quote(trackinfo_trans)
Print #f3,"gps file";tab(n);" = ";quote(gps_file)
Print #f3,"form file";tab(n);" = ";quote(form_file)
Print #f3,"gps modes";tab(n);" = ";quote(lng_lst)
Print #f3,"ignore_linkdata";tab(n);" = ";quote(ignore_linkdata)
Print #f3,"driver-team delim.";tab(n);" = ";quote(driver_team_delim)
Print #f3,"country-town delim.";tab(n);" = ";quote(country_town_delim)
Print #f3,"log file";tab(n);" = ";quote(log_file)
Print #f3,"log extended";tab(n);" = ";quote(log_extended)
Print #f3,

'Datei %trackinfo_trans% lesen, falls in INI definiert 
readspecial(trackinfo_trans)

Print #f3, String(80,"-")
Print String(80,"-")

'Erstellen der CSV- und/oder Text-Dateien
filecount=0

For gps_lng=0 To 4
	modus=Val(lng_list(gps_lng))
	If modus>0 Then
		csvmodus = modus And 1
		txtmodus = (modus And 2)/2
		'Print "gps_lng=";gps_lng, "modus=";modus, "csvmodus=";csvmodus, "txtmodus=";txtmodus
		'Print "language=";language(gps_lng), "ln=";lng(gps_lng)
		'Print "gps_file=";gps_file
		gpsfile = StrReplace(gps_file,"%ln%",lng(gps_lng))
		gpsfile = StrReplace(gpsfile,"%language%",language(gps_lng))
		ascii_gpsfile = StrReplace(gpsfile,language(gps_lng),ascii_language(gps_lng)) 'fr Ausgabe auf Screen
		'Print "gpsfile=";quote(gpsfile)
		'Print "ascii_gpsfile=";quote(ascii_gpsfile)
		'GetKey
		If FileExists(gpsfile) Then
			'Print "gpsfile = ";quote(gpsfile)
			Print #f3, "gpsfile No.";filecount+1; " / modus=" & modus;": language=" & gps_lng & " " & lng(gps_lng); ", csvmodus=" & csvmodus; ", txtmodus=" & txtmodus
			Print #f3,
			MakeTXT(gpsfile)
			Print String(80,"-")
			Print #f3, String(80,"-")
		Else
			error_print ("gpsfile " + quote(gpsfile) + " not found",red)
			Print #f3, ">>> gpsfile " + quote(gpsfile) + " not found" 
			errors +=1
		EndIf	
	EndIf
Next

Print filecount & " gpsfiles processed"
Print #f3, filecount & " gpsfiles processed"

ende:
Close #f1

If errors > 0 Then error_print(errors & " errors",ylw)
Print:Print"Detailed Information in logfile "+quote(gpaedia_log)
If errorcount > 0 Then 
	dspcol=ylw
Else
	dspcol=wht
EndIf
error_print(errorcount & " errors or warnings in log file",dspcol)
Print #f3, errorcount & " errors or warnings in log file"
Close #f3
Print"--- press space to view log, any other key to quit ---"

k=GetKey
'Print k:Sleep:end
If k=32 Then 
	If FILEEXISTS(gpaedia_log) Then
		Shell ("notepad.exe " + gpaedia_log)
	EndIf
EndIf

End	
	
errorhandler:
errnr = Err
errfn = *Ermn
errln = Erl
'Print #f3, ("Error " &Err &" in function " &*Ermn &" in line " &Erl)
'Print #f3, "--- Program stopped ---"
'Close #f3

Print("Error " &errnr &" in function " &errfn &" in line " &errln)
Print "--- press any key to stop ---"
GetKey:End

'Daten einlesen:
Data "Circuit Info:","Streckeninfo:","Informacin sobre el circuito:","Caractristiques :","Note sul tracciato:",_
"Gear "," Gang","Marcha ","Vitesse  ","",_
"Prima","Seconda","Terza","Quarta","Quinta","Sesta","Settima","Ottava","Nona",_  
&h2019,&h0092,&h0027,_
&h201c,&h0093,&h0022,_
&h201d,&h0094,&h0022,_
&h0153,&h009c,&h0153,_
&h2018,&h0091,&h0027,_
&h0152,&h008c,&h0152,_
&h201e,&h0084,&h0022,_
&h2026,&h0085,&h2026
Sub MakeTXT(gpsfile As String)

Dim As Integer i,k,j,l,m,n,circuit_info_row,parttxt_count
Dim As UShort xx
Dim As String pruef, pruef2, puffer, puffer2

txt_count=0
circuit_count=0
csv_count=0

'Initialisiere UTF-in Zhler
For i=0 To 7
	utf_incount(i)=0
Next

if csvmodus > 0 Then
	Readformat 'Einlesen der Formate (header) aus form_file
	'Print "info_row = ";info_row
	InitTabs 'Tabellen initialisieren (Zeilen- und Spaltenkpfe), braucht header aus Readformat
EndIf

'--- GPS Datei lesen ---
f1=FreeFile
'print
Select Case OPEN (gpsfile For Binary As #f1) 'lese gps binary
	CASE 0
		Print "gpsfile ";quote(ascii_gpsfile);" opened binary - ok"
		Print #f3,"Gpsfile ";quote(gpsfile);" opened binary - ok"
	Case 2
		error_print("gpsfile " & quote(ascii_gpsfile) & " not found.",red)
		Print #f3,">>> Gpsfile ";quote(gpsfile);" not found."
		'Close #f1
		GoTo endsub
	CASE Else
		error_print("Error when opening gpsfile " & quote(ascii_gpsfile),red)
		Print #f3,">>> Error when opening gpsfile ";quote(gpsfile)
		'Close #f1
		GoTo endsub
END Select

Get #f1,,xx 'die ersten beiden Zeichen (Unicode-Kennung)
If xx <> bom Then
	Print Hex(xx,4),Hex(bom,4)
	error_print(quote(gpsfile) + " has not UTF-16 file format",red)
	Print #f3, Hex(xx,4),Hex(bom,4)
	Print #f3, quote(gpsfile) + " has not UTF-16 file format"
	errorcount += 1
	GoTo endsub
EndIf	

'Pfad + Name fr Ausgabedateien sprachspezifisch:
if txtmodus > 0 Then
	'print
	'Print "Init filenames for output"
	Print #f3,:Print #f3, "Init filenames for output:"
	For i=1 To 11
		outfile(i)=outpath+lng(gps_lng)+"_"+"part"+str(i)+".txt"
		'Print outfile(i)
		Print #f3, outfile(i)
	Next
	'Print
	Print #f3,
EndIf

'-- 1. Teil: Alle Zeilen bis 1. Kennung in 1. Textdatei schreiben
Textout(outfile(1),"",0,"1767 "+NAK,1)

'-- 2. Teil: Fahrer\Team Daten in Array Drivertab aufnehmen
if csvmodus > 0 Then
	i=0
	'Print:Print "Driver (No.,GP-Info-No.,Name,Team)"
	Print #f3,:Print #f3, "Driver Num.,Name,Team):"
	Do While Not(Eof(f1))
		i=i+1
		zeile = UTF2Str(f1)
		'Print i,quote(zeile)
		If Eof(f1) Then 
			Print #f3,">>> Driver table not found - EOF"
			error_print("Driver table not found - EOF",red):Sleep:End
		EndIf
		pruef=Left(zeile,1)
		'Print "Zeile=";quote(zeile),"pruef=";quote(pruef),
		If pruef=NAK Then Exit Do 'Zeile nach Driver\Teams oder letzte Zeile erreicht
		If i=1 Then 
			puffer=Mid(zeile,4)
		Else puffer=zeile
		EndIf
		'Print "==> puffer = ";puffer, "driver_team_delim =";driver_team_delim
		Drivertab(1,i)=Trim(SubStr(puffer,driver_team_delim,1))
		Driver_Team(i)=Trim(StrReplace(SubStr(puffer,driver_team_delim,2),NAK,""))
		'Print "Driver_team=";quote(Driver_Team(i))
		'm=InStr(Driver_team(i),Space(1))
		'If m>0 Then
		'	Drivertab(2,i)=Left(Driver_Team(i),m) 'kurz
		'Else
		Drivertab(2,i)=Driver_Team(i)
		'EndIf
		'Print i,GPDriverInfo(i),drivertab(1,i) + ", " + drivertab(2,i)
		Print #f3, i,drivertab(1,i) + ", " + drivertab(2,i)
		pruef2=Right(zeile,1)
		'Print "pruef2=";quote(pruef2)
		If pruef2 = NAK Then 
			'Print "Exit in Zeile ";zeile,quote(pruef),quote(pruef2)
			Exit Do
		EndIf
		If Eof(f1) Then 
			print#f3,">>> End of driver table not found - EOF"
			error_print("End of driver table not found - EOF",red):Sleep:End
		EndIf
	Loop 

	Print #f3,
EndIf

'-- 3. Teil: Alle Zeilen bis vor GPaedia - Driver\Teams in 2. Textdatei schreiben   
Textout(outfile(2),"45 "+NAK,1,"2163 "+NAK,1)

'-- 4. Teil: Alle Zeilen bis nach GPaedia - Driver\Teams
' und vor Tracks \ Country in 3. Textdatei schreiben   

Textout(outfile(3),"13 "+NAK,1,"1445 "+NAK,1)

'-- 5. Teil: Tracks\Country auslesen
'Print "Tracks (Tracknum.,Name,Country)"
If csvmodus > 0 Then
	Print #f3,:Print #f3,"Tracks (No.,Name,Country):"
	i=0
	Do While Not(Eof(f1))
		zeile = UTF2Str(f1)
		If Eof(f1) Then 
			Print #f3,">>> Track table not found - EOF"
			error_print("Track table not found - EOF",red):Sleep:End
		EndIf
		i=i+1
		puffer=SubStr(zeile,NAK,2)'rechts und links weglassen
		'Print "puffer=";quote(puffer):GetKey
		Tracktab(1,i)=Trim(SubStr(puffer,country_town_delim,1)) 'Track
		'Print "track=";quote(tracktab(1,i));Tab(40);
		Tracktab(2,i)=Trim(SubStr(puffer,country_town_delim,2)) 'Country
		'Print "country=";quote(tracktab(2,i))
		Print #f3,i;Tab(5);Tracktab(1,i);Tab(30);Tracktab(2,i)
		If Left(zeile,4)="37 "+NAK Then Exit Do 'letzte Zeile von Track\Country
	Loop
	Print #f3, 
	'Print "--- key ---":GetKey
EndIf
	
'-- 6. Teil: Alle Zeilen nach Track\Country Trackrecords in 4. Textdatei schreiben   
Textout(outfile(4),"43 "+NAK,1,"950 "+NAK,1)

if csvmodus > 0 Then
	
	'-- 7. Teil: Rekorde der Strecken - Teil 1/2 - auslesen
	'Print"Trackrecords 1-7 (Gpaedia-Num., Track, Trackname, Label+Data)"

	Print #f3,:Print #f3,"Trackrecords 1-7 (Gpaedia-No., Track, Trackname, Label+Data):"
	For i=1 To 7 'Teil 1 = die ersten 7 Strecken
		GetTrackRecords(i)
	Next
	Print #f3,

	'-- 8. Teil: Corner data auslesen
	'Print"Corner data (Gpaedia-Num.,Track,Searchlabel,Header)"
	Print #f3,"Corner data (Gpaedia-Num.,Track,Searchlabel,Header)"
	For i=1 To 17: GetCornerData(i):Next
	Print #f3,

	'-- 9. Teil: Rekorde der Strecken - Teil 2/2 - auslesen
	'Print"Trackrecords 8-17 (Gpaedia-Num., Track, Trackname, Label+Data)"
	Print #f3,"Trackrecords 8-17 (Gpaedia-No., Track, Trackname, Label+Data):"
	For i=8 To 17:	GetTrackRecords(i): Next
	Print #f3,
EndIf	

'-- 10. Teil: ab "179 "+NAK incl. bis  "666 "+NAK excl. in 5.-7. Textdatei (gross!)
Textout(outfile(5),"179 "+NAK,1,"470 "+NAK,1)
Textout(outfile(6),"",0,"2170 "+NAK,1) 'direkt weiter mit 471 (=> edit)
Textout(outfile(7),"",0,"666 "+NAK,0) 'direkt weiter mit 2171

if csvmodus > 0 Then
	
	'-- 11. Teil: anschlieend "666 "+NAK incl. Streckendaten auslesen, dabei
	'          Streckeninfo-Text in Info-Textdatei fr Strecke schreiben
	'Print "Trackinfo data (Gpaedia-Num., Track, Label + Circuit)"
	Print #f3,:Print #f3,"Trackinfo data (Gpaedia-Num., Track, Label + Circuit):"
	For i=1 To 17
		GetTrackGpaedia(i)	
	Next
	Print #f3,

	'-- 12. Teil (anschlieend ab "685 "+NAK): Teamdaten auslesen
	'Print"Teamdata (GPTeam, Team-Num, Teamname)"
	Print #f3,"Teamdata (GpTeam, Team-Num, Teamname):"
	For j=1 To 11
		GetTeamData(j)
	Next
	Print #f3,

	'-- 13. Teil (anschlieend ab "696 "+NAK): Fahrerdaten auslesen
	'		  vor Driver(15) wird dabei die kurze Textdatei 8 ausgegeben 				
	Print #f3,"Driverdata (No.,GPaedia-No.,Label,";quote("Team");" from driverdata, team from driver selection:"
	For j=1 To 22
		i=GP_Driverinfo(j)
		'Print j;Tab(5);i;Tab(10);quote(Drivertab(1,i))
		GetDriverData(j)
	Next

	'Testausgabe Drivers'
	'Print "Drivers (No.,GPaedia-No.,Label,Data)"
	'Print #f3,:Print #f3,"Drivers (No.,GPaedia-No.,Label,Data):"
	Print #f3,
	Print #f3,"Drivers (Driver-Num,GPaedia-Num,Drivername,Driverteam:"
	For j=1 To 22 
		i=GP_Driverinfo(j)
		'Print j;Tab(5);i;Tab(10);Driver_Label(i);Tab(20);Drivertab(1,j);Tab(45);Drivertab(2,j);Tab(80);driverteam(i)
		Print #f3,j;Tab(5);i;Tab(10);Driver_Label(i);Tab(20);Drivertab(1,j);Tab(50);Drivertab(2,j)';Tab(80);driverteam(i)
	Next
	Print #f3,

EndIf
If (Not csvmodus) And txtmodus Then
	TextOut(outfile(8),"719 "+NAK,1,"1130 "+NAK,0)
EndIf

'-- 14. Teil (ab "1558 "+NAK incl. bis "540 "+NAK incl.): in 9. Textdatei
TextOut(outfile(9),"1558 "+NAK,1,"540 "+NAK,1)

'-- 15. Teil: Linkdaten fr driver, team, track
For i=1 To 11
	Teamtab(1,i)=Driver_Team(2*i) 'Team name from driver-team
	Teamtab(2,i)=Teamtab(1,i) 'Kurzname vorlufig = Teamname, spter ggf. durch Teamlink ersetzt
Next
if csvmodus > 0 Then
	Print #f3,
	GetLinkdata
	Print #f3,
EndIf
'Testausgabe Teams' hinter Einlesen der Teamlinks (fr team short)
	'Print "Teams (Team,GPaedia-Num.,Name / Shortname)"
	Print #f3,"Teams (Team,GPaedia-Num.,Name / Shortname):"
	For i=1 To 11
 		'Teamtab(2,i) = Teamname, wird mit teamlink data verglichen und ggf. ersetzt
		'Print i;Tab(5);GPTeam(i);Tab(30);Teamtab(1,i);" / ";teamtab(2,i) 
		Print #f3,i,GPTeam(i),Teamtab(1,i);" / ";teamtab(2,i) 
	Next
	Print #f3,

'-- 16. Teil (nach Linkdaten ab "2129 "+NAK bis Ende ("1554 "+NAK) in 10. Textdatei
Textout(outfile(10),"2129 "+NAK,1,"1554 "+NAK,1)

'-- 17. Teil (nach CloseCountry-Daten ab "1579 "+NAK bis Ende ("2125 "+NAK) in 11. Textdatei
Textout(outfile(11),"1579 "+NAK,1,"2125 "+NAK,1)

'-- 18. Teil: Ausgaben in CSV-Dateien
'Print
Print #f3,

if csvmodus > 0 Then
	csvfile="driver.csv"
	If gps_lng>0 Then csvfile=lng(gps_lng)+"_"+csvfile 
	csvfile=outpath+csvfile
	WriteCSV (Drivertab(),csvfile,";",Chr(34),0) 
	'Print"CSV file ";quote(csvfile);" created"
	Print #f3,"CSV file ";quote(csvfile);" created"
	csv_count+=1
	
	csvfile="team.csv"
	If gps_lng>0 Then csvfile=lng(gps_lng)+"_"+csvfile 
	csvfile=outpath+csvfile
	WriteCSV (Teamtab(),csvfile,";",Chr(34),0)
	'Print"CSV file ";quote(csvfile);" created"
	Print #f3,"CSV file ";quote(csvfile);" created"
	csv_count+=1

	csvfile="track.csv"
	If gps_lng>0 Then csvfile=lng(gps_lng)+"_"+csvfile 
	csvfile=outpath+csvfile
	'"Circuit info" Zeile nicht bernehmen:
	pruef=Trim(RTrim(circuit_info(gps_lng),":"))
	For k=0 To track_rows
		'Print k,quote(tracktab(k,0)),quote(pruef)
		If tracktab(k,0)=pruef Then circuit_info_row=k
		If circuit_info_row>0 And k>circuit_info_row Then
			n=k-1
		Else 
			n=k
			If n>track_rows-1 Then Exit For
		EndIf
		'Print "circuit_info_row=";circuit_info_row,k,n:getkey
		For i=0 To 17 
			track_tab(n,i)=tracktab(k,i)
		Next
	Next
	If circuit_info_row>0 Then
		WriteCSV (Track_tab(),csvfile,";",Chr(34),0)
	Else
		WriteCSV (Tracktab(),csvfile,";",Chr(34),0)		
	EndIf
	'Print"CSV file ";quote(csvfile);" created"
	Print #f3,"CSV file ";quote(csvfile);" created"	
	csv_count+=1
EndIf

If log_extended="1" Then utf_in_summary

parttxt_count = txt_count-circuit_count
Print parttxt_count & " part text files, " & circuit_count & " trackinfo files, " & csv_count & " CSV files created"
Print #f3, parttxt_count & " part text files, " & circuit_count & " trackinfo files, " & csv_count & " CSV files created"
filecount += 1

endsub:	
End Sub
'---------------------------------- Functions and SUBs: ------------------------------------
Function  SubStr(byVal  Liste As  String, byVal  Trenner As  String, byVal  Stelle As  Integer) As  String
  Dim As String ret0	
  Dim As Integer Aktuell=0, Ooops, ltr=Len(Trenner), Vorige=1, Gefunden
  If Stelle=0 Or Liste="" Or Trenner="" Or Instr(Liste, Trenner)=0 Then Return ""
  Do
    Ooops=Gefunden
    Gefunden=Instr(Gefunden+1, Liste, Trenner)
    Aktuell-=Gefunden<>0
    If Aktuell=Stelle-1 Then Vorige=Gefunden+ltr
    If Aktuell=Stelle Then Exit Do
  Loop Until Gefunden=0
  ret0 = Mid(Liste, IIF(Stelle-Aktuell>1, Len(Liste)+1, Ooops+ltr))
  If ret0="" Then ret0 = ret0 &Chr(0)
  If Stelle>Aktuell Then 
  	Return ret0
  Else  
  	Return Mid(Liste, Vorige, Gefunden-Vorige)
  EndIf
  
End Function

'Original-Code von ytwinky (Jrg Zhlke), Quelle: 
'http://www.freebasic-portal.de/code-beispiele/string-funktionen/substr-fast-ein-splitstring-81.htm
'Korrigiert P.Hagemann 04/2012 (Fehler: chr(0) am Ende des letzten Teils der Liste)

Function StrReplace (Byval StrEx as String, _
                     Byval StrMask as String, _
                     Byval StrRplce as String) as String

    If Len(StrEx)=0 or Len(StrMask)>Len(StrEx) Then Return StrEx
    'If InStr(StrEx,StrMask)=0 Then Return StrEx

    Dim Buffer as String=StrEx
    Dim MaskSearch as UInteger
    Dim MFound as byte
    Dim lp as UInteger=1

    Do
        MaskSearch=InStr(lp,Buffer,StrMask)
        MFound=0

        If MaskSearch Then
            MFound=1:lp=MaskSearch+Len(StrRplce)

            ''
            Buffer=Left(Buffer,MaskSearch-1)+ _
            StrRplce+ _
            Right(Buffer,Len(Buffer)-(MaskSearch+(Len(StrMask)-1)))
            ''

        End If

    Loop while MFound=1

    Return Buffer
End Function
'Quelle: http://www.freebasic-portal.de/code-beispiele/string-funktionen/strreplace-59.html


Function quote(ByVal chckstr As String) As String
Dim chkstr As string

	chkstr = Chr(34)+chckstr+Chr(34)
	Return chkstr
	
End Function

Function Replace(ByVal V_Data As String, ByVal V_Expression As String, ByVal V_ReplaceBy As String) As String
Dim X As Long
Dim SL As Long
Dim D as String
D = V_Data
SL = Len(V_Expression)
X = 0
Do
    X = X + 1
    If X > Len(D) - SL + 1 Then Exit Do
    If Mid(D, X, SL) = V_Expression Then
        D = Mid(D, 1, X - 1) & V_ReplaceBy & Mid(D, X + SL)
        X = X - (SL  - 1)
        If X < 0 then X = 0
    End If
Loop
'Print"Replaced ";quote(V_Expression);" in ";quote(V_Data);", result: ";quote(D)
Return D
End Function
'Quelle: http://www.freebasic-portal.de/code-beispiele/string-funktionen/sehr-schnelle-replace-funktion-91.html

Sub error_print(zeilen As String, colour As Integer)
'gibt Zeile rot oder gelb aus'

Color colour
Print zeilen
Color 15 	
End Sub

SUB WriteCSV(s() AS STRING, Datei AS STRING, TZ AS STRING, TT As String, conv AS INTEGER)
' Erzeugt aus dem Array s(0, 0) bis s(m, n) eine CSV-Datei (Excel-Tabelle aus
' den Zeilen 0 bis m und den Spalten 0 bis n).
' - TZ = Trennzeichen (z.B. Komma oder Semikolon, d.h. englisches oder deutsches
'   CSV-Format, oder beliebiges anderes Zeichen)
' - TT = Text-Trennzeichen (z.B. Anfhrungszeichen); damit knnen auch Sonderzeichen
'   in den Felddaten vorkommen, wie z.B. LF (Linefeed) als Zeilenumbruch 
' - conv <> 0: Dezimalpunkte werden in Kommata umgewandelt (nur sinnvoll, wenn
'   das Trennzeichen kein Komma ist und die Daten z.B. keine Datumsangaben
'   enthalten)

  DIM AS INTEGER i, j, k, m, n, f

  m = UBOUND(s, 1)
  n = UBOUND(s, 2)

  'Dezimalpunkte durch Kommata ersetzen:
  IF conv THEN
    FOR i = 0 TO m
      FOR j = 0 TO n
        k = INSTR(s(i, j), ".")
        IF k > 0 THEN MID(s(i, j), k, 1) = ","
      NEXT j
    NEXT i
  END IF

  'Speichern mit Trennzeichen:
  f = FreeFile
   
  OPEN Datei For Output Encoding("UTF-16") As #f
  FOR i = 0 TO m
    FOR j = 0 TO n - 1
      PRINT #f, TT + s(i, j) + TT + TZ;
    NEXT j
    PRINT #f, TT + s(i, n) + TT
  NEXT i
  CLOSE #f

END Sub

'Original-Code von Lothar Schirm, Quelle:
'http://www.freebasic-portal.de/code-beispiele/kleine-helferlein/csv-dateien-erzeugen-lesen-163.html
'Modifiziert (Text-Trennzeichen hinzugefgt) von P.Hagemann

Sub ReadIni

Dim As String zeile, pruef, pruef2, puffer
Dim As Integer i,j,k,t,errors=0,lng_count,part_count

Print

	f2=FreeFile
	Select Case OPEN (gps_ini For Input As #f2)
		CASE 0
			Print "INI file ";quote(gps_ini);" opened"
		Case 2
			error_print ("INI file not found " + quote(gps_ini),red)
			'Close #f2
			errors = errors + 1
			GoTo endini
		Case Else
			error_print ("Error when opening INI file " + quote(gps_ini),red)
			'Close #f2
			errors = errors + 1
			GoTo endini
	END Select
	
	'Verzeichnisnamen
	k=0
	Do While Not(Eof(f2))
		Line Input #f2,zeile
		k=k+1
		'print "#";k,zeile
		If zeile="" Then Continue Do
		If Left(zeile,1)=";" Then Continue Do
		
		If Left(zeile,7)="gps_lng" Then 
			'gps_lng = Val(Trim(SubStr(zeile,"=",2)))
			'Print "gps_lng = ";gps_lng,": ";Left(language(gps_lng),2)
			Print quote("gps_lng") + " ignored, parameter deprecated"
		EndIf
		
		If Left(zeile,6)="season" Then 
			Season = Trim(SubStr(zeile,"=",2))
			Print "season = ";season
		EndIf
		
		If Left(zeile,12)="program_path" Then 
			progpath = Trim(SubStr(zeile,"=",2)) 
			progpath = StrReplace(progpath,"%season%",season)
			'If Right(progpath,1) = "\" Then progpath = Left(progpath,Len(progpath)-1)
			progpath = RTrim(progpath,"\")
			If chkpath(progpath+"\") = 1 Then
				Print "program_path = ";quote(progpath)
			Else
				error_print ("program_path folder " + quote(progpath) + " not found.",red)
				errors=errors+1
			EndIf	
		EndIf
				
		If Left(zeile,7)="in_path" Then 
			inpath = Trim(SubStr(zeile,"=",2)) 
			inpath = StrReplace(inpath,"%program_path%",progpath)
			inpath = StrReplace(inpath,"%season%",season)
			If Right(inpath,1)<>"\" Then inpath=inpath+"\"
			inpath_ = RTrim(inpath,"\")
			If chkpath(inpath) = 1 Then
				Print "in_path = ";quote(inpath)
			Else
				error_print ("in_path folder " + quote(inpath) + " not found.",red)
				errors=errors+1
			EndIf	
		EndIf	
		
		If Left(zeile,14)="trackinfo_file" Then 
			trackinfo_file = Trim(SubStr(zeile,"=",2))
			trackinfo_file = StrReplace(trackinfo_file,"%season%",season)
			'Print "trackinfo file = ";trackinfo_file
		EndIf
		
		If Left(zeile,15)="trackinfo_trans" Then 
			trackinfo_trans = Trim(SubStr(zeile,"=",2))
			trackinfo_trans = StrReplace(trackinfo_trans,"%program_path%",progpath)
			trackinfo_trans = StrReplace(trackinfo_trans,"%in_path%",inpath_)
			Print "trackinfo_trans = ";quote(trackinfo_trans)
		EndIf
		
		If Left(zeile,8)="out_path" Then 
			outpath = Trim(SubStr(zeile,"=",2)) 'Leerzeichen und Tabs entfernen
			outpath = StrReplace(outpath,"%program_path%",progpath)
			'Print "outpath=";quote(outpath)
			outpath = StrReplace(outpath,"%in_path%",inpath_)
			'Print "outpath=";quote(outpath)
			outpath = StrReplace(outpath,"%season%",season)
			outpath = StrReplace(outpath,"%language%",language(gps_lng))
			outpath = StrReplace(outpath,"%ln%",lng(gps_lng))
			pruef = Left(outpath,Len(inpath))
			pruef2 = Left(outpath,Len(progpath+"\"))
			If inpath<>"" And pruef=inpath Then
				puffer=LTrim(outpath,inpath)
				'Print:Print "outpath=";quote(outpath):Print "pruef  =";quote(pruef),"rest=";quote(puffer):print
				result = makedir(pruef,puffer)
				If result = -1 Then
					error_print("out_path folder " + quote(puffer) + " could not be created in folder " + quote(pruef),red)
					errors=errors+1
				ElseIf result = 1 Then
					Print "out_path subfolder " + quote(puffer) + " created in folder in_path"
				Else
					'result = 0
					Print "out_path=" + quote(outpath)
				EndIf
			ElseIf pruef2=progpath Then
				puffer=LTrim(outpath,progpath)
				'Print:Print "outpath=";quote(outpath):Print "pruef2 =";quote(pruef2),"rest=";quote(puffer):print
				result = makedir(pruef2,puffer)
				If result = -1 Then
					error_print("out_path folder " + quote(puffer) + " could not be created in folder " + quote(pruef2),red)
					errors=errors+1
				ElseIf result = 1 Then
					Print "out_path subfolder " + quote(puffer) + " created in folder program_path"
				Else
					'result = 0
					Print "out_path=" + quote(outpath)
				EndIf
			Else
				If ChDir(outpath) Then
					If MkDir(outpath) Then
						error_print("out_path folder " + quote(outpath) + " could not be created.",red)
						errors=errors+1
					Else
						Print("out_path folder " + quote(outpath) + " created.")
					EndIf		
				Else
				Print "out_path = ";quote(outpath)
				EndIf
			EndIf
			If Right(outpath,1) <> "\" Then outpath = outpath + "\"

			If trackinfo_file <> "" Then
				out_trackinfo = outpath + "trackinfo\"
				If ChDir(out_trackinfo) Then
					If MkDir(out_trackinfo) Then
						error_print("trackinfo folder " + quote(out_trackinfo) + " could not be created.",red)
						errors=errors+1
					Else
						Print("trackinfo folder = " + quote(out_trackinfo) + " created.")',"outpath_set = ";outpath_set
					EndIf
				Else
					Print("trackinfo folder = " + quote(out_trackinfo))
				EndIf
			EndIf 
		EndIf
		
		If Left(zeile,8)="gps_file" Then 
			'Print "zeile = ";quote(zeile)
			gps_file = Trim(SubStr(zeile,"=",2)) 
			'Print "gps_file = ";quote(gps_file)
			gps_file = StrReplace(gps_file,"%program_path%",progpath)
			'Print "gps_file = ";quote(gps_file)
			gps_file = StrReplace(gps_file,"%in_path%",inpath_)
			'Print "gps_file = ";quote(gps_file)
			gps_file = StrReplace(gps_file,"%season%",season)
			'Print "gps_file = ";quote(gps_file)
		EndIf	
		
		If Left(zeile,9)="form_file" Then 
			form_file = Trim(SubStr(zeile,"=",2)) 
			form_file = StrReplace(form_file,"%program_path%",progpath)
			form_file = StrReplace(form_file,"%in_path%",inpath_)
			form_file = StrReplace(form_file,"%season%",season)
		EndIf		
		
		'select gps language files
		If Left(zeile,9)="gps_modes" Then
			lng_lst=Trim(SubStr(zeile,"=",2))
			Print "selected modes: ";
			part_count = InCount(lng_lst,",")
			If part_count <> 5 Then
				Print
				error_print ("Invalid gps value list " + quote(lng_lst) + ": " + Str(part_count) + " parts",red) 
				errors=errors+1
			EndIf
			For i = 0 To 4 : 
				lng_list(i)=Trim(SubStr(lng_lst,",",i+1))
				Print lng(i);"=";lng_list(i) + Space(2);
				If chkvalue(lng_list(i),"0123") <> 1 Then 
					error_print ("Invalid gps value " + lng_list(i),red)
					errors=errors+1
				EndIf
			Next
			Print
		EndIf
		
		If Left(zeile,15)="ignore_linkdata" Then 
			ignore_linkdata = Trim(SubStr(zeile,"=",2))
			If chkvalue(ignore_linkdata,"01") <> 1 Then 
				error_print ("Invalid ignore_linkdata value " + quote(ignore_linkdata),red)
				errors=errors+1
			Else
				Print "ignore_linkdata = ";quote(ignore_linkdata)
			EndIf
		EndIf
		
		If Left(zeile,17)="driver_team_delim" Then 
			driver_team_delim = Trim(SubStr(zeile,"=",2))
			driver_team_delim = StrReplace(driver_team_delim,"_"," ")
			Print "driver_team_delim = ";quote(driver_team_delim)
		EndIf
		
		If Left(zeile,18)="country_town_delim" Then 
			country_town_delim = Trim(SubStr(zeile,"=",2))
			country_town_delim = StrReplace(country_town_delim,"_"," ")
			Print "country_town_delim = ";quote(country_town_delim)
		EndIf
		
		If Left(zeile,5)="modus" Then 
				'_modus = Trim(SubStr(zeile,"=",2))
				'Select Case _modus
				'	Case "csv"
				'		modus = 0
				'	Case "0"
				'		modus = 0
				'	Case "all"
				'	modus = 1
				'	Case "1"
				'		modus = 1
				'	Case "txt"
				'		modus = 2
				'	Case "2"
				'		modus = 2
				'	Case Else
				'		modus = -1
				'End Select
				'If modus <> -1 Then
				'	Print "modus = ";quote(_modus);" ==> ";modus
				'Else
				'	error_print ("Invalid modus " + _modus + " not: all, csv, txt",red)
				'	errors=errors+1
				'EndIf
				Print quote("modus") + " ignored, parameter deprecated"
		EndIf			
		
		'select name of log_file (without extension, that is always ".log") 
		If Left(zeile,8)="log_file" Then 
			log_file = Trim(SubStr(zeile,"=",2))
			Print "log_file = ";quote(log_file)
		EndIf	
		
		'Extended log output (UTF critical chars, trackinfo translations) 
		If Left(zeile,12)="log_extended" Then 
			log_extended = Trim(SubStr(zeile,"=",2))
			If chkvalue(log_extended,"01") <> 1 Then 
				error_print ("Invalid log_extended value " + quote(log_extended),red)
				errors=errors+1
			Else
				Print "log_extended = ";quote(log_extended)
			EndIf
		EndIf
		
	Loop
	Close #f2

	'For i=0 To 4:Print i, quote(outfile(i)):Next
	'For i=0 To 4:Print i, quote(trackgpsfile(i)):next
  	
endini:
	If errors > 0 Then
		Print
		print "--- ";errors;" INI file errors found. Press any key to break ---"
		GetKey:End
	EndIf
  	
End Sub

Sub Readformat
Dim As String zeile, puffer, pruef, mode
Dim As String driver_label="[driver]", team_label="[team]", track_label="[track]"
Dim As Integer i,k,n,in,act, errors=0
Dim As Integer driverfound, teamfound, trackfound, dr,te,tr

'Print "form_file=";quote(form_file), quote(lng(gps_lng))
formfile = StrReplace(form_file,"%language%",language(gps_lng))
formfile = StrReplace(formfile,"%ln%",lng(gps_lng))
'Print "formfile=";quote(formfile)

If FileExists(formfile) Then
	'Print "form file = ";quote(formfile)
Else
	Print #f3, ">>> Form file not found" + quote(formfile)
	error_print ("Form file not found" + quote(formfile),red)
	errors +=1
	GoTo endformat
EndIf

chktext(formfile)	
'Print
Print #f3,"Read format text file"
	
anfang:
	f2=FreeFile
	Select Case OPEN (formfile For Input Encoding("UTF-16") As #f2)
		CASE 0
			If act=0 Then 
				Print "Form file ";quote(formfile);" opened"
				Print #f3,"Form file ";quote(formfile);" opened"
			EndIf
		Case 2
			Print #f3,">>> Form file not found " + quote(formfile)
			Print:error_print ("Form file not found " + quote(formfile),red)
			'Close #f2
			errors += 1
			GoTo endformat
		Case Else
			Print #f3,">>> Error when opening form file " + quote(formfile)
			Print:error_print ("Error when opening form file " + quote(formfile),red)
			'Close #f2
			errors += 1
			GoTo endformat
	END Select
	
If act = 1 GoTo act1
	
	'Print "act0"
	' lesen und Anzahl der Daten ermitteln
	Do
		Line Input #f2,zeile
		'Print "Format Zeile: ";zeile
		If Eof(f2) Then Exit Do
		If Trim(zeile)="" Then Continue Do 'leere Zeile berlesen
		If Left(zeile,1)=";" Then Continue Do 'Zeile mit ";" berlesen
		If Left(zeile,Len(driver_label)) = driver_label Then 
			mode = "dr" ':print quote(driver_label)
			Continue Do
		EndIf
		If Left(zeile,Len(team_label)) = team_label Then 
			mode = "te" ':print quote(team_label)
			Continue Do
		EndIf
		If Left(zeile,Len(track_label)) = track_label Then 
			mode = "tr" ':print quote(track_label)
			Continue Do
		EndIf
		
		n=InCount(zeile,"|")
		If n-1>header_dim Then 
			header_dim=n-1
			'Print "header_dim = ";header_dim
		EndIf

		If mode = "dr" Then dr +=1
		If mode = "te" Then te +=1
		If mode = "tr" Then tr +=1
		'Print mode,quote(zeile),dr,te,tr
	Loop
	'Print "act0 exit =";quote(zeile):GetKey':End
	
Close #f2
'	Print "header_dim = ";header_dim
	dr+=1 ' +1 Zeile fr "driver replace"
	ReDim driver_header(dr,header_dim)
	ReDim team_header(te,header_dim)
	ReDim track_header(tr,header_dim)
	
	ReDim dr_header(dr)
	ReDim te_header(te)
	ReDim tr_header(tr)
	
act = act + 1:GoTo anfang
'Print "act1"
act1:
	
	' einlesen der Daten in arrays
	Do While Not(Eof(f2))
		Line Input #f2,zeile':Print zeile
		If Eof(f2) Then Exit Do
		If Left(zeile,1)=";" Then Continue Do 'Zeile mit ";" berlesen
		
		If Left(zeile,Len(driver_label)) = driver_label Then
			driverfound = 1
			i=1
			'Print "--- driver_header";
			Do While i<dr
				Line Input #f2,zeile':Print zeile
				If Left(zeile,1)=";" Then Continue Do 'Zeile mit ";" berlesen
				n=InCount(zeile,"|")
				'Print "i,n,zeile";i;Tab(15);n;Tab(20);quote(zeile);
				If n=1 Then
					driver_header(i,0) = Trim(zeile)
					'Print Tab(50);0;quote(driver_header(i,0))				
				Else
					For k=1 To n
						pruef = SubStr(zeile,"|",k)
						driver_header(i,k-1) = Trim(pruef)
						'Print Tab(20);i;Tab(25);k-1;quote(pruef)
					Next
				EndIf
				
				If Eof(f2) Then Exit Do
				'Print i,zeile:	
				'GetKey
				i+=1
			Loop 
		EndIf
		
		If Left(zeile,Len(team_label)) = team_label Then
			teamfound = 1
			i=1
			'Print "--- team_header";
			Do While i<= te
				Line Input #f2,zeile':Print zeile
				If Left(zeile,1)=";" Then Continue Do 'Zeile mit ";" berlesen
				n=InCount(zeile,"|")
				'Print "i,n,zeile";i;Tab(15);n;Tab(20);quote(zeile);
	
				If n=1 Then
					team_header(i,0) = Trim(zeile)':Print i,dr,zeil
					'Print Tab(50);0;quote(team_header(i,k))
				else
					For k=1 To n
						pruef = SubStr(zeile,"|",k)
						team_header(i,k-1) = Trim(pruef)':Print i,dr,quote(puffer)
						'Print Tab(20);i;Tab(25);k-1;quote(pruef)
					Next
				EndIf
				
				If Eof(f2) Then Exit Do
				'Print i,zeile
				'getkey
				i+=1
			Loop
		EndIf
		
		If Left(zeile,Len(track_label)) = track_label Then
			trackfound = 1
   		i=1
   		'Print "--- track_header";
   		Do While i<= tr
				Line Input #f2,zeile':Print zeile
				If Left(zeile,1)=";" Then Continue Do 'Zeile mit ";" berlesen
				n=InCount(zeile,"|")
				'Print "i,n,zeile";i;Tab(15);n;Tab(20);quote(zeile);
			  	
				If n=1 Then
					track_header(i,0) = Trim(zeile)':Print i,dr,zeile
					'Print Tab(50);0;quote(track_header(i,0))
					If zeile = "#info" Then info_row = i
					If zeile = "corner data" Then 
						tracktab_offset = i
						corner_rows=25
					EndIf
				else
					For k=1 To n
						pruef = SubStr(zeile,"|",k)
						track_header(i,k-1) = Trim(pruef)':Print i,dr,quote(puffer)
						'Print Tab(20);i;Tab(25);k-1;quote(pruef)
					Next
				EndIf

				If Eof(f2) Then Exit Do
				'Print i,zeile
				'getkey
				i+=1
   		Loop
		EndIf
    	
	Loop
	'Print "act1 exit =";quote(zeile):GetKey:End
	driver_header(dr,0) = "driver replace" 'immer in letzte Zeile

Close #f2

If driverfound = 0 Then
	Print #f3,">>> driver format not found"
	error_print("driver format not found",red)
	errors +=1
EndIf

If teamfound = 0 Then
	Print #f3,">>> team format not found"
	error_print("team format not found",red)
	errors +=1
EndIf

If trackfound = 0 Then
	Print #f3,">>> track format not found"
	error_print("track format not found",red)
	errors +=1
EndIf

If info_row < 4 Then 
	Print #f3,"invalid #info row = "+ Str(info_row)
	error_print("invalid #info row = "+ Str(info_row),red)
	errors +=1
EndIf

If errors >0 Then GoTo endformat

'Test Ausgabe Format
'Print dr;" driver_header:"
Print #f3, dr;" driver_header:"
For i=1 To dr-1
	'Print i,quote(driver_header(i,0));
	Print #f3, i,quote(driver_header(i,0));
   For k=1 To header_dim
		If driver_header(i,k)<>"" Then 
			'Print "|";quote(driver_header(i,k));
			Print #f3, "|";quote(driver_header(i,k));
		EndIf
   Next
   Print #f3,
	'Print
Next
Print #f3, dr,quote(driver_header(dr,0)); " (inserted by program)";
Print #f3,
'Print

'Print te;" team_header:"
Print #f3, te;" team_header:"
For i=1 To te
	'Print i,quote(team_header(i,0));
	Print #f3, i,quote(team_header(i,0));
   For k=1 To header_dim
		If team_header(i,k)<>"" Then 
			'Print "|";quote(team_header(i,k));
			Print #f3, "|";quote(team_header(i,k));
		EndIf
   Next
   'Print
   Print #f3,
Next

'Print tr;" track_header:"
Print #f3, tr;" track_header:"
For i=1 To tr
	'Print i,quote(track_header(i,0));
	Print #f3,i,quote(track_header(i,0));
   For k=1 To header_dim
		If track_header(i,k)<>"" Then 
			'Print "|";quote(track_header(i,k));
			Print #f3,"|";quote(track_header(i,k));
		EndIf
   Next
   'Print
   Print #f3,
Next

Print #f3,

'Print
driver_rows = UBound(driver_header)
'Print "driver_rows = ";driver_rows
team_rows = UBound(team_header)
'Print "team_rows = ";team_rows
track_rows = UBound(track_header)+corner_rows 'plus zeilen fr corner data (0 oder 25)
'Print "track_rows = ";track_rows,tracktab_offset,corner_rows	

reDim Drivertab(driver_rows,22) As String
reDim Teamtab(team_rows,11) As String
reDim Tracktab(track_rows,17) As String
ReDim Track_tab(track_rows-1,17) As String 'Tracktab minus "circuit info"

Print #f3, "Drivertable (" & driver_rows & ",22)" 
Print #f3, "Teamtable   (" & team_rows & ",11)" 
Print #f3, "Tracktable  (" & track_rows & ",17)" 
	
endformat:	
	If errors > 0 Then
		Print
		print "--- ";errors;" Form errors found. Press any key to break ---"
		GetKey:End
	EndIf
	
'Print "---End Sub ReadFormat---":GetKey
End Sub

Sub InitLang
'Einlesen von Daten fr sprachspezifische Feldgruppen
'0=English,1=German,2=Espanol,3=Italiano,4=Francais
Dim As Integer i,k

For i=0 To 4:Read circuit_info(i)
	'Print i,quote(circuit_info(i))
Next
'Print

For i=0 To 4:Read gear_word(i)
	'Print i,quote(gear_word(i))
Next
'Print
'italienisches Zahlwort fr Gang aus cornerdata:
For i=1 To 9:Read it_gear(i)
	'Print i,quote(it_gear(i))
Next
'print':

'Print "Read UTF_ASC Werte" 
For i=0 To 7
	'Print i,
	For k=0 To 2
		Read UTF_ANSI(i,k)
		'Print k;" ";quote(Hex(UTF_ANSI(i,k),4)),
	Next
	'Print 
Next
'GetKey:end
End Sub

SUB InitTabs
'Initialisiert die Arrays fr die Ausgabe in CSV
'Die erste Spalte wird gefllt mit den Bezeichnern fr die Zeilen	
Dim As integer i,k
Dim As String mph_kmh = "km/h"
Dim As String corner_nr

'Eintrge der Spaltennummern
Drivertab (0,0) = season
Teamtab(0,0) = season
Tracktab(0,0) = season

Print "Init table rows and columns"
Print #f3, "Init table rows and columns: ";
'Spalten
For i=1 To 22
	Drivertab(0,i)=Str(i) 'Number of driver
	'Print "driver";i,quote(Drivertab(0,i))',"=key=":getkey
Next

For i=1 To 11
	Teamtab(0,i)=Str(i)	'Number of team, GPaedia-Team-Nr
	'Print "team";i,quote(Teamtab(0,i))',"=key=":GetKey
Next

For i=1 To 17
	Tracktab(0,i)=Str(i) 'Number of Track
	'Print "track";i,quote(tracktab(0,i))',"=key=":getkey
Next

'Zeilen der ersten Spalte
'Print "- Driver rows"
For k = 1 To driver_rows
	Drivertab(k,0) = Trim(Trim(driver_header(k,0)),":")
	'Print k,quote(Drivertab(k,0))
Next

'Print "- Team rows"
For k = 1 To team_rows
	Teamtab(k,0) = Trim(Trim(team_header(k,0)),":")
	'Print k,quote(Teamtab(k,0))
Next

'Print "- Track rows"
For k = 1 To tracktab_offset
		Tracktab(k,0) = Trim(Trim(track_header(k,0)),":")
		'Print k,quote(Tracktab(k,0))
Next

' corner data
If corner_rows > 0 Then
'Print "corner rows set"
Print #f3,"Set corner rows"
	Tracktab(tracktab_offset,0)=track_header(tracktab_offset,0)
	For i=tracktab_offset+1 To track_rows ' 25 corner-data
		k=i-tracktab_offset
		If Len(Str(k))>=2 Then 
			corner_nr = Str(k)
		Else 
			corner_nr = "0"+Str(k)
		EndIf
		Tracktab(i,0)="corner " + corner_nr + ": name"+LF+"           gear"+LF+"           "+mph_kmh
	Next
EndIf

'Print "Init Arrays for CSV-output done"
'Print #f3,"Init Arrays for CSV-output done"
End Sub

Sub GetTrackRecords (gptracknum As integer)
'Daten fr Strecken-Rekorde auslesen	

Dim TrackLabel(17) As String => {"179 "+NAK,"951 "+NAK,"953 "+NAK,"954 "+NAK,"955 "+NAK,_
 "956 "+NAK,"957 "+NAK,"958 "+NAK,"977 "+NAK,"978 "+NAK,"979 "+NAK,"980 "+NAK,"981 "+NAK,_
 "982 "+NAK,"983 "+NAK,"984 "+NAK,"985 "+NAK,"986 "+NAK}
 'Marken pro Track (1-17)
Dim As Integer i,j,k,hd,max,n,fertig,first,halt,track
Dim As String pruef,puffer,rest,lines
ReDim tr_header(UBound(tr_header)) 'alle auf 0 setzen

max=UBound(track_header)
j=gptracknum : i=GPTrackrec(j) : track=i
k=info_row+1

   'Weiterlesen bis zur Marke fr 1. Zeile der Streckendaten
	Do While Not Eof(f1)
		zeile = UTF2Str(f1)
		If Eof(f1) Then 
			Print #f3, ">>> Track records not found - EOF"
			error_print("Track records not found - EOF",red):Sleep:End
		EndIf
	'Print i, quote(zeile)
	'Print i, "Pruef = ";quote(Left(zeile,5))
	'Print i, "Tracklabel =";quote(Tracklabel(i))
	'getkey
		If Left(zeile,5)=TrackLabel(j) Then Exit Do
	Loop
	'Start trackheader prfen
	'Print j;Tab(5);i;Tab(10);Tracktab(1,i);Tab(30);quote(zeile)
	Print #f3,j,i;Tab(25);Tracktab(1,i);Tab(45);quote(zeile)
	puffer = Trim(Mid(zeile,6))				':Print "puffer=";quote(puffer),
	pruef = track_header(k,0):m=Len(pruef)	':Print "pruef=";quote(pruef)
	If left(puffer,m)=pruef Then 
		Tracktab(k,i) = Trim(Mid(puffer,m+1))
		'Print k;Tab(5);track_header(k,0);Tab(30);quote(Tracktab(k,j))
		n=k
		If k<max Then k=k+1
	'Else
		'Fehlermeldung unntig, da track_header ev. in nchster Zeile; falls er fehlt, bringt die Header-Prfung eine Meldung
		'	Print #f3, ">>> " & j;Tab(5);quote(Str(track_header(k,0)))+" not in first track records line "+quote(zeile)+" track " & i
		'	'error_print(j & " " & quote(Str(track_header(k,0)))+" not in first track records line "+quote(zeile) & " track " & i,ylw)
		'	errorcount +=1
		'	'GetKey
		'EndIf
	EndIf

	Do While Not Eof(f1)	
		zeile = UTF2Str(f1)
		'Print i;k;" zeile = ";quote(zeile)
		If zeile = NAK Then Exit Do
		If Right(zeile,1) = NAK Then 
			zeile = Trim(zeile,NAK)
			fertig = 1
		EndIf
		If zeile = "" Then Continue Do
		If chkheader(zeile,"track",k,m,hd)>0 Then
			'Print i;k;quote(track_header(k,0));tab(40);
			'If hd<>0 Then Print hd;quote(track_header(k,hd));
			'Print quote(track_header(k,hd))
			puffer =  Trim(LTrim(zeile,track_header(k,hd)))
			'If Len(puffer)>0 Then
			'	Print "zeile = ";quote(zeile)
			'	Print "header= ";quote(track_header(k,hd));Tab(40);hd;Tab(50);"puffer = ";quote(puffer):GetKey
			'EndIf
			Tracktab(k,i) = puffer
			
			n=k
			'Print k;track_header(k,0);quote(Tracktab(k,i))
			If k<max Then k=k+1
		Else			
			If tracktab(n,i)<>"" Then
				Tracktab(n,i)= Tracktab(n,i) + LF + Trim(zeile)	
			Else
				Tracktab(n,i)= Trim(zeile)	
			EndIf
			
			'Print n,quote(Tracktab(n,i))
		EndIf
		'Print "=key=":GetKey
		If fertig > 0 Then Exit Do
	Loop

	'Prfen, ob alle trackheader benutzt wurden
	pruef = LCase(Trim(Tracktab(1,i)))
	If pruef<>"test" And pruef<>"" Then
		For k=info_row+2 To max
			If tr_header(k)=0 Then
				If track_header(k,0)<>"corner data" Then
					Print #f3,">>> track " & track & " header not used: " & k & Space(5-len(str(k))) & quote(track_header(k,0))
					error_print("track " & track & " header not used: " & k & Space(5-len(str(k))) & quote(track_header(k,0)),ylw)
					errorcount +=1
					'halt=1
				EndIf
			EndIf
		Next
	EndIf

'subend:	   
End Sub

Sub GetCornerData (gptracknum As integer)
'Daten fr Kurvenpunkte der jeweiligen Strecke auslesen	

Dim As Integer ColonPos, trennpos, ausgang
Dim As Integer i,k,j,l
Dim As String cornerdata, gear, speed, nextdata
Dim TrackLabel(1 To 17) As String => {"960 "+NAK,"961 "+NAK,"962 "+NAK,"963 "+NAK,_
 "964 "+NAK,"965 "+NAK,"966 "+NAK,"967 "+NAK,"968 "+NAK,"969 "+NAK,"970 "+NAK,"971 "+NAK,_
 "972 "+NAK,"973 "+NAK,"974 "+NAK,"975 "+NAK,"976 "+NAK}
 'Marken pro Track (1-17)
	
j=gptracknum : i=GP_Track(j) 'tracknum

'Weiterlesen bis zur Marke fr 1. Zeile der Streckendaten
	Do While Not Eof(f1)
		zeile = UTF2Str(f1)
		'Print "zeile=";quote(zeile)
		If Eof(f1) Then 
			Print #f3,">>> Tracklabel ";Tracklabel(j);" not found - EOF"
			error_print("Tracklabel " + Tracklabel(j) + " not found - EOF",red):Sleep:End
		EndIf
		If Left(zeile,5)=TrackLabel(j) Then Exit Do
	Loop
'Ausgabe in Log	
	Tracktab(tracktab_offset,i)=Trim(zeile,Tracklabel(j))
	'Print j,i,Tracklabel(j),quote(Tracktab(tracktab_offset,i))
	Print #f3,j,i,Tracklabel(j),quote(Tracktab(tracktab_offset,i))
'corner data
If corner_rows > 0 Then
	Do 
   	zeile = UTF2Str(f1)
   	If Eof(f1) Then 
   		Print #f3,">>> corner data not found - EOF"
   		error_print("corner data not found - EOF",red):Sleep:End
   	EndIf
   	'Print zeile
   	If Trim(zeile)="" Then Continue Do	'Zeile leer, dann nchste
   	If Right(zeile,1)= NAK Then 
   		zeile=Trim(zeile,NAK)
   		Ausgang=1							  	' letzte Zeile erreicht
   	EndIf
   	ColonPos=InStr(zeile,":")
	   If ColonPos>0 And ColonPos<5 Then	' Neue Kurve, wenn am Anfang (1-4) Doppelpunkt 
	   	If cornerdata<>"" Then				' Daten vorhanden, dann vorige Kurvendaten jetzt bernehmen
	   		'Print"cornerdata ausgabe = ";quote(cornerdata)':getkey
	   		Tracktab(k+tracktab_offset,i)=cornerdata 
	   		cornerdata=""						' Datenpuffer lschen
	   	EndIf		
	   	k=Val(Left(zeile,ColonPos-1)) ' Kurvennummer = Nr. vor dem Doppelpunkt
	   	If k>25 Then Exit Do
	   	cornerdata=Trim(Mid(zeile,ColonPos+1))
	   	cornerdata=StrReplace(cornerdata,"\"+Chr(34),"'")
	   	'Print"cornerdata+Kurve = ";quote(cornerdata);Tab(40);"Kurve= ";k,ColonPos:getkey
	   	If cornerdata = "" Then cornerdata = "-"	'Kurvenname als leer markieren
	   	If chkgear(zeile)=1 Then 	'1. Zeile leer oder schon "Gear"-Zeile
				cornerdata = "-"
				puffer=Trim(Mid(zeile,ColonPos+1))
				gear=getgear(puffer)
				'Print quote(zeile),quote(puffer),gear
				cornerdata=cornerdata+LF+gear	' in Daten aufnehmen 					
	   	EndIf		   	
	   ElseIf chkgear(zeile)=1 Then 'Zeile mit "Gear"
	   	puffer=Trim(Mid(zeile,ColonPos+1))
			gear=getgear(puffer)
			'Print quote(zeile),quote(puffer),gear
			cornerdata=cornerdata+LF+gear			 ' in Daten aufnehmen
	   ElseIf InStr(Trim(zeile),"/")>0 Then ' mph/km/h-Zeile
	   	puffer = Trim(Mid(zeile,ColonPos+1))
	   	trennpos = InStr(puffer,"/")
	   	If gps_lng <> 2 Then
	   		speed=Str(Val(Mid(puffer,trennpos+1))) 'nur den km/h Wert (hinter "/") nehmen
	   	Else
	   		speed=Str(Val(puffer))
	   	EndIf
	   	'Print quote(puffer),trennpos,"speed = ";quote(speed)
	    	cornerdata=cornerdata+LF+speed
	   Else
	   EndIf
	   
	Loop 	While Not Eof(f1) And ausgang=0
	If cornerdata<>"" Then
		'Print j,i,"cornerdata ausgabe = ":Print quote(cornerdata):getkey
		Tracktab(k+tracktab_offset,i)=cornerdata ' bernehme
	EndIf
EndIf
	
End Sub

Function GetDigits (ByVal inline As String) As String
' extrahiert Zahlen aus String	
Dim As String number, digits = "0123456789"
Dim chk As String*1
Dim As Integer i,l

l=Len(inline)
For i=1 To l
	chk = Mid(inline,i,1)
	If InStr(digits,chk)>0 Then number = number + chk
Next

'Print "Number = ";quote(number)
Return number	
End Function

Sub GetTrackGpaedia (gptracknum As integer)

Dim TrackLabel(1 To 17) As String => {"666 "+NAK,"667 "+NAK,"668 "+NAK,"671 "+NAK,"672 "+NAK,_
 "673 "+NAK,"674 "+NAK,"675 "+NAK,"676 "+NAK,"677 "+NAK,"678 "+NAK,"679 "+NAK,"680 "+NAK,_
 "681 "+NAK,"682 "+NAK,"683 "+NAK,"684 "+NAK}
'Marken pro Track (1-17)
Dim As String pruef, puffer, trackinfo_name, trackinfo_txt, trackinfo_path
Dim As Integer i,j,k,l,n,m,hd,max,fertig,modus_save,halt, track
ReDim tr_header(UBound(tr_header)) 'alle auf 0 setzen
 	 	
j=gptracknum : i=GP_Track(j) : track=i
max = UBound(track_header)
	
	If i=1 Then 
		Tracktab(3,GPTrack(i))=Trim(Mid(zeile,6)," ")
		'Print j,i,zeile
		Print #f3,j,i,zeile
	Else'die erste Marke wurde bereits eingelesen
	'Weiterlesen bis zur Marke fr 1. Zeile der Streckendaten
		Do While Not Eof(f1)
			zeile = UTF2Str(f1)
			'If i=12 Then Print i,quote(zeile):getkey	
			If Eof(f1) Then 
				Print #f3,">>> " +quote(Tracklabel(j))+ " not found - EOF",quote(zeile)
				error_print (quote(Tracklabel(j))+ " not found - EOF" + quote(zeile),red)
				Sleep:End 
			EndIf
			If Left(zeile,5)=TrackLabel(j) Then 
				trackinfo_name=Mid(zeile,6)
				Exit Do
			EndIf		
		Loop	
		
		Tracktab(3,i)=Trim(trackinfo_name)
		'Print j,i,zeile
		Print #f3,j,i,zeile
				
	EndIf

'Print i,"Tracklabel = ";Tracklabel(i)
'Print i,"Zeile = ";quote(zeile)

	k=4
   Do 
   	zeile = UTF2Str(f1)
   	if Eof(f1) Then 
   		Print #f3,">>> Track-Header ";quote(track_header(k,0));" not found - EOF"
   		error_print ("Track-Header "+quote(track_header(k,0))+" not found - EOF",red)
   		Sleep:End
   	EndIf
   	If Trim(zeile)="" Then Continue Do
   	If zeile = NAK Then Exit Do
		If Right(zeile,1) = NAK Then 
			zeile = Trim(zeile,NAK)
			fertig = 1
		EndIf
   	
   	pruef=Trim(track_header(k,0)) : m = Len(pruef)
   	   'Print i;" zeile = ";quote(zeile)
     		'Print "   pruef = ";quote(pruef),quote(Right(pruef,4)):getkey
   	If chkheader(zeile,"track",k,m,hd)>0 Then
   		'Print quote(pruef),"chkheader track:";k,quote(zeile),m
   		puffer= Trim(LTrim(zeile,track_header(k,hd)))
   		'Print "puffer = ";quote(puffer),m
   		'print "=key=":GetKey
   		If gps_lng = 0 Then
   			If Right(pruef,4)= " GP:" And k+1<max Then
   				'Print k,quote(track_header(k,0)),quote(track_header(k+1,0)),quote(track_header(k+2,0))
   				If track_header(k+1,0) = "GP Date" And track_header(k+2,0) = "Laps" Then
   					l=InStr(puffer,"(")
   					If l>0 Then
   						TrackTab(k+1,i)=Left(puffer,l-1) ' Datum
   						TrackTab(k+2,i)=Str(Val(Mid(puffer,l+1))) ' Laps
   						'Print i, "zeile = ";quote(zeile)
   						'Print "GP Date =";quote(tracktab(k+1,j))," Laps = ";TrackTab(k+2,j)
   						'getkey
   					Else
   						TrackTab(k+1,i)=puffer ' Datum
   						TrackTab(k+2,i)="" ' Laps
   						'Print "track = ";i;",";Tab(20);"zeile = ";quote(zeile)
   						'Print "GP Date =";quote(tracktab(k+1,j));Tab(30);" Laps = ";quote(TrackTab(k+2,j))   						
   					EndIf
   					k=k+3
   					Continue Do
   				EndIf
   			EndIf
   		EndIf
			
   		If pruef = circuit_info(gps_lng) Then
   			If trackinfo_file <> "" Then
					'wenn in ini spezifiziert
					'im Namen fr die Trackinfo-Datei %trackname% bzw. %tracknum% ersetzen
					'%trackname% durch Name aus Tracktab(1,tracknr), %tracknum% durch track(nr)
					'Print "trackinfo_file = ";quote(trackinfo_file)
					'Print "Tracktab = ";quote(Tracktab(1,i))
					trackinfo_txt = StrReplace(trackinfo_file,"%language%",language(gps_lng))
					'Print "trackinfo_txt = ";quote(trackinfo_txt)
					trackinfo_txt = StrReplace(trackinfo_txt,"%ln%",lng(gps_lng))
					'Print "trackinfo_txt = ";quote(trackinfo_txt)
					trackinfo_txt = StrReplace(trackinfo_txt,"%trackname%",Lnamecase(Trim(Tracktab(1,i))))
					'Print "trackinfo_txt = ";quote(trackinfo_txt)
					trackinfo_txt = StrReplace(trackinfo_txt,"%tracknum%",Str(i))
					'Print "trackinfo_txt = ";quote(trackinfo_txt)
					trackinfo_txt = out_trackinfo + trackinfo_txt
   				'Print "trackinfo_txt = ";quote(trackinfo_txt)
   				modus_save = txtmodus : txtmodus = 1
   				TextOut(trackinfo_txt,"",1,NAK,0)
   				txtmodus = modus_save
   				circuit_count +=1
   			EndIf	  					
   		Else
  				Tracktab(k,i)=StrReplace(puffer,"\"+Chr(34),"''")
	     		'Print i;quote(zeile);Tab(40);"pruef = ";quote(pruef)
	     		'Print i;k;Tab(10);track_header(k,0);quote(Tracktab(k,i)):GetKey
   		EndIf
	     	
	     	n=k
	  		If k<max Then
	  			k+=1
	  			If k=info_row Then Exit Do '#info markiert Ende TrackGpaedia/Anfang Trackrecords
	  		EndIf
   	Else
   		'folgende Zeilen ohne Header bernehmen in Tabellenzelle
   		If tracktab(n,i)<>"" Then
				Tracktab(n,i)= Tracktab(n,i) + LF + Trim(zeile)	
			Else
				Tracktab(n,i)= Trim(zeile)	
			EndIf
   		'Print n,quote(tracktab(n,i))
   	EndIf	
   	If fertig > 0 Then Exit Do
   Loop 

	'Prfen, ob alle trackheader benutzt wurden
	pruef = LCase(Trim(Tracktab(1,i)))
	If pruef<>"test" And pruef<>"" Then
		For k=4 To info_row-1
			If gps_lng=0 Then 
				'Print quote(track_header(k,0));Tab(30);tr_header(k)
				If track_header(k,0)="GP Date" Then Continue For
				If track_header(k,0)="Laps" Then Continue For
			EndIf
			If tr_header(k)=0 Then
				Print #f3,">>> track " & track & " header not used: " & k & Space(5-len(str(k))) & quote(track_header(k,0))
				'error_print("track " & track & " header not used: " & k & Space(5-len(str(k))) & quote(track_header(k,0)),ylw)
				errorcount +=1
				'halt=1
			EndIf
		Next
	EndIf
	
'subend:   
End Sub

Sub GetTeamData (gpteamnum As Integer)
Dim TeamLabel(1 To 11) As String => {"685 "+NAK,"686 "+NAK,"687 "+NAK,"688 "+NAK,_
"689 "+NAK,"690 "+NAK,"691 "+NAK,"692 "+NAK,"693 "+NAK,"694 "+NAK,"695 "+NAK}
Dim As Integer i,j,k,n,m,hd,max,fertig,halt,team
Dim As String pruef, hpruef, puffer
ReDim te_header(UBound(te_header)) 'alle auf 0 setzen

j=gpteamnum : i=GP_Team(j) : team=i
k=3 : max = UBound(team_header)

	Do While Not Eof(f1)
		zeile = UTF2Str(f1)
		If Eof(f1) Then 
			Print #f3,">>> Teamlabel ";Teamlabel(j);" not found - EOF"
			error_print ("Teamlabel "+quote(Teamlabel(j))+" not found - EOF",red):Sleep:End
		EndIf
		If Left(zeile,5)=TeamLabel(j) Then 
			'Print j;Tab(5);i;Tab(10);k;Tab(15);quote(zeile)
			Print #f3,j;Tab(5);i;Tab(10);quote(zeile)
			Exit Do
		EndIf
	Loop
	
	puffer = LTrim(zeile,Teamlabel(j))
	If chkheader(puffer,"team",k,m,hd)>0 Then 
    	Teamtab(k,i)=Trim(LTrim(puffer,team_header(k,hd)))
	EndIf
	'Print "zeile= ";quote(zeile) 
	'Print "puffer =";quote(puffer);Tab(50);j;k;" Teamtab = ";quote(Teamtab(k,j)):GetKey

	k=4	
   Do 
   	zeile = UTF2Str(f1)
   	if Eof(f1) Then 
   		Print #f3,">>> Team-Header ";quote(team_header(k,0));" not found - EOF"
   		error_print ("Team-Header "+quote(team_header(k,0))+" not found - EOF",red)
   		Sleep:End
   	EndIf
   	If Trim(zeile)="" Then Continue Do
   	If zeile = NAK Then Exit Do
		If Right(zeile,1) = NAK Then 
			zeile = Trim(zeile,NAK)
			fertig = 1
		EndIf
   	'pruef=team_header(k,0) : m = Len(pruef)
   	If chkheader(zeile,"team",k,m,hd)>0 Then 
   		puffer =  Trim(LTrim(zeile,team_header(k,hd)))
    		Teamtab(k,i)=puffer
    		'Print j;Tab(5);i;Tab(10);k;Tab(15);quote(teamtab(k,i))
   		n=k
   		If k<max Then k=k+1
   	Else
   		Teamtab(n,i)=Teamtab(n,i) + LF + Trim(zeile)
   	EndIf	
   	If fertig > 0 Then Exit Do
   Loop 	
   'GetKey

	'Prfen, ob alle teamheader benutzt wurden
	pruef = LCase(teamtab(1,i))
	If pruef<>"" And pruef<>"none" Then
		For k=4 To max
		'If team=1 Then Print quote(team_header(k,0));Tab(40);te_header(k)
			If te_header(k)=0 Then
				Print #f3,">>> team " & team & " header not used: " & k & Space(5-len(str(k))) & quote(team_header(k,0))
				'error_print("team " & team & " header not used: " & k & Space(5-len(str(k))) & quote(team_header(k,0)),ylw)
				errorcount +=1
			'halt=1
			EndIf
		Next
	EndIf

End Sub
Sub GetDriverData (gpdrivernum As Integer)

Dim DriverLabel(1 To 22) As String => {"696 "+NAK,"697 "+NAK,"698 "+NAK,"699 "+NAK,"701 "+NAK,"702 "+NAK,_
"704 "+NAK,"705 "+NAK,"706 "+NAK,"708 "+NAK,"709 "+NAK,"712 "+NAK,"713 "+NAK,"716 "+NAK,"719 "+NAK,_
"1135 "+NAK,"1136 "+NAK,"1137 "+NAK,"1138 "+NAK,"1272 "+NAK,"1451 "+NAK,"1477 "+ NAK}
Dim As Integer i,j,k,l,n,m,hd,max,fertig,halt, driver
Dim As String pruef, puffer
ReDim dr_header(UBound(dr_header)) 'alle auf 0 setzen

max = UBound(driver_header)':Print "max =";max
j=gpdrivernum : i=GPDriverInfo(j) : driver=i 
Do While Not Eof(f1)
	zeile = UTF2Str(f1)':Print quote(zeile),
	If Eof(f1) Then 
		Print #f3,">>> Driverlabel ";Driverlabel(j);" not found - EOF"
		error_print ("Driverlabel "+quote(Driverlabel(j))+" not found - EOF",red):Sleep:End
	EndIf
	l=Len(Driverlabel(j))
	If Left(zeile,l)=Driverlabel(j) Then
		Driver_Label(j)=Driverlabel(j) 'Label global fr Ausgabe in Liste
		'Print quote(driverlabel(j)):GetKey
		If Driverlabel(j)="719 "+NAK Then 
			TextOut(outfile(8),"",1,"1130 "+NAK,0)
		Else
			m=InStr(zeile,":")
			If m>0 Then Driverteam(j) = Trim(Mid(zeile,m+1))
			'Print j;Tab(5);i;Tab(10);driverlabel(j);Tab(20);quote(driverteam(j))';Tab(40);drivertab(2,i)
			Print #f3, j;Tab(5);i;Tab(10);driverlabel(j);Tab(20);quote(driverteam(j))';Tab(40);drivertab(2,j)
		EndIf
		Exit Do
	EndIf
Loop
'Print j,i, zeile, Driverlabel(j)
If Driverlabel(j)="719 "+NAK Then
	Driverlabel(j)="1130 "+NAK
	m=InStr(zeile,":")
	If m>0 Then Driverteam(j) = Trim(Mid(zeile,m+1))
	'Print j;Tab(5);i;Tab(10);driverlabel(j);Tab(20);quote(driverteam(j))';Tab(40);drivertab(2,i)
	Print #f3, j;Tab(5);i;Tab(10);driverlabel(j);Tab(20);quote(driverteam(j))';Tab(40);drivertab(2,j)
EndIf

k=3
Do 
  	zeile = UTF2Str(f1)':Print quote(zeile):getkey
  	if Eof(f1) Then 
  		Print #f3,">>> Driver-Header ";quote(driver_header(k,0));" not found - EOF"
  		error_print ("Driver-Header "+quote(driver_header(k,0))+" not found - EOF",red)
  		Sleep:End
  	EndIf
  	If Trim(zeile)="" Then Continue Do
  	If zeile = NAK Then Exit Do
	If Right(zeile,1) = NAK Then 
		zeile = Trim(zeile,NAK)
		fertig = 1
	EndIf
 '	pruef=driver_header(k,0) : m = Len(pruef)
  	
  	If chkheader(zeile,"driver",k,m,hd)>0 Then
  		puffer =  Trim(LTrim(zeile,driver_header(k,hd)))
		Drivertab(k,i) = puffer
		'Print j;Tab(5);i;Tab(10);quote(driver_header(k,0));Tab(40);quote(puffer);Tab(65);quote(drivertab(1,i)):getkey
  		'Print j;i;k;Tab(10);quote(zeile);Tab(45);"pruef = ";quote(pruef);Tab(85);quote(Drivertab(k,j)):getkey
  		n=k 'Index festhalten fr Folge-Zeilen zum gleichen Header
  		If k< max Then k=k+1
  	Else
  		'Print "keine headerzeile: ";quote(zeile)
  		Drivertab(n,i)=Drivertab(n,i) + Lf + Trim(zeile)
  		'Print "k, Zeile:";k;quote(zeile);
  		'Print " pruef = ";quote(pruef)
  		'Print " Tab   = ";quote(Drivertab(k,j))
  	EndIf	
  	If fertig > 0 Then Exit Do
Loop 	

'Prfen, ob alle driverheader benutzt wurden
If drivertab(1,i)<>"none" Then
	For k=3 To max-1 'letzter header "driver replace" wird nicht geprft
		If dr_header(k)=0 Then
			Print #f3,">>> driver " & driver & " header not used: " & k & Space(5-len(str(k))) & quote(driver_header(k,0))
			'error_print("driver " & driver & " header not used: " & k & Space(5-len(str(k))) & quote(driver_header(k,0)),ylw)
			errorcount +=1
			'halt=1
		EndIf
	Next
EndIf

'Print "Exit:";quote(zeile):getkey
End Sub

Sub GetLinkdata

Dim Link (1 To 51) As String
Dim As String Firstlabel, pruef, pruef2,drivername,teamname,country
Dim As Integer i,k,l,la,le,max,l1,l2,li1,li2
Dim Driverlink(1 To 23) As Integer => {3,4,1,2,12,17,5,8,7,11,15,18,13,9,0,6,16,14,19,10,21,20,22}
'Teamlink (1 to 11) = GPTeam: {2,1,6,9,3,4,11,8,7,10,5}
Dim Tracklink(1 To 17) As Integer => {1,3,4,5,9,7,8,10,6,12,13,14,15,16,17,2,11}

Const alink = "<LINK>"
Const elink = "<\LINK>"
Const maxlinks=51 '=23+11+17

Firstlabel = "540 "+NAK
Do While Not Eof(f1)
	If Left(zeile,5)=Firstlabel Then Exit Do
	zeile = UTF2Str(f1)':Print quote(zeile):getkey
	If Eof(f1) Then 
		Print #f3,">>> Linklabel ";Firstlabel;" not found - EOF"
		error_print("Linklabel " + Firstlabel + " not found - EOF",red):Sleep:End
	EndIf
Loop	

'Print "Linkdata driver, teams, tracks"':GetKey
Print #f3,"Linknum, linktype, typenum, number, data, input:"

For k=1 To maxlinks 
  	zeile = UTF2Str(f1)
  	la=InStr(zeile,">")
  	le=InStrRev(zeile,"<")
	Link(k)=mid(zeile,la+1,le-la-1)
	'If k=1 Then Print quote(zeile):Print la,le,quote(link(k))
	
	If k<=23 Then 
		i=Driverlink(k)
		'Print "driver" & i;Tab(15);quote(drivertab(1,i));Tab(40);"Link=" &k & quote(Link(k))
		'Print tab(40);quote(zeile)
		Print #f3,k;Tab(5);"driver";Tab(15);k;Tab(20);i;Tab(25);Link(k);Tab(50);quote(zeile)
		'Eintrag 15 in driver links wird nicht benutzt
		'Link driver in Tabelle bernehmen, falls er in entspr. Zelle von drivertab vorkommt. 
		If k<>15 Then
			If ignore_linkdata = "0" Then
				Drivertab(1,i)=Link(k) 
			Else
				drivername=Trim(LCase(Drivertab(1,i)))
				pruef=LCase(Trim(link(k)))
				If drivername<>"" And drivername<>"none" Then
					If drivername <> pruef Then
						'Print k;Tab(5);i;Tab(10);"driver=";quote(drivertab(1,i));Tab(40);"driverlink=";quote(link(k))
						Print #f3,">>> " & quote(link(k)) & " <> " & quote(drivertab(1,i)) & ", link data ignored."
						errorcount +=1
					EndIf
				EndIf
			EndIf
		EndIf
	EndIf
	
	If k>23 And k<=34 Then 
		'Print "team",k,i,Link(k),quote(zeile)
		n=k-23
		i=GP_Team(n)
		Print #f3,k;Tab(5);"team",Tab(15);n;Tab(20);i;Tab(25);Link(k);Tab(50);quote(zeile)
		If ignore_linkdata = "0" Then
			Teamtab(2,i)=LCase(Link(k))
		Else
			teamname=Trim(LCase(teamtab(2,i)))
			pruef=LCase(Trim(link(k)))
			If teamname<>"" And teamname<>"none" Then
				If InStr(teamname,pruef)=0 Then
					'Print k;Tab(5);i;Tab(10);"team=";quote(teamtab(2,i));Tab(40);"teamlink=";quote(link(k))
					Print #f3,">>> " & quote(link(k)) & " does not belong to " & quote(teamtab(2,i)) & ", link data ignored."
					errorcount +=1
				EndIf
			EndIf
		EndIf
	EndIf
	
	If k>34 And k<=maxlinks Then 
		n=k-34
		'i=GP_Track(Tracklink(n))
		i=Tracklink(n)
		'Print "track",k,i,Link(k),quote(zeile)
		Print #f3,k;Tab(5);"track";Tab(15);n;Tab(20);i;Tab(25);Link(k);Tab(50);quote(zeile)
		If ignore_linkdata = "0" Then
			Tracktab(2,i)=Link(k)
		Else
			country=LCase(Trim(Tracktab(2,i)))
			pruef=LCase(Trim(link(k)))
			If country <> pruef Then
				'Print k;Tab(5);i;Tab(10);"track=";quote(tracktab(2,i));Tab(40);"tracklink=";quote(link(k))
				Print #f3,">>> " & quote(link(k)) & " <> " & quote(tracktab(2,i)) & ", link data ignored."
				errorcount +=1		
			EndIf
		EndIf
		'Print k;Tab(5);"Link=";link(k);Tab(40);"Tracktab=";quote(tracktab(2,i));Tab(70);l1,l2
	EndIf
Next

End Sub
Sub Textout (outfile As String, StartLabel As String,StartOption As Integer, ExitLabel As String,ExitOption As integer)
'Direktausgabe von Zeilen aus gps-Datei in Textdatei outfile - nur bei txtmodus 1
'Startlabel: Marke, bei der die Ausgabe beginn; wenn leer, dann sofort
'StartOption = 1: inclusiv, d.h. die erste Zeile ist schon eingelesen (bei voriger Textausgabe), 0=exclusiv 
'ExitLabel: Marke, bei der die Ausgabe endet
'ExitOption = 1: inclusiv, d.h. die Zeile mit dem ExitLabel gehrt zum Text, 0=exclusiv
Dim As String normaleof
Dim As Integer fertig

'Initialisiere UTF-out Zhler
For i=0 To 7
	utf_outcount(i)=0
Next

If txtmodus > 0 Then
	If outfile = "" Then
		Print #f3,">>> Empty text file name "+quote(outfile)
		error_print("Empty text file name "+quote(outfile),red)
		GoTo subend
	EndIf
	f2=FreeFile
	Select Case OPEN (outfile For Binary As #f2)
		CASE 0
			' ok
		Case 2
			' not found: wird erstellt
		Case Else
			Print #f3,">>> Error when opening text file "+outfile
			error_print("Error when opening text file "+outfile,red)
			Close #f2
			errorcount +=1
			GoTo subend
	END Select
	Put #f2,,bom 'die ersten beiden Zeichen (Unicode-Kennung)
	'Print Hex(bom,4)
EndIf	
	
If StartLabel<>"" Then
	'Print "StartLabel=" & quote(Startlabel) 
	Do While Not(Eof(f1))
		zeile = UTF2Str(f1)
		'Print quote(zeile):getkey
		If Eof(f1) Then 
			Print #f3,">>> Startlabel "+Startlabel+" not found - EOF"
			error_print("Startlabel "+Startlabel+" not found - EOF",red):Sleep:End
		EndIf
		If Left(zeile,Len(StartLabel))=StartLabel Then Exit Do 'vor bis Startlabel
	Loop
EndIf
	
If txtmodus >0 Then
	If StartOption = 1 Then Str2UTF(zeile,f2,"CrLf") 'die erste Zeile ist schon eingelesen worden
EndIf

Do While Not(Eof(f1))
	zeile = UTF2Str(f1)
	'Print zeile:getkey
	If Eof(f1) Then 
		If ExitLabel="2125 "+NAK Then  
			normaleof = "Normal EOF"
		Else
			Print #f3,">>> Exitlabel "+Exitlabel+" not found - EOF"
			error_print("Exitlabel "+Exitlabel+" not found - EOF",red):Sleep:End
		EndIf
	EndIf
	'Print quote(Left(zeile,Len(exitlabel))),quote(exitlabel):getkey
	If Left(zeile,Len(ExitLabel))=ExitLabel Then 
		If txtmodus > 0 Then If Exitoption = 1 Then Str2UTF(zeile,f2,"CrLf")
		Exit Do	
	EndIf
	If txtmodus > 0 Then Str2UTF(zeile,f2,"CrLf")
Loop

If txtmodus > 0 Then 
	Close #f2
	'Print"Text file ";quote(outfile); " created."
	Print #f3,"Text file ";quote(outfile); " created."
	txt_count+=1
EndIf
If normaleof <>"" Then 
	'Print normaleof
	Print #f3,normaleof
EndIf

If log_extended = "1" Then utf_out
	
subend:	  	
End Sub

Sub chktext(txtfile As String)
	'prft auf CRLF am Ende in UTF-16 Textdatei
Dim As Integer f4,anzahl,hi,low,test,pruef=13*4096+16*10
Dim As Byte x
Dim As UShort xcr,xlf

If Not FileExists(txtfile) Then
	print #f3,">>> Text file not found " + quote(txtfile)
	If txtfile = trackinfo_trans Then
		error_print ("Text file not found " + quote(txtfile),ylw)
	Else
		error_print ("Text file not found " + quote(txtfile),red)
		errorcount +=1
	EndIf
	'GetKey
	Exit Sub		
EndIf

check:
'Print "checking ";quote(txtfile)
	f4 = FreeFile
	Open txtfile For Binary As #f4
	
	anzahl = Lof(f4)
	'Print quote(txtfile),anzahl;" Bytes"
	Get #f4,anzahl-3,xcr
	Get #f4,,xlf
	'hi=HiByte(xcr):low=LoByte(xcr)
	'Print xcr, hi;" / ";low
	'hi=HiByte(xlf):low=LoByte(xlf)
	'Print xlf, hi;" / ";low
	test=xcr*4096 + 16*xlf':Print (test = pruef)
Close #f4	

If Not(test = pruef) Then
	print #f3,">>> " + quote(txtfile) + " no CRLF at end of file"
	error_print (quote(txtfile)+ " no CRLF at end of file",red)
	Print "--- Critical text file error found. Press any key to break ---"	
	Close #f1
	GetKey:End
EndIf

End Sub
Function chkvalue (ByVal value As String, allowed As String) As Integer
' prft erlaubte Werte	
Dim As Integer i, l, result

l=Len(allowed)
For i=1 To l
	If value=Mid(allowed,i,1) Then 
		result=1
		Exit For
	EndIf
Next

Return result
End Function


Function chkpath(ByVal path As String) As Integer
' prft Verzeichnis	
Dim result As Integer

result = 1+ ChDir(path)
'Print "Path ";quote(path);result

Return result
End Function

Function chkheader(ByVal zeile As String, ByVal typ As String, ByVal index As Integer, ByRef chklen As Integer, ByRef headerdim As Integer) As Integer
' prft, ob zeile header enthlt
' gibt die Lnge (chklen) des gefundenen Headers und die Dimension (headerdim) der Header-Variante zurck 

Dim As Integer i, result, m1
Dim As String header(0 To header_dim),hpruef(0 To header_dim), puffer
'Print typ,"header_dim = ";header_dim, "index = ";index

Select Case typ
	Case "driver"
		For i=0 To header_dim
			header(i)=driver_header(index,i)
		Next
	Case "team"
		For i=0 To header_dim
			header(i)=team_header(index,i)
		Next
	Case "track"
		For i=0 To header_dim
			header(i)=track_header(index,i)
		Next
	Case Else
		chklen=0
		Return result
End Select

i=0
Do While i<=header_dim
	hpruef(i) = LCase(Trim(header(i))) 
	m1 = Len(hpruef(i)) 
	puffer = LCase(Left(Trim(zeile),m1))
	If hpruef(i)="" Then Exit Do
	'Print "zeile = ";quote(zeile)
	'Print "pruef =";quote(hpruef(i)),i;Tab(50);"puffer=";quote(puffer)':getkey
	If hpruef(i) = puffer Then
		chklen = m1 'Rckgabewert
		headerdim = i 'Rckgabewert
		result = 1
		If typ = "driver" Then dr_header(index)=result
		If typ = "team" Then te_header(index)=result
		If typ = "track" Then tr_header(index)=result
		'Print "chkheader ";i,quote(zeile);" hpruef(i)=";quote(hpruef(i));" Len=";chklen," result=";result:GetKey
		Exit Do
	EndIf
	i+=1
Loop

'If typ="track" And Left(zeile,4)="1980" Then Print typ;" chkheader ";quote(zeile);Tab(50);"result=";result;Tab(60);"Len=";chklen:getkey
Return result
End Function

Function  InCount(ByVal wordlist As String, ByVal Delimiter As String) As Integer
'Ermittelt die Anzahl der Wrter = 1 + wie oft der Delimiter-String vorkommt im String Wortliste
Dim As Integer x,z,count
z=0:x=1

Do
	x=x+z
	z=InStr(Mid(wordlist,x),delimiter)
	'Print z,Chr(34);Mid(wordlist,x);Chr(34)
	count +=1
Loop While z<>0

'Print Count;"-mal"
Return count
End Function

Function utf2ansi(unicode As Short) As short
	Dim As Integer i,found
	Dim As Short result
	
	If unicode > 255 Then
		'Print quote(Hex(unicode,4))
		For i=0 To 7	
			'Print i,quote(Hex(UTF_ANSI(i,0),4))
			If UTF_ANSI(i,0)=unicode Then
				result = UTF_ANSI(i,1)
				'Print "Result=";Hex(unicode,4),i,Hex(result,4)
				UTF_incount(i)+=1 'zhlen
				found=1
				Return result
			EndIf
		Next
		If found=0 Then 
			'error_print ("UTF2ANSI failed: " + quote(Hex(unicode,4)),ylw)
			Print #f3,">>> UTF2ANSI failed: ";quote(Hex(unicode,4))
		EndIf
	Else
		result = unicode
	EndIf

Return result	
End Function

Function ansi2utf(ansicode As short) As Short
	Dim As Integer i,k
	Dim As short result
	
	result=ansicode
	For i=0 To 7
		If UTF_ANSI(i,1)=ansicode Then
			result = UTF_ANSI(i,2)':Print Hex(result,4),
			'Print quote(Hex(ansicode,2));" ==> ";quote(Hex(result,4))':GetKey
			If result>255 Then UTF_outcount(i)+=1 'zhlen
			Return result
		EndIf
	Next
	
Return result
End Function

Sub Str2UTF(zkette As string, f As Integer,zende As String)
'extmode, dann
'ansi-String byteweise als Unicode-Zeichen ausgeben
'==== geht leider nicht bei Ausgabe in UTF-16 encoded Datei
'==== weil hier die einzelnen Bytes mit Nullen ergnzt werden
'nicht extmode, dann normal mit print #f1
Dim As Integer i,l,ansibyte
Dim As UShort xx

 
	'If zkette = "essage"+NAK Then
	'		Print quote(zkette):getkey	
	'EndIf

	l=Len(zkette)
	i=1
	Do Until i>l
		ansibyte = Asc(Mid(zkette,i,1))
		xx = ansi2utf(ansibyte)
		'If zkette = "2125 "+NAK+"abandon season"+NAK then
			'Print Mid(zkette,i,1),ansibyte,Hex(xx,4):getkey	
		'EndIf
		Put #f,,xx
		i+=1
	Loop
	If zende = "CrLf" Then Put #f,,wCrLf

End Sub

Function UTF2Str(f As Integer) As String

Dim As String result
Dim As UShort xx, ansicode

Do While Not Eof(f) 
	Get #f,,xx
	If xx = wCr Then 
		Get #f,,xx 'LF holen
		Exit Do
	EndIf
	ansicode = utf2ansi(xx)
	result=result+Chr(ansicode)
	'Print Hex(xx,4),result:GetKey
Loop
'Print quote(result):getkey
Return result
End Function

Function chkgear(gearword As String) As Integer
Dim As Integer i,gearfound
'prft in cornerdata, ob in der aktuellen Zeile ein Gang angegeben ist

If gps_lng <> 4 Then
	If InStr(gearword,Trim(gear_word(gps_lng)))>0 Then gearfound=1
	'Print quote(gearword),gps_lng,quote(gear_word(gps_lng)),InStr(gearword,Trim(gear_word(gps_lng)))
Else
	For i=1 To 9
		If InStr(gearword,it_gear(i))>0 Then 
			gearfound = 1
			Exit For
		EndIf
	Next
EndIf
'Print quote(gearword),gps_lng,gear_word(gps_lng),gearfound
Return gearfound
End Function

Function getgear(geardata As String) As String
Dim As String gear
Dim As Integer i

If gps_lng<>4 Then 
	gear=GetDigits(puffer)
Else
	For i=0 To 9
		If it_gear(i)=puffer Then gear=Str(i)
	Next
EndIf

Return gear
End Function

Function extpath(filename As String) As String
Dim As Integer t

	t=InStrRev(filename,"\")
	extpath = Left(filename,t)
	
End Function

Function makedir(curdir_path As String,subfolder As string) As Integer
'erzeugt in curdir_path den Unterordner subfolder bel. Ordnung
'durch sukzessives Generieren des jeweiligen neuen Unterordners 	
Dim As Integer i,imax,debug,result
Dim As String subfolder_part

	imax=InCount(subfolder,"\")
	'debug=-1
	If debug Then Print "imax=";imax

	If ChDir(curdir_path) Then
		If debug Then Print "curdir_path=";quote(curdir_path)
		If MkDir(curdir_path) Then 
			error_print("out_path folder " + quote(curdir_path) + " could not be created",red)
			result = -1
		EndIf
	Else
		For i=1 To imax
			If imax=1 Then 
				subfolder_part = subfolder
			Else
				subfolder_part=SubStr(subfolder,"\",i)
			EndIf				
			If debug Then Print i,"subfolder_part=";quote(subfolder_part)
			If ChDir(subfolder_part) Then
				If MkDir(subfolder_part) Then 
					error_print("subfolder " + quote(subfolder_part) + " could not be created in " + quote(CurDir),red)
					result=-1
					Exit For
				Else
					ChDir (subfolder_part)
					result=1
					If debug Then Print "new curdir=";curdir
				EndIf
			Else
				If debug Then Print "curdir=";CurDir
			EndIf
		Next
	EndIf

Return result
End Function

Sub readspecial(specialfile As String)
	Dim As String zeile
	Dim As Integer i, k, imax
	If specialfile = "" Then GoTo endspecial 'nicht definiert in INI
		
	chktext(specialfile) 'Prft auf CrLf am Ende der UTF-16 Datei
	If Not FileExists(specialfile) Then GoTo endspecial
	
	imax = tag_entries(specialfile)
	'Print "imax=";imax 'Anzahl der Eintrge	
	ReDim unames(imax,4) 'fr Sprachen 0 bis 4
	
	f2=FreeFile
	Select Case OPEN (specialfile For Input Encoding("UTF-16") As #f2)
		CASE 0
			'Print #f3, quote(specialfile);" openend"
		Case 2
			'Print:error_print ("Trackinfo trans text file not found " + quote(specialfile),red)
			'Close #f2
			errors += 1
			GoTo endspecial
		Case Else
			Print #f3, "Error when opening trackinfo trans text file"
			error_print ("Error when opening trackinfo trans text file " + quote(specialfile),red)
			'Close #f2
			errors += 1
			GoTo endspecial
	END Select

	'Einlesen der Daten in arrays
	i=0
	Do While Not(Eof(f2))
		Line Input #f2,zeile
		If Eof(f2) Then Exit Do
		If Left(zeile,1)=";" Then Continue Do 'Kommentarzeile mit ";" berlesen
		If Trim(zeile)="" Then Continue Do 'Leerzeile berlesen
		For k=0 To 4
			unames(i,k) = Trim(SubStr(zeile,"|",k+1))
		Next
		i+=1
		If i>imax Then Exit Do
	Loop

	Close #f2

'Print imax;": unames:":
'For i=0 To imax:Print i;
'	For k=0 to 4
'		Print Tab(15*(k+1));quote(unames(i,k));
'	Next
'	Print
'Next
'GetKey:End

Print "Trackinfo trans names (" & imax & "," & "4)"
Print #f3, "Trackinfo trans names (" & imax & "," & "4)"

endspecial:	
End Sub

Function tag_entries(ByVal txtfile As String) As Integer
Dim As Integer f2,i

	f2=FreeFile
	Select Case OPEN (txtfile For Input Encoding("UTF-16") As #f2)
		CASE 0
			' ok
		Case 2
			'print "file not found " + quote(csvfile)
			'Close #f2
			Return i
		Case Else
			'print "Error when opening file " + quote(csvfile)
			'Close #f2
			Return i
	END Select

	i=0
	Do 
		Line Input #f2,zeile
		If Eof(f2) Then Exit Do
		'Print i,quote(zeile)
		If Trim(zeile)="" Then Continue Do 'leere Zeile berlesen
		If Left(zeile,1)=";" Then Continue Do 'Kommentarzeile berlesen
		i+=1
	Loop

Return i-1
End Function

Function Lnamecase(getname As String) As String
Dim As Integer i,k, imax
Dim As String newname
	
	imax = UBound(unames)
	'Print "imax=";imax
	newname = LCase(getname)
	'Print newname
	If imax>0 Then
		For i=0 To imax
			For k=0 To 4
				'Print i;Tab(5);k;Tab(10);quote(LCase(unames(i,k))):GetKey
				If LCase(getname) = LCase(unames(i,k)) Then
					newname = LCase(unames(i,0)) 'englischen Namen nehmen
					If log_extended ="1" Then
						'nur Kleinschreibung nicht anzeigen
						If LCase(getname) <> newname Then
							'Print i,k,quote(unames(i,k));" => "; quote(newname)':GetKey
							Print #f3, quote(getname);" => "; quote(newname)
						EndIf
					EndIf
					Exit For
				EndIf
			Next
		Next
	EndIf
	'Namen aus Datei trackinfo_trans
	
'Print "newname = ";newname	
Return newname	
End Function

Sub utf_in_summary
Dim As Integer insum

	For i=0 To 7:insum=insum+utf_incount(i):Next
	'Print gps_lng,insum
	If insum <> 0 Then
		Print #f3, "UTF gps input summary:"
		For i=0 To 7
			If UTF_incount(i)>0 Then
				'Print "U+" & Hex(UTF_ANSI(i,0),4);tab(10);chr(utf_ansi(i,1));tab(13);UTF_incount(i);
				Print #f3, "U+" & Hex(UTF_ANSI(i,0),4);tab(10);chr(utf_ansi(i,1));tab(13);UTF_incount(i);
				If UTF_ANSI(i,2) <> UTF_ANSI(i,0) Then 
					'Print tab(19);" => U+" & Hex(UTF_ANSI(i,2),4);tab(31);chr(utf_ansi(i,2));
					Print #f3, Tab(19);" => U+" & Hex(UTF_ANSI(i,2),4);tab(31);chr(utf_ansi(i,2));
				EndIf
				'Print
				Print #f3,
			EndIf
		Next
	EndIf
	   
End Sub

Sub utf_out
	
	For i=0 To 7
		If utf_outcount(i)>0 Then
			'Print "U+" & Hex(UTF_ANSI(i,0),4);tab(10);chr(utf_ansi(i,1));tab(13);UTF_outcount(i)
			Print #f3, "U+" & Hex(UTF_ANSI(i,0),4);Tab(10);Chr(utf_ansi(i,1));tab(13);UTF_outcount(i)
		EndIf
	Next
	
End Sub
